#ifndef ARAZIENDA_H
#define ARAZIENDA_H

#define ARAZIENDA_ADD  0
#define ARAZIENDA_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QLineEdit;
class QTextEdit;
class QLabel;
class QMessageBox;
class QRegExp;

class ARFinestra;
class ARMainMenu;
class ARBarra;
class ARDialogProv;
class ARDialogCAP;
class ARsql;

class ARAzienda : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui,*stampaint,*cercapr,*cercap;
   QLineEdit *nome,*indr,*cap,*citta,*prov,*nazio,*tel,*fax,*cell,*piva;
   QLineEdit *email,*sitoweb;
   
   ARAzienda(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void setAziendaID(QString);
   void setAzione(int);
   bool isAzione(int);
   
  public slots:
   void addAzienda();
   void cercaProvincia();
   void cercaCAP();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   ARDialogProv *provbox;
   ARDialogCAP *capbox;
   QMessageBox *infobox,*warnbox;
   QString aziendaID;
   QLabel *_nome,*_indr,*_cap,*_citta,*_prov,*_nazio,*_tel,*_fax,*_cell,*_piva;
   QLabel *_datiweb,*_email,*_sitoweb;
   QRegExp *reg_email;
   int azione;

   bool checkForm();
   QString quote(QString, bool like = false);   
 };

#endif
