#include <QPushButton>
#include <QGroupBox>
#include <QComboBox>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QHeaderView>
#include <QTableWidget>
#include <QTableWidgetItem>
#include <QMessageBox>
#include <QTextEdit>
#include <QDateEdit>

#include "ARFinestra.h"
#include "ARDialogBolla.h"
#include "ARDialogNumero.h"
#include "ARsql.h"

#include "ARBolla.h"

ARBolla::ARBolla(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	num_col=4;
 	rows_det=10;  // Prima colonna dettagli
 	rows_cam=6;   // Prima colonna campi
 	row_pr_pub=5; // Colonna con prezzo al pubblico
 	dettagli=false;
 	printBollaID="0"; bollaID="0";
  sql      = new ARsql(this);
  old_data = new QDate();
  bollabox = new ARDialogBolla(this);
  numerobox = new ARDialogNumero(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice  = new QGroupBox(tr("Crea nuovo documento di trasporto "),this);
 	esegui   = new QPushButton(QIcon("pic/ddt_add.png"),tr("Inserisci D.D.T."),this);
 	estampa  = new QPushButton(QIcon("pic/ddt_add.png"),tr("Inserisci e stampa D.D.T."),this);
  escludi  = new QPushButton(QIcon("pic/cls.png"),tr(" Escludi articolo"),this);
  escludi->setIconSize(QSize(32,32));
  aggiungi = new QPushButton(QIcon("pic/ddt_add.png"),tr(" Aggiungi articoli"),this);
  aggiungi->setIconSize(QSize(32,32));
 	oggi = new QPushButton(QIcon("pic/calendar.png"),"",this);
  oggi->setGeometry(577,80,24,24);

  _for      = new QLabel(tr("Fornitore per reso"),this);   _for->setGeometry      ( 10,20,120,24);
  listaFor  = new QComboBox(this);                         listaFor->setGeometry  (120,20,430,24);
  _mezzo = new QLabel(tr("A mezzo"),this);                 _mezzo->setGeometry    (560,20, 80,24);
  listaMezzo = new QComboBox(this);                        listaMezzo->setGeometry(610,20,185,24);
  listaMezzo->addItem(tr("Mittente"),QVariant("1"));
  listaMezzo->addItem(tr("Vettore"),QVariant("2"));
  listaMezzo->addItem(tr("Destinatario"),QVariant("3"));
  _indir     = new QLabel(tr("Indirizzo di spedizione"),this);    _indir->setGeometry    ( 10, 50,120, 24);
  listaIndir = new QComboBox(this);                               listaIndir->setGeometry(120, 50,430, 24);
  _vettore   = new QLabel(tr("Vettore"),this);                    _vettore->setGeometry  (560, 50, 80, 24);
  vettore    = new QTableWidget(this);                            vettore->setGeometry   (610, 50,185, 58);
  vettore->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
  vettore->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
  vettore->horizontalHeader()->hide();
  vettore->verticalHeader()->hide();
  vettore->setAlternatingRowColors(true);
  vettore->insertColumn(0);
  vettore->setColumnWidth(0,181);
  _numero    = new QLabel(tr("Documento numero"),this);           _numero->setGeometry   ( 10, 80,120, 24);
  numero     = new QLineEdit("",this);                            numero->setGeometry    (120, 80, 70, 24);
  numero->setReadOnly(true);
  _causale   = new QLabel(tr("Causale"),this);                    _causale->setGeometry  (200, 80, 80, 24);
  causale    = new QLineEdit("",this);                            causale->setGeometry   (250, 80,190, 24);
  _bdata     = new QLabel(tr("Data"),this);                       _bdata->setGeometry    (450, 80, 30, 24);
 	bdata      = new QDateEdit(QDate::currentDate(),cornice);       bdata->setGeometry     (480, 80, 90, 24);
 	bdata->setDisplayFormat("dd-MMM-yyyy");
  _table     = new QLabel(tr("Articoli per il reso"),this);       _table->setGeometry    ( 10,100,120, 24);
 	_aspetto   = new QLabel(tr("Aspetto esteriore dei beni"),this); _aspetto->setGeometry  ( 10,330,120, 24);
  aspetto    = new QLineEdit("",this);                            aspetto->setGeometry   (140,330,260, 24);
 	_colli     = new QLabel(tr("N. colli"),this);                   _colli->setGeometry    (410,330, 80, 24);
  colli      = new QLineEdit("",this);                            colli->setGeometry     (450,330, 70, 24);
 	_peso      = new QLabel(tr("Peso kg."),this);                   _peso->setGeometry     (530,330, 80, 24);
  peso       = new QLineEdit("",this);                            peso->setGeometry      (580,330, 70, 24);
 	_porto     = new QLabel(tr("Porto"),this);                      _porto->setGeometry    (660,330, 80, 24);
  listaPorto = new QComboBox(this);                               listaPorto->setGeometry(693,330,100,24);
  listaPorto->addItem(tr("Franco"),QVariant("1"));
  listaPorto->addItem(tr("Assegnato"),QVariant("2"));
  _note      = new QLabel(tr("Annotazioni"),this);                _note->setGeometry   ( 10,350,120, 24);
  note       = new QTextEdit("",this);                            note->setGeometry    ( 10,370,784, 90);
  causale->setMaxLength(255);
  aspetto->setMaxLength(255);
  colli->setMaxLength(255);
  peso->setMaxLength(255);

  table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,140);
 	table->setColumnWidth(1,150);
 	table->setColumnWidth(2,350);
 	table->setColumnWidth(3,70);
 	table->setHorizontalHeaderLabels(QStringList() << "Codice a barre" << "Articolo" << "Descrizione" << "Quantit");
 	table->setGeometry(10,120,784,200);
 	//hidePrezzo(false);
 	
  //connect(ckcampi,SIGNAL(stateChanged(int)),this,SLOT(hideCampi(int)));
  connect(aggiungi,SIGNAL(clicked()),this,SLOT(addRighe()));
  connect(escludi,SIGNAL(clicked()),this,SLOT(clearRiga()));
  connect(esegui,SIGNAL(clicked()),this,SLOT(addBolla()));
  connect(oggi,SIGNAL(clicked()),this,SLOT(settaOggi()));
 	//connect(listaFor,SIGNAL(activated(int)),this,SLOT(updFornitore(int)));  
 	connect(listaFor,SIGNAL(currentIndexChanged(int)),this,SLOT(updFornitore(int)));  
  connect(bdata,SIGNAL(dateChanged(QDate)),this,SLOT(cambiaAnno(QDate))); // TODO

  yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  infobox->setWindowModality(Qt::WindowModal);
  warnbox->setWindowModality(Qt::WindowModal);
  bollabox->setDestTable(table);
  azione=ARBOLLA_ADD;
  hide();
 }

void ARBolla::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-111);
  table->setGeometry     (10,120,lar-16,alt-354);
  vettore->setGeometry   (610, 50,lar-615,58);
  vettore->setColumnWidth(0,lar-619);
  _aspetto->setGeometry  ( 10,alt-230,120,24);
  aspetto->setGeometry   (140,alt-230,260,24);
 	_colli->setGeometry    (410,alt-230, 80,24);
  colli->setGeometry     (450,alt-230, 70,24);
 	_peso->setGeometry     (530,alt-230, 80,24);
  peso->setGeometry      (580,alt-230, 70,24);
 	_porto->setGeometry    (660,alt-230, 80,24);
  listaPorto->setGeometry(693,alt-230,100,24);
  _note->setGeometry     ( 10,alt-210,120,24);
  note->setGeometry      ( 10,alt-190,lar-275,50);
 	cornice->setGeometry   (2,0,lar-2,alt-111);
 	aggiungi->setGeometry  (lar-261,alt-190,128,50);
 	escludi->setGeometry   (lar-131,alt-190,128,50);
 	estampa->setGeometry   (lar-261,alt-138,150,24);
  esegui->setGeometry    (lar-108,alt-138,105,24);
 }

bool ARBolla::setForm(QString bollaID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM bolle WHERE bollaID='"+bollaID+"'");
  if(rs)
   {
   	QString fornitoreID,indir_resoID,aux;
   	
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    fornitoreID=row[1];  populateFor(fornitoreID);
    indir_resoID=row[2]; populateIndir(indir_resoID);
    causale->setFocus();
 	  causale->setText(row[3]);
 	  aux=row[4];
 	  listaMezzo->setCurrentIndex(aux.toInt()-1);
 	  aspetto->setText(row[5]);
 	  colli->setText(row[6]);
 	  peso->setText(row[7]);
 	  aux=row[8];
 	  listaPorto->setCurrentIndex(aux.toInt()-1);
 	  vettore->setRowCount(0);
    for(int r=0;r<3;r++)
     {
      vettore->insertRow(r); vettore->setRowHeight(r,18);
      vettore->setItem(r,0,inserisciRiga(row[10+r]));
     }
 	  note->setPlainText(row[13]);
 	  bdata->setDate(QDate::fromString(QString(row[14]),"yyyy-MM-dd"));
    numero->setText(row[17]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
  return false;
 }

void ARBolla::settaFormAdd()
 {
 	esegui->setText(tr("Inserisci D.D.T.")); 	
 	esegui->setIcon(QIcon("pic/ddt_add.png"));
 	estampa->setText(tr("Inserisci e stampa D.D.T."));
 	estampa->setIcon(QIcon("pic/ddt_add.png"));
 	cornice->setTitle(tr("Crea nuovo documento di trasporto "));
 	listaFor->setEnabled(true);
  numero->setText(nextNumero(bdata->date().toString("yyyy")));
  old_data->setYMD(bdata->date().year(),1,1);
  QDate st(1752,9,29),en(7999,12,31);
  bdata->setDateRange(st,en);
  if(numero->text()=="1")
   {
    numerobox->clearForm(bdata->date().toString("yyyy"));
    numerobox->exec();
    numero->setText(numerobox->prendiNumero());
   }
 }

void ARBolla::settaFormEdit()
 {
 	esegui->setText(tr("Salva modifiche"));
 	esegui->setIcon(QIcon("pic/floppy.png"));
 	estampa->setText(tr("Salva modifiche e stampa"));
 	estampa->setIcon(QIcon("pic/floppy.png"));
	cornice->setTitle(tr("Visualizza documento di trasporto "));
	listaFor->setEnabled(false);
  old_data->setYMD(bdata->date().year(),1,1);
  QDate st(bdata->date().year(),1,1),en(bdata->date().year(),12,31);
  bdata->setDateRange(st,en);
 	allineaBolle();
 }

void ARBolla::clearForm()
 {
  populateFor("");
  populateIndir("");
  vettore->setRowCount(0);
  for(int r=0;r<3;r++)
   {
    vettore->insertRow(r); vettore->setRowHeight(r,18);
    vettore->setItem(r,0,inserisciRiga(""));
   }
  listaMezzo->setCurrentIndex(0);
 	causale->setFocus();
 	bdata->setDate(QDate::currentDate());
 	causale->clear();
 	aspetto->clear();
 	colli->clear();
 	peso->clear();
 	listaPorto->setCurrentIndex(0);
 	note->clear();
  allineaBolle();
 	table->setRowCount(0);
  numero->clear();
 }

void ARBolla::populateTable(QString bollaID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0;
 	
 	rs=sql->doQueryRS("SELECT articoloID,codice,descrizione FROM articoli WHERE bollaID='"+bollaID+"'ORDER BY descrizione");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
  	  table->insertRow(r); table->setRowHeight(r,18);
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[2]));
   	  table->setItem(r,3,inserisciRiga("1",Qt::AlignRight));
   	  r++;
     }
    mysql_free_result(rs);
   }
  else
   {
   	infobox->setText(tr("Nessun articolo trovato"));
 	  infobox->exec();
   }
 }

bool ARBolla::populateFor(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString aux;
 	
 	listaFor->clear();
 	rs=sql->doQueryRS("SELECT * FROM fornitori ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaFor->addItem(row[1],QVariant(row[0]));
     	aux=row[0]; if(aux==val) v=r;
     	r++;
     }
    mysql_free_result(rs);
   }
  listaFor->setCurrentIndex(v);
  return r;
 }

bool ARBolla::populateIndir(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString fornitoreID,aux;
 	
 	fornitoreID=listaFor->itemData(listaFor->currentIndex()).toString();
 	listaIndir->clear();
 	listaIndir->addItem(tr("Idem"),QVariant(0));
 	rs=sql->doQueryRS("SELECT * FROM indirizzi_reso WHERE fornitoreID='"+fornitoreID+"' ORDER BY indirizzo");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	QString aux;
     	
     	aux=row[2]; if(aux!="") aux=aux+" ";
     	listaIndir->addItem(aux+row[3],QVariant(row[0]));
   	  r++;
     	aux=row[0]; if(aux==val) v=r;
     }
    mysql_free_result(rs);
   }
  listaIndir->setCurrentIndex(v);
  return r;
 }

void ARBolla::hideCampi(int st)
 {
 	if(st==Qt::Unchecked)
 	 {
    table->hideColumn(rows_cam);
	  table->hideColumn(rows_cam+1);
    table->hideColumn(rows_cam+2);
    table->hideColumn(rows_cam+3);
   }
  else
   {
   	table->showColumn(rows_cam);
	  table->showColumn(rows_cam+1);
    table->showColumn(rows_cam+2);
    table->showColumn(rows_cam+3);
   }
 }

QString ARBolla::nextNumero(QString anno)
 {
  MYSQL_RES *rs;
  MYSQL_ROW row;
  QString aux;

  rs=sql->doQueryRS("SELECT MAX(numero)+1 FROM bolle WHERE anno='"+anno+"'");
  if(rs)
   {
    row=mysql_fetch_row(rs);
    aux=row[0]; if(aux=="") aux="1";
    mysql_free_result(rs);
    return aux;
   }
  return "0";
 }

QString ARBolla::nextNumeroPer(QString anno)
 {
  MYSQL_RES *rs;
  MYSQL_ROW row;
  QString aux;

  rs=mainWin->sql->doQueryRSPer("SELECT MAX(numero)+1 FROM bolle WHERE anno='"+anno+"'");
  if(rs)
   {
    row=mysql_fetch_row(rs);
    aux=row[0]; if(aux=="") aux="1";
    mysql_free_result(rs);
    return aux;
   }
  return "0";
 }

bool ARBolla::addBolla()
 {
  QString articoloID,bollaID,stato;
  QString ts_sr,data_sr,ora_sr;
  QString fornitoreID=listaFor->itemData(listaFor->currentIndex()).toString();
  QString indir_resoID=listaIndir->itemData(listaIndir->currentIndex()).toString();
  QString causale=quote(this->causale->text());
  QString mezzo=listaMezzo->itemData(listaMezzo->currentIndex()).toString();
  QString aspetto=quote(this->aspetto->text());
  QString colli=quote(this->colli->text());
  QString peso_kg=quote(this->peso->text());
  QString porto=listaPorto->itemData(listaPorto->currentIndex()).toString();
  QString inizio=""; //quote(this->inizio->text());
  QString vettore1=quote(vettore->item(0,0)->text());
  QString vettore2=quote(vettore->item(1,0)->text());
  QString vettore3=quote(vettore->item(2,0)->text());
  QString note=quote(this->note->toPlainText());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);
  QString data_bolla=bdata->date().toString("yyyy-MM-dd");
  QString numero="0";
  QString anno=bdata->date().toString("yyyy");

  if(isAzione(ARBOLLA_ADD))
   {
    if(!checkForm())
     {
  	  yesnobox->setText(tr("Confermi salvataggio D.D.T.?"));
      if(yesnobox->exec()==QMessageBox::Yes)
       {
        mainWin->sql->doQueryPer("LOCK TABLES bolle WRITE, articoli WRITE");
        numero=nextNumeroPer(anno);
        if(numero!="1")
         {
          if(this->numero->text()!=numero)
           {
            warnbox->setText(tr("Attenzione, il numero del documento\n stato aggiornato a ")+numero);
 	          warnbox->exec();
           }
          this->numero->setText(numero);
         }
        else { numero=this->numero->text(); }
        ts_sr=ts; data_sr=data; ora_sr=ora;
        stato=ARSTATO_RESO;
 	      if(mainWin->sql->doQueryPer("INSERT INTO bolle VALUES(NULL,'"+fornitoreID+"','"+indir_resoID+"','"+causale+"','"+mezzo+"','"+aspetto+"','"+colli+"','"+peso_kg+"','"+porto+"','"+inizio+"','"+vettore1+"','"+vettore2+"','"+vettore3+"','"+note+"','"+data_bolla+"','00:00:00','0','"+numero+"','"+anno+"','"+data+"','"+ora+"','"+ts+"')",true))
 	       {
 	        bollaID=mainWin->sql->prendiLastID();
 	        printBollaID=bollaID;
          for(int r=0;r<table->rowCount();r++)
           {
            articoloID=table->item(r,0)->text();
 	          mainWin->sql->doQueryPer("UPDATE articoli SET bollaID='"+bollaID+"', bolla='1', stato="+stato+", fatturato='0', fatturaID='0', ts_sr='"+ts_sr+"', data_sr='"+data_sr+"', ora_sr='"+ora_sr+"', data_fat='000-00-00', ora_fat='00:00:00', ts_fat='0' WHERE articoloID='"+articoloID+"'");
     	     }
     	    //allineaBolle(1);
     	    infobox->setText(tr("Nuovo D.D.T. inserito"));
   	      infobox->exec();
   	      mainWin->sql->doQueryPer("UNLOCK TABLES");
   	      clearForm();
          this->numero->setText(nextNumero(bdata->date().toString("yyyy")));
   	      return true;
   	     }
   	    mainWin->sql->doQueryPer("UNLOCK TABLES");
       }
     }
   }
  if(isAzione(ARBOLLA_EDIT))
   {
    if(!checkForm())
     {
  	  yesnobox->setText(tr("Confermi modifica D.D.T.?"));
      if(yesnobox->exec()==QMessageBox::Yes)
       {
        ts_sr=ts; data_sr=data; ora_sr=ora;
        stato=ARSTATO_RESO;
        bollaID=this->bollaID;
        printBollaID=bollaID;
 	      if(sql->doQuery("UPDATE bolle SET fornitoreID='"+fornitoreID+"', indir_resoID='"+indir_resoID+"', causale='"+causale+"', mezzo='"+mezzo+"', aspetto='"+aspetto+"', colli='"+colli+"', peso_kg='"+peso_kg+"', porto='"+porto+"', vettore1='"+vettore1+"', vettore2='"+vettore2+"', vettore3='"+vettore3+"', note='"+note+"', data_bolla='"+data_bolla+"' WHERE bollaID='"+bollaID+"'",true))
 	       {
 	       	for(int r=0;r<table->rowCount();r++)
           {
       	    articoloID=table->item(r,0)->text();
 	          sql->doQuery("UPDATE articoli SET bollaID='"+bollaID+"', bolla='1', stato="+stato+", fatturato='0', fatturaID='0', ts_sr='"+ts_sr+"', data_sr='"+data_sr+"', ora_sr='"+ora_sr+"', data_fat='000-00-00', ora_fat='00:00:00', ts_fat='0' WHERE articoloID='"+articoloID+"'");
     	     }
     	    stato=ARSTATO_GIACENZA;
     	    allineaBolle(1);
     	    infobox->setText(tr("D.D.T. modificato e salvato!"));
   	      infobox->exec();
   	      mainWin->visBolle();
   	      return true;
   	     }
   	   }
     }
 	 }
 	return false;
 }

void ARBolla::addRighe()
 {
 	bollabox->setFornitoreID(listaFor->itemData(listaFor->currentIndex()).toString());
 	bollabox->visMagazzino();
 	bollabox->setMsg(listaFor->itemText(listaFor->currentIndex()));
 	bollabox->exec();
 }

void ARBolla::clearRiga()
 {
 	if(table->currentRow()<0)
 	 {
 	  infobox->setText(tr("Nessun articolo selezionato"));
 	  infobox->exec();
 	 }
 	else
 	 {
 	 	QString aux;

 	 	aux=table->item(table->currentRow(),0)->text();
    sql->doQuery("UPDATE articoli SET bolla='0' WHERE articoloID='"+aux+"'");
 	 	table->removeRow(table->currentRow());
 	 }
 }

bool ARBolla::checkForm()
 {
 	if(table->rowCount()==0)
 	 {
 	  infobox->setText(tr("Nessun articolo selezionato"));
 	  infobox->exec();
 	  return true;
 	 }
 	if(quote(this->causale->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il causale"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->aspetto->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire l'aspetto dei beni"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->colli->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire il numero dei colli"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

QTableWidgetItem *ARBolla::inserisciRiga(const char *str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QTableWidgetItem *ARBolla::inserisciRiga(QString str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QString ARBolla::getPrintBollaID() { return printBollaID; }

QString ARBolla::getFornitoreID()
 {
 	return listaFor->itemData(listaFor->currentIndex()).toString();
 }

QString ARBolla::getElemento(int r, int c, QString def)
 {
 	if(table->item(r,c)) return table->item(r,c)->text(); else return def;
 }

QString ARBolla::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARBolla::settaOggi()
 {
 	QDate cd = QDate::currentDate();

 	bdata->setDate(cd);
 }

void ARBolla::setSrcTable(QTableWidget *stb) { srctable=stb; }

void ARBolla::setAzione(int azio) { azione=azio; }

bool ARBolla::isAzione(int azio) { if(azione==azio) return true; else return false; }

void ARBolla::setBollaID(QString id) { bollaID=id; }

void ARBolla::updFornitore(int p)
 {
  allineaBolle();
  table->setRowCount(0);
 	populateIndir("");
 }

void ARBolla::allineaBolle(int save)
 {
 	if(save==0)
 	 {
 	  sql->doQuery("UPDATE articoli SET bolla='1' WHERE bollaID!='0' AND bolla='0'");
 	  sql->doQuery("UPDATE articoli SET bolla='0' WHERE bollaID='0' AND bolla='1'");
 	 }
 	if(save==1)
 	 {
 	 	QString giacenza,reso;
 	 	
 	 	giacenza=ARSTATO_GIACENZA;
 	 	reso=ARSTATO_RESO;
 	  sql->doQuery("UPDATE articoli SET bollaID='0', stato="+giacenza+", bolla='0', data_sr='000-00-00', ora_sr='00:00:00', ts_sr='0', fatturato='0', fatturaID='0', data_fat='0000-00-00', ora_fat='00:00:00', ts_fat='0' WHERE bollaID!='0' AND stato='"+reso+"' AND bolla='0'");
 	 }
 }

void ARBolla::cambiaAnno(QDate d)
 {
  QString old_anno,new_anno,numero;

  old_anno.sprintf("%d",old_data->year());
  new_anno=bdata->date().toString("yyyy");
  old_data->setYMD(d.year(),1,1);
  if(new_anno!=old_anno)
   {
    numero=nextNumero(new_anno);
    if(numero=="1")
     {
      numerobox->clearForm(new_anno);
      if(numerobox->exec()==QDialog::Accepted) this->numero->setText(numerobox->prendiNumero());
     }
    else { this->numero->setText(numero); }
   }
 }
