#ifndef ARBOLLA_H
#define ARBOLLA_H

#define ARBOLLA_ADD  0
#define ARBOLLA_EDIT 1

#include <QWidget>
#include <QDate>

class QPushButton;
class QGroupBox;
class QComboBox;
class QCheckBox;
class QLabel;
class QLineEdit;
class QHeaderView;
class QTableWidget;
class QTableWidgetItem;
class QMessageBox;
class QTextEdit;
class QDateEdit;

class ARFinestra;
class ARDialogBolla;
class ARDialogNumero;
class ARsql;

class ARBolla : public QWidget
 {
  Q_OBJECT

  public:
   bool dettagli;
   QGroupBox *cornice;
   QPushButton *estampa,*esegui,*escludi,*aggiungi,*oggi;
   QComboBox *listaPorto,*listaFor,*listaIndir,*listaMezzo;
   QLineEdit *numero,*causale,*aspetto,*colli,*peso;
   QTableWidget *table,*vettore;
   QTextEdit *note;
   QDateEdit *bdata;
   
   ARBolla(QWidget *parent = 0);
   void settaGeometria(int,int);
   void populateTable(QString);
   bool populateFor(QString);
   bool populateIndir(QString);
   QString getPrintBollaID();
   QString getFornitoreID();
   QString getElemento(int,int,QString def="");
   bool checkForm();
   bool setForm(QString);
   void settaFormAdd();
   void settaFormEdit();
   void clearForm();
   void setSrcTable(QTableWidget *);
   void setAzione(int);
   bool isAzione(int);
   void setBollaID(QString);

  public slots:
   bool addBolla();
   void updFornitore(int);
   void addRighe();
   void clearRiga();
   void settaOggi();
   //void hidePrezzo(bool);
   void hideCampi(int);
   void cambiaAnno(QDate);

  private:
   QString printBollaID,bollaID;
   ARFinestra *mainWin;
   ARDialogBolla *bollabox;
   ARDialogNumero *numerobox;
   QMessageBox *infobox,*warnbox,*yesnobox;
   ARsql *sql;
   QLabel *_for,*_indir,*_numero,*_mezzo,*_vettore,*_causale,*_bdata,*_table,*_note,*_aspetto,*_colli,*_peso,*_porto;
   QCheckBox *ckdata,*ckcampi;
   QTableWidget *srctable;
   QDate *old_data;
   int num_col,rows_det,rows_cam,row_pr_pub,azione;

   QString nextNumero(QString);
   QString nextNumeroPer(QString);
   QString quote(QString, bool like = false);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
   void allineaBolle(int save=0);
 };

#endif
