#ifndef ARCLIENTE_H
#define ARCLIENTE_H

#define ARCLIENTE_ADD  0
#define ARCLIENTE_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QLineEdit;
class QTextEdit;
class QLabel;
class QMessageBox;
class QRegExp;

class ARFinestra;
class ARDialogProv;
class ARDialogCAP;
class ARsql;

class ARCliente : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui,*cercapr,*cercap;
   QLineEdit *nome,*indr,*cap,*citta,*prov,*nazio,*tel,*fax,*cell,*piva,*cf;
   QLineEdit *email,*sitoweb;
   QTextEdit *note;
   
   ARCliente(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void setClienteID(QString);
   void setAzione(int);
   bool isAzione(int);

  public slots:
   void addCliente();
   void cercaProvincia();
   void cercaCAP();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   ARDialogProv *provbox;
   ARDialogCAP *capbox;
   QMessageBox *infobox,*warnbox;
   QString clienteID;
   QLabel *_nome,*_indr,*_cap,*_citta,*_prov,*_nazio,*_tel,*_fax,*_cell,*_piva,*_cf;
   QLabel *_datiweb,*_email,*_sitoweb;
   QLabel *_note;
   QRegExp *reg_email;
   int azione;

   bool checkForm();
   QString quote(QString, bool like = false);   
 };

#endif
