#include <QPushButton>
#include <QLabel>
#include <QString>
#include <QFile>
#include <QDir>
#include <QProgressBar>
#include <QProcess>
#include <QMessageBox>

#include "ARsql.h"

#include "ARDialogBackup.h"

ARDialogBackup::ARDialogBackup(QWidget *parent) : QDialog(parent)
 {
  sql = new ARsql(this);
  setWindowTitle(tr("Copia di sicurezza"));
  infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  _msg1 = new QLabel(tr("Copia di sicurezza dei dati"),this);
  _msg1->setGeometry (10,10,200,24);
  _msg2 = new QLabel(tr("Copia in corso"),this);
  _msg2->setGeometry (10,40,200,24);
  _msg2->setVisible(false);
  progresso  = new QProgressBar(this);
  progresso->setGeometry(10,60,206,20);
  progresso->setVisible(false);
  progresso->setValue(0);
 	
  backup = new QPushButton(QIcon("pic/backup.png"),tr("Crea copia"),this);
  backup->setGeometry(10,220,96,30);
  annulla = new QPushButton(QIcon("pic/exit.png"),tr("Chiudi"),this);
  annulla->setGeometry(120,220,96,30);
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(backup,SIGNAL(clicked()),this,SLOT(faiBackup()));

  infobox->setWindowModality(Qt::WindowModal);
  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(200,200,450,260);
 }

void ARDialogBackup::faiBackup()
 {
  int num,tot,n;
  QFile fd;
  QDir mysql_path,data_path,db_path,back_path;
  QString _mysql_path,_data_path,_db_path,_back_path,backfilename;
  QStringList list;
  QProcess dump;
  QString sep = QDir::separator();

  _msg2->setVisible(true);
  progresso->setVisible(true);
  progresso->setValue(0);
  repaint();

  _mysql_path  = sql->getPref(3,"pref_varie");
  _data_path   = sql->getPref(4,"pref_varie");
  _db_path     = sql->getPref(5,"pref_varie");
  _back_path   = sql->getPref(6,"pref_varie");
  backfilename = "bak_"+sql->data(sql->timeStamp());
  
  if(!back_path.cd(_back_path)) { back_path.mkdir(_back_path); back_path.cd(_back_path); }
  back_path.mkdir(backfilename);
  back_path.mkdir(backfilename+"/"+sql->getDbName());
  db_path.cd(_db_path);
  data_path.cd(_data_path);

  // Dump
  progresso->setValue(10);
  // dump.startDetached("c:/mysql/bin/mysqldump --host="+sql->getServerAddr()+" --port="+sql->getServerPort()+" --user="+sql->getUserLog()+" --password="+sql->getUserPwd()+" "+sql->getDbName()+" > "+_backdir+"/backup.sql"); // Backup con dump
  dump.execute("\""+_mysql_path+"/bin/mysqldump\" --host="+sql->getServerAddr()+" --port="+sql->getServerPort()+" --user="+sql->getUserLog()+" --password="+sql->getUserPwd()+" --result-file=\""+_back_path+"/"+backfilename+".sql\" "+sql->getDbName()); // Backup con dump
  // mysql     --host=HOST --port=PORT --user=USER --password=PWD db < pathfile.sql // Restore da dump

  // Copia dei file (solo se si ha accesso diretto ai file)
  n=0;
  list=db_path.entryList(); num=list.count()-1; list=data_path.entryList(); tot=num+list.count()-1;

  list=data_path.entryList();
  num=list.count()-1;
  for(int i=0;i<=num;i++)
   {
    fd.setFileName(_data_path+"/"+list.at(i));
    fd.open(QIODevice::ReadOnly);
    fd.copy(_back_path+"/"+backfilename+"/"+list.at(i));
    fd.close();
    progresso->setValue((int)(((float)i/(float)num)*50));
    n++;
   }
  progresso->setValue(0);
  list=db_path.entryList();
  num=list.count()-1;
  for(int i=0;i<=num;i++)
   {
    fd.setFileName(_db_path+"/"+list.at(i));
    fd.open(QIODevice::ReadOnly);
    fd.copy(_back_path+"/"+backfilename+"/"+sql->getDbName()+"/"+list.at(i));
    fd.close();
    progresso->setValue((int)(((float)n/(float)num)*100));
    n++;
   }
  infobox->setText(tr("Copia di sicurezza dei dati completata!"));
  infobox->exec();
  progresso->setVisible(false);
  _msg2->setVisible(false);
 }
