#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QLabel>
#include <QString>
#include <QMessageBox>
#include <QProgressBar>

#include "ARsql.h"

#include "ARDialogEditAll.h"

ARDialogEditAll::ARDialogEditAll(QWidget *parent) : QDialog(parent)
 {
 	sql = new ARsql(this);
 	setWindowTitle(tr("Modifica articoli"));
 	yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  _art        = new QLabel(tr("Articolo"),this);           _art->setGeometry       ( 35,  5, 80, 24);
  art         = new QLineEdit("",this);                    art->setGeometry        (  8, 30, 80, 24);
  _descr      = new QLabel(tr("Descrizione"),this);        _descr->setGeometry     (127,  5,140, 24);
  descr       = new QLineEdit("",this);                    descr->setGeometry      (100, 30,140, 24);
  _prezzo_pub = new QLabel(tr("Prezzo al pubblico"),this); _prezzo_pub->setGeometry(277,  5,120, 24);
  prezzo_pub  = new QLineEdit("",this);                    prezzo_pub->setGeometry (250, 30,120, 24);
  _sconto     = new QLabel(tr("Sconto (%)"),this);         _sconto->setGeometry    (407,  5, 80, 24);
  sconto      = new QLineEdit("",this);                    sconto->setGeometry     (380, 30, 80, 24);
  _prezzo     = new QLabel(tr("Prezzo d'acquisto"),this);  _prezzo->setGeometry    (497,  5,120, 24);
  prezzo      = new QLineEdit("",this);                    prezzo->setGeometry     (470, 30,120, 24);
  _iva        = new QLabel(tr("IVA (%)"),this);            _iva->setGeometry       (627,  5, 70, 24);
  iva         = new QLineEdit("",this);                    iva->setGeometry        (600, 30, 70, 24);
  _for        = new QLabel(tr("Fornitore"),this);          _for->setGeometry       ( 35, 65, 80, 24);
  listaFor    = new QComboBox(this);                       listaFor->setGeometry   (100, 65,570, 24);
  
  art->setMaxLength(255);
  descr->setMaxLength(255);
  prezzo_pub->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo_pub));
  prezzo->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo));
  sconto->setValidator(new QDoubleValidator(-9999.0,9999.0,2,sconto));
  iva->setMaxLength(3);
  iva->setValidator(new QIntValidator(0,100,iva));

  dummy = new QPushButton(tr(""),this); dummy->setGeometry(0,0,0,0);
 	agg_art = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_art->setGeometry(  8, 5,24,24);
 	agg_des = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_des->setGeometry(100, 5,24,24);
 	agg_prp = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_prp->setGeometry(250, 5,24,24);
 	agg_sco = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_sco->setGeometry(380, 5,24,24);
 	agg_pre = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_pre->setGeometry(470, 5,24,24);
 	agg_iva = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_iva->setGeometry(600, 5,24,24);
 	agg_for = new QPushButton(QIcon("pic/upd.png"),tr(""),this); agg_for->setGeometry(  8,65,24,24);
 	aggiorna = new QPushButton(QIcon("pic/upd.png"),tr("Aggiorna tutti"),this); aggiorna->setGeometry(8,100,96,30);
 	annulla  = new QPushButton(QIcon("pic/exit.png"),tr("Chiudi"),this); annulla->setGeometry (118,100,96,30);
 	_msg      = new QLabel(tr("Aggiornamento in corso"),this); _msg->setGeometry(220,106,120,24);
 	_msg->setVisible(false);
  progresso = new QProgressBar(this); progresso->setGeometry(340,106,250,19);
  progresso->setValue(0);
  progresso->setVisible(false);

  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
   
  yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	
  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(110,160,676,140);
 }

void ARDialogEditAll::settaValori(QString art, QString descr, QString prezzo_pub, QString prezzo, QString iva, QString sconto,QString forID, bool dett)
 {
 	populateFor();
 	this->art->setText(art);
 	this->descr->setText(descr);
 	this->prezzo_pub->setText(prezzo_pub);
 	this->prezzo->setText(prezzo);
 	this->iva->setText(iva);
 	this->sconto->setText(sconto);	
 	this->art->setFocus();
 	this->listaFor->setCurrentIndex(this->listaFor->findData(QVariant(forID)));	
 	if(!dett)
 	 {
 	 	this->prezzo->setVisible(false); this->_prezzo->setVisible(false); this->agg_pre->setVisible(false);
 	 	this->iva->setVisible(false);    this->_iva->setVisible(false);    this->agg_iva->setVisible(false);
 	 }
 	else
 	 {
 	 	this->prezzo->setVisible(true); this->_prezzo->setVisible(true); this->agg_pre->setVisible(true);
 	 	this->iva->setVisible(true);    this->_iva->setVisible(true);    this->agg_iva->setVisible(true);
 	 }
 }

void ARDialogEditAll::mostraProgresso(bool b)
 {
 	_msg->setVisible(b);
 	progresso->setVisible(b);
 }

void ARDialogEditAll::settaProgresso(int v) { progresso->setValue(v); }

QString ARDialogEditAll::getArt()       { return quote(art->text()); }

QString ARDialogEditAll::getDescr()     { return quote(descr->text()); }

QString ARDialogEditAll::getPrezzoPub() { return prezzo_pub->text(); }

QString ARDialogEditAll::getPrezzo()    { return prezzo->text(); }

QString ARDialogEditAll::getIva()       { return iva->text(); }

QString ARDialogEditAll::getSconto()    { return sconto->text(); }

QString ARDialogEditAll::getFornitoreID()
 {
 	return listaFor->itemData(listaFor->currentIndex()).toString();
 }

bool ARDialogEditAll::esisteFornitore(QString forID)
 {
 	MYSQL_RES *rs;

 	rs=sql->doQueryRS("SELECT * FROM fornitori WHERE fornitoreID='"+forID+"'");
	if(rs)
 	 {
 	  if(mysql_num_rows(rs)==1) { mysql_free_result(rs); return true; }
 	  else                      { mysql_free_result(rs); return false; }
   }
  return false;
 }

bool ARDialogEditAll::populateFor()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0;
 	
 	listaFor->clear();
 	rs=sql->doQueryRS("SELECT fornitoreID,nome FROM fornitori ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaFor->addItem(row[1],QVariant(row[0]));
   	  r++;
     }
    mysql_free_result(rs);
   }
  return r;
 }

QString ARDialogEditAll::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
