#include <QPushButton>
#include <QGroupBox>
#include <QComboBox>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QHeaderView>
#include <QTableWidget>
#include <QTableWidgetItem>
#include <QMessageBox>
#include <QTextEdit>
#include <QDateEdit>
#include <QDate>

#include "ARFinestra.h"
#include "ARFattura.h"
#include "ARsql.h"

#include "ARDialogFattura.h"

ARDialogFattura::ARDialogFattura(QWidget *parent) : QDialog(parent)
 {
 	setWindowTitle(tr("Aggiungi articoli alla fattura"));
 	mainWin=(ARFinestra *)parent;
 	num_col=14;
 	num_col_dest=7;
 	rows_det=10;  // Prima colonna dettagli
 	rows_cam=6;   // Prima colonna campi
 	row_pr_pub=5; // Colonna con prezzo al pubblico
 	dettagli=false;
 	printBollaID="0"; bollaID="0"; fornitoreID="0";
 	
  sql      = new ARsql(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);

 	add = new QPushButton(QIcon("pic/fatture_add.png"),tr(" Aggiungi tutti"),this);
 	add->setGeometry(600,298,175,34); add->setIconSize(QSize(26,26));
 	addsel = new QPushButton(QIcon("pic/fatture_add.png"),tr(" Aggiungi selezionato"),this);
 	addsel->setGeometry(600,332,175,34); addsel->setIconSize(QSize(26,26));
 	esci = new QPushButton(QIcon("pic/exit.png"),tr(" Chiudi"),this);
 	esci->setGeometry(600,366,175,34); esci->setIconSize(QSize(26,26));

  QPalette pal(this->palette()); pal.setColor(QPalette::Base,QColor(0xff,0xff,0x99));
 	cornice = new QGroupBox(tr("Ricerca articoli da inserire nella fattura "),this);
 	cornice->setGeometry(0,291,598,109);
  _bcode  = new QLabel(tr("<b>Codice a barre</b>"),cornice); _bcode->setGeometry (  0, 15,100, 24);
  bcode   = new QLineEdit("",cornice);                       bcode->setGeometry  ( 98, 15,96, 24);
  bcode->setMaxLength(10); bcode->setPalette(pal);
  _art    = new QLabel(tr("Art."),cornice);                  _art->setGeometry   (228, 45, 80, 24);
  art     = new QLineEdit("",cornice);                       art->setGeometry    (248, 45, 55, 24);
  art->setMaxLength(255);
  _descr  = new QLabel(tr("Descr."),cornice);                _descr->setGeometry (308, 45, 80, 24);
  descr   = new QLineEdit("",cornice);                       descr->setGeometry  (343, 45,250, 24);
  descr->setMaxLength(255);
  _misura = new QLabel(tr("Misura"),cornice);                _misura->setGeometry(  5, 75, 80, 24);
  misura  = new QLineEdit("",cornice);                       misura->setGeometry ( 45, 75, 45, 24);
  misura->setMaxLength(20);
  _prezzo = new QLabel(tr("Prezzo"),cornice);                _prezzo->setGeometry( 95, 75, 80, 24);
  prezzo  = new QLineEdit("",cornice);                       prezzo->setGeometry (135, 75, 70, 24);
  prezzo->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo));
  _mostra = new QLabel(tr("Visualizza"),cornice);            _mostra->setGeometry(  5, 45, 80, 24);
  listaMostra = new QComboBox(cornice);                      listaMostra->setGeometry(60,45,160,24);
  //listaMostra->addItem(tr("Articoli caricati (giacenze)"),QVariant(ARSTATO_GIACENZA));
  listaMostra->addItem(tr("Articoli scaricati (venduti)"),QVariant(ARSTATO_VENDUTO));
  //listaMostra->addItem(tr("Articoli resi (al fornitore)"),QVariant(ARSTATO_RESO));
  QDate cd = QDate::currentDate();
  _from = new QLabel(tr("dal"),cornice); _from->setGeometry(343, 15, 80, 24);
 	from  = new QDateEdit(cd,cornice);     from->setGeometry (365, 15, 90, 24);
 	_to   = new QLabel(tr("al"),cornice);  _to->setGeometry  (462, 15, 80, 24);
 	to    = new QDateEdit(cd,cornice);     to->setGeometry   (479, 15, 90, 24);
 	from->setDisplayFormat("dd-MMM-yyyy");
 	to->setDisplayFormat("dd-MMM-yyyy");
 	ckdata  = new QCheckBox("Disattiva ricerca per data",cornice); ckdata->setGeometry(203,15,150,24);
 	ckcampi = new QCheckBox("Mostra campi",cornice);               ckcampi->setGeometry(210,75,150,24);
 	ckcampi->setCheckState(Qt::Checked);
 	_totali = new QLabel(tr("Totale guadagno: "),cornice); _totali->setGeometry(393,15,260,24);
 	_totali->setHidden(true);
 	dummy = new QPushButton("",cornice); dummy->setGeometry(0,0,0,0);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(402,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(500,83,96,24);
  oggi = new QPushButton(QIcon("pic/calendar.png"),"",cornice);
  oggi->setGeometry(571,15,24,24);
 	//_for      = new QLabel(tr("Fornitore per reso"),this);   _for->setGeometry      ( 10,20,120,24);
  //listaFor  = new QComboBox(this);                         listaFor->setGeometry  (120,20,430,24);
  
  _table = new QLabel(tr("Articoli da inserire nella fattura relativa al cliente:"),this); _table->setGeometry(5,0,300,24);
  _msg   = new QLabel("",this); _msg->setGeometry(230,0,300,24);
  table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,92);
 	table->setColumnWidth(1,60);
 	table->setColumnWidth(2,225);
 	table->setColumnWidth(3,200); // Fornitore
 	table->setColumnWidth(4,50);
 	table->setColumnWidth(5,80);
 	table->setColumnWidth(6,75); // Colore
 	table->setColumnWidth(7,70); // Fondo
 	table->setColumnWidth(8,45); // Tacco
 	table->setColumnWidth(9,80); // Stagione
 	table->setColumnWidth(10,80);
 	table->setColumnWidth(11,30);
 	table->setColumnWidth(12,110);
 	table->setColumnWidth(13,80);
 	table->setHorizontalHeaderLabels(QStringList() << "Codice a barre" << "Articolo" << "Descrizione" << "Fornitore" << "Misura" << "Prezzo" << "Colore" << "Fondo" << "Tacco" << "Stagione" << "Prezzo acq." << "IVA" << "Prezzo acq. ivato" << "Guadagno");
 	table->setGeometry(0,33,775,256);
 	//hidePrezzo(false);

 	connect(search,SIGNAL(clicked()),this,SLOT(visMagazzino()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
  connect(bcode,SIGNAL(returnPressed()),this,SLOT(visMagazzino()));
  connect(art,SIGNAL(returnPressed()),this,SLOT(visMagazzino()));
  connect(descr,SIGNAL(returnPressed()),this,SLOT(visMagazzino()));
  connect(misura,SIGNAL(returnPressed()),this,SLOT(visMagazzino()));
  connect(prezzo,SIGNAL(returnPressed()),this,SLOT(visMagazzino()));
  connect(ckdata,SIGNAL(stateChanged(int)),this,SLOT(visMagazzino(int)));
  connect(ckcampi,SIGNAL(stateChanged(int)),this,SLOT(hideCampi(int)));
  connect(add,SIGNAL(clicked()),this,SLOT(addAll()));
  connect(addsel,SIGNAL(clicked()),this,SLOT(addSelection()));
  connect(oggi,SIGNAL(clicked()),this,SLOT(settaOggi()));
 	//connect(listaMostra,SIGNAL(activated(int)),this,SLOT(visMagazzino(int)));
 	//connect(listaFor,SIGNAL(activated(int)),this,SLOT(visMagazzino(int)));
 	//connect(add,SIGNAL(clicked()),this,SLOT(accept()));
 	connect(esci,SIGNAL(clicked()),this,SLOT(reject()));

  yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  infobox->setWindowModality(Qt::WindowModal);
  warnbox->setWindowModality(Qt::WindowModal);

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(15,120,775,400);
 }
/*
bool ARDialogFattura::populateFor(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString aux;
 	
 	listaFor->clear();
 	rs=sql->doQueryRS("SELECT * FROM fornitori ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaFor->addItem(row[1],QVariant(row[0]));
     	aux=row[0]; if(aux==val) v=r;
     	r++;
     }
    mysql_free_result(rs);
   }
  listaFor->setCurrentIndex(v);
  return r;
 }
*/
void ARDialogFattura::hideCampi(int st)
 {
 	if(st==Qt::Unchecked)
 	 {
    table->hideColumn(rows_cam);
	  table->hideColumn(rows_cam+1);
    table->hideColumn(rows_cam+2);
    table->hideColumn(rows_cam+3);
   }
  else
   {
   	table->showColumn(rows_cam);
	  table->showColumn(rows_cam+1);
    table->showColumn(rows_cam+2);
    table->showColumn(rows_cam+3);
   }
 }

void ARDialogFattura::visMagazzino(int p) {	visMagazzino(); } // Wrapper per evento "cambio listaMostra"

void ARDialogFattura::visMagazzino()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,stato,bcode,art,descr,misura,prezzo,fornitoreID;
 	bool primo;
 	int r;

 	table->setRowCount(0);
 	r=0; primo=true;
 	query="SELECT articoloID,codice,descrizione,fornitori.nome,misura,prezzo_pub,colore,fondo,tacco,stagione,prezzo,iva FROM articoli,fornitori";
 	bcode=quote(this->bcode->text(),true);
 	art=quote(this->art->text(),true);
 	descr=quote(this->descr->text(),true);
 	misura=quote(this->misura->text());
 	prezzo=quote(this->prezzo->text(),true);
 	fornitoreID=this->fornitoreID;
  if(bcode!="")  { if(primo) { query+=" WHERE articoloID='"+bcode+"'"; primo=false; } else { query+=" AND articoloID='"+bcode+"'"; } }
 	if(art!="")    { if(primo) { query+=" WHERE codice LIKE '%"+art+"%'"; primo=false; } else { query+=" AND codice LIKE '%"+art+"%'"; } }
 	if(descr!="")  { if(primo) { query+=" WHERE descrizione LIKE '%"+descr+"%'"; primo=false; } else { query+=" AND descrizione LIKE '%"+descr+"%'"; } }
 	if(misura!="") { if(primo) { query+=" WHERE misura='"+misura+"'"; primo=false; } else { query+=" AND misura='"+misura+"'"; } }
 	if(prezzo!="") { if(primo) { query+=" WHERE prezzo_pub LIKE '%"+prezzo+"%'"; primo=false; } else { query+=" AND prezzo_pub LIKE '%"+prezzo+"%'"; } }
 	//if(fornitoreID!="0") { if(primo) { query+=" WHERE articoli.fornitoreID='"+fornitoreID+"'"; primo=false; } else { query+=" AND articoli.fornitoreID='"+fornitoreID+"'"; } }
 	if(primo) { query+=" WHERE articoli.fornitoreID=fornitori.fornitoreID"; primo=false; } else { query+=" AND articoli.fornitoreID=fornitori.fornitoreID"; }

  stato=listaMostra->itemData(listaMostra->currentIndex()).toString();
 	if(primo) { query+=" WHERE fatturato='0'"; primo=false; } else { query+=" AND fatturato='0'"; }
 	if(primo) { query+=" WHERE stato='"+stato+"'"; primo=false; } else { query+=" AND stato='"+stato+"'"; }
 	if(stato==ARSTATO_VENDUTO)
 	 {
 	 	if(ckdata->checkState()==Qt::Unchecked)
 	   if(primo) { query+=" WHERE (articoli.data_sr >= '"+from->date().toString(Qt::ISODate)+"' AND articoli.data_sr <= '"+to->date().toString(Qt::ISODate)+"')"; primo=false; } else { query+=" AND (articoli.data_sr >= '"+from->date().toString(Qt::ISODate)+"' AND articoli.data_sr <= '"+to->date().toString(Qt::ISODate)+"')"; }
 	  table->hideColumn(rows_det+3); _totali->setHidden(true);
 	 }
 	query+=" ORDER BY articoli.ts";
 	rs=sql->doQueryRS(query);
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);
   	  for(int c=0;c<num_col-2;c++) { if(c!=rows_det && c!=rows_det+1) table->setItem(r,c,inserisciRiga(row[c])); else table->setItem(r,c,inserisciRiga(row[c],Qt::AlignRight)); }
   	  QString aux_iva=row[num_col-3];
   	  QString aux_prezzo=row[num_col-4];
   	  double ivato=aux_prezzo.toDouble()+(aux_prezzo.toDouble()*aux_iva.toDouble()/100);
   	  QString aux; aux.setNum(ivato,'F',2);
   	  table->setItem(r,num_col-2,inserisciRiga(aux,Qt::AlignRight)); // Prezzo ivato
   	  QString aux_prezzo_pub=row[row_pr_pub];
   	  double guad=aux_prezzo_pub.toDouble()-ivato;
   	  aux.setNum(guad,'F',2);
   	  table->setItem(r,num_col-1,inserisciRiga(aux,Qt::AlignRight)); // Guadagno
   	  r++;
     }
    this->bcode->setFocus();
    mysql_free_result(rs);
    if(r==0) 
     {
     	infobox->setText(tr("Nessun articolo trovato!"));
 	    infobox->exec();
     }
   }
  if(stato==ARSTATO_VENDUTO)
   {
 	 	//if(dettagli) { table->showColumn(rows_det+3); _totali->setText(calcGuadagno()); _totali->setHidden(false); }
  	//else         { table->hideColumn(rows_det+3); _totali->setHidden(true); }
   }
 }

QTableWidgetItem *ARDialogFattura::inserisciRiga(const char *str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QTableWidgetItem *ARDialogFattura::inserisciRiga(QString str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

void ARDialogFattura::resRicerca()
 {
 	QDate cd = QDate::currentDate();

 	from->setDate(cd);
 	to->setDate(cd);
 	bcode->clear();
 	art->clear();
 	descr->clear();
 	misura->clear();
 	prezzo->clear();
 	ckdata->setCheckState(Qt::Unchecked);
 	ckcampi->setCheckState(Qt::Checked);
 }

QString ARDialogFattura::getElemento(int r, int c, QString def)
 {
 	if(table->item(r,c)) return table->item(r,c)->text(); else return def;
 }

QString ARDialogFattura::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARDialogFattura::settaOggi()
 {
 	QDate cd = QDate::currentDate();
 	
 	from->setDate(cd);
 	to->setDate(cd);
 	ckdata->setCheckState(Qt::Unchecked);
 }

void ARDialogFattura::addAll()
 {
 	if(table->rowCount()<=0)
 	 {
 	 	infobox->setText(tr("Nessun articolo da inserire"));
 	  infobox->exec();
 	  return;
 	 }
 	else
 	 {
 	 	QString aux;
 	 	int n;

    for(int i=0;i<table->rowCount();i++)
     {
      n=desttable->rowCount();
      desttable->insertRow(n); desttable->setRowHeight(n,18);
 	   	for(int c=0;c<3;c++)
 	 	   {
 	 	 	  aux=table->item(i,c)->text();
        if(c==0) sql->doQuery("UPDATE articoli SET fatturato='1' WHERE articoloID='"+aux+"'"); 
 	 	    desttable->setItem(n,c,inserisciRiga(aux));
	     }
	    desttable->setItem(n,3,inserisciRiga("1",Qt::AlignRight)); // Quantit
	    double qta=desttable->item(n,3)->text().toDouble();
	    aux=table->item(i,5)->text(); // Prezzo al pubblico (unitario)
	    double pre_uni=aux.toDouble();
	    desttable->setItem(n,4,inserisciRiga(aux,Qt::AlignRight));
	    double pre_tot=pre_uni*qta; // Prezzo totale
	    desttable->setItem(n,6,inserisciRiga(aux.sprintf("%.2lf",pre_tot),Qt::AlignRight));
	    aux=table->item(i,11)->text(); // Iva
	    desttable->setItem(n,5,inserisciRiga(aux,Qt::AlignRight));

      for(int j=0;j<num_col_dest;j++) desttable->item(i,j)->setFlags(Qt::ItemIsSelectable);
	   }
   }
 	visMagazzino();
 }

void ARDialogFattura::addSelection()
 {
 	if(table->currentRow()<0)
 	 {
 	 	infobox->setText(tr("Nessun articolo selezionato"));
 	  infobox->exec();
 	  return;
 	 }
 	else
 	 {
 	 	QString aux;
 	 	int n;

    n=desttable->rowCount();
    desttable->insertRow(n); desttable->setRowHeight(n,18);
 	 	for(int c=0;c<3;c++)
 	 	 {
 	 	 	aux=table->item(table->currentRow(),c)->text();
      if(c==0) sql->doQuery("UPDATE articoli SET fatturato='1' WHERE articoloID='"+aux+"'");
 	 	  desttable->setItem(n,c,inserisciRiga(aux));
	   }
	  desttable->setItem(n,3,inserisciRiga("1",Qt::AlignRight)); // Quantit
	  double qta=desttable->item(n,3)->text().toDouble();
	  aux=table->item(table->currentRow(),5)->text(); // Prezzo al pubblico (unitario)
	  double pre_uni=aux.toDouble();
	  desttable->setItem(n,4,inserisciRiga(aux,Qt::AlignRight));
	  double pre_tot=pre_uni*qta; // Prezzo totale
	  desttable->setItem(n,6,inserisciRiga(aux.sprintf("%.2lf",pre_tot),Qt::AlignRight));
	  aux=table->item(table->currentRow(),11)->text(); // Iva
	  desttable->setItem(n,5,inserisciRiga(aux,Qt::AlignRight));
	  	
    for(int j=0;j<num_col_dest;j++) desttable->item(n,j)->setFlags(Qt::ItemIsSelectable);
   }
  visMagazzino();
  padre->calcTotali();
 }

void ARDialogFattura::settaPadre(ARFattura *p) { padre=p; }

void ARDialogFattura::setDestTable(QTableWidget *dtb) { desttable=dtb; }

void ARDialogFattura::setBollaID(QString id) { bollaID=id; }

void ARDialogFattura::setPrintBollaID(QString id) { printBollaID=id; }

void ARDialogFattura::setFornitoreID(QString id) { fornitoreID=id; }

QString ARDialogFattura::getBollaID() { return bollaID; }

QString ARDialogFattura::getPrintBollaID() { return printBollaID; }

QString ARDialogFattura::getFornitoreID() { return fornitoreID; }

void ARDialogFattura::setMsg(QString m) { _msg->setText("<b>"+m+"</b>"); }
