#ifndef ARDIALOGFATTURA_H
#define ARDIALOGFATTURA_H

#include <QDialog>

class QPushButton;
class QGroupBox;
class QComboBox;
class QCheckBox;
class QLabel;
class QLineEdit;
class QHeaderView;
class QTableWidget;
class QTableWidgetItem;
class QMessageBox;
class QTextEdit;
class QDateEdit;
class QDate;

class ARFinestra;
class ARFattura;
class ARsql;

class ARDialogFattura : public QDialog
 {
  Q_OBJECT

  public:
   bool dettagli;
   QGroupBox *cornice;
   QPushButton *dummy,*add,*addsel,*esci,*search,*reset,*oggi;
   QComboBox *listaMostra;//,*listaFor;
   QLineEdit *causale,*aspetto,*colli,*peso;
   QTableWidget *table,*vettore;
   QTextEdit *note;
   QDateEdit *bdata;
   
   ARDialogFattura(QWidget *parent = 0);
   bool populateFor(QString);
   QString getElemento(int,int,QString def="");
   void setDestTable(QTableWidget *);
   QString getBollaID();
   QString getPrintBollaID();
   QString getFornitoreID();
   void setBollaID(QString);
   void setPrintBollaID(QString);
   void setFornitoreID(QString);
   void setMsg(QString);
   void settaPadre(ARFattura *);

  public slots:
   void resRicerca();
   void settaOggi();
   //void hidePrezzo(bool);
   void hideCampi(int);
   void visMagazzino();
   void visMagazzino(int);
   void addAll();
   void addSelection();

  private:
   QString printBollaID,bollaID,fornitoreID;
   ARFinestra *mainWin;
   ARFattura *padre;
   QMessageBox *infobox,*warnbox,*yesnobox;
   ARsql *sql;
   QLabel *_msg,*_table,*_bcode,*_art,*_descr,*_misura,*_prezzo,*_from,*_to,*_mostra,*_totali;//*_for,
   QLineEdit *bcode,*art,*descr,*misura,*prezzo;
   QDateEdit *from,*to;
   QCheckBox *ckdata,*ckcampi;
   QTableWidget *desttable;
   int num_col,num_col_dest,rows_det,rows_cam,row_pr_pub;

   QString quote(QString, bool like = false);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
 };

#endif
