#ifndef ARDIALOGINDIRRESO_H
#define ARDIALOGINDIRRESO_H

#define ARDIALOGINDIRRESO_ADD  0
#define ARDIALOGINDIRRESO_EDIT 1

#include <QDialog>

class QPushButton;
class QLineEdit;
class QComboBox;
class QLabel;
class QString;
class QMessageBox;
class QRegExp;

class ARFinestra;
class ARDialogProv;
class ARDialogCAP;
class ARFornitore;
class ARsql;

class ARDialogIndirReso : public QDialog
 {
  Q_OBJECT

  public:
   QPushButton *esegui,*annulla,*cercapr,*cercap;
   QLineEdit *nome,*indr,*cap,*citta,*prov,*nazio,*tel,*fax,*cell,*email;
   //QComboBox *listaClienti;
   QMessageBox *infobox,*warnbox,*yesnobox;

   ARDialogIndirReso(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void setFornitoreID(QString);
   void setIndirResoID(QString);
   void setAzione(int);
   bool isAzione(int);

  public slots:
   void addIndirReso();
   void cercaProvincia();
   void cercaCAP();

  private:
   ARFinestra *mainWin;
   ARsql *sql;
   ARDialogProv *provbox;
   ARDialogCAP *capbox;
   QString fornitoreID,indir_resoID;
   QLabel *_nome,*_indr,*_cap,*_citta,*_prov,*_nazio,*_tel,*_fax,*_cell,*_email;
   QRegExp *reg_email;
   int azione;
   
   bool checkForm();
   QString quote(QString, bool like = false);
 };

#endif
