#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QLabel>
#include <QString>
#include <QDate>

#include "ARsql.h"
#include "ARFinestra.h"

#include "ARDialogScarica.h"

ARDialogScarica::ARDialogScarica(QWidget *parent) : QDialog(parent)
 {
  QString aux;

  mainWin=(ARFinestra *)parent;
  sql = new ARsql(this);

  aux = "Prezzo di listino ("+mainWin->CURRENCY_NAME+")";
  _prezzo_lis = new QLabel(tr(aux.toAscii()),this);
  _prezzo_lis->setGeometry (10,10,150,24);
   prezzo_lis = new QLineEdit("",this); 
   prezzo_lis->setGeometry (120,10,190,24);
   prezzo_lis->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo_lis));
   prezzo_lis->setEnabled(false);
   
  _sconto = new QLabel(tr("Sconto(%)"),this);
  _sconto->setGeometry (320,40,150,24);
   sconto = new QLineEdit("",this); 
   sconto->setGeometry (380,40,50,24);
   sconto->setValidator(new QDoubleValidator(-9999.0,9999.0,2,sconto));
  
  _prezzo_pub = new QLabel("<b><font color=#ff0000>"+tr("Prezzo di vendita")+"</font></b>",this);
  _prezzo_pub->setGeometry (5,40,140,24);
   prezzo_pub = new QLineEdit("",this); 
   prezzo_pub->setGeometry (120,40,190,24);
   prezzo_pub->setValidator(new QDoubleValidator(-50000000.0,50000000.0,2,prezzo_pub));
  _cliente = new QLabel(tr("Cliente acquirente"),this);
  _cliente->setGeometry (10,70,100,24);
  listaClienti = new QComboBox(this);
  listaClienti->setGeometry(120,70,410,24);
  _info = new QLabel(tr("<b>Informazioni articolo:</b>"),this);
  _info->setGeometry( 5, 100,520,24);
  info = new QLabel("",this);
  info->setGeometry (10, 125,520,100);
 	
 	scarica = new QPushButton(QIcon("pic/scarico.png"),tr("Scarica"),this);
  scarica->setGeometry(10,240,96,30);
 	annulla = new QPushButton(QIcon("pic/exit.png"),tr("Annulla"),this);
  annulla->setGeometry(120,240,96,30);
  connect(prezzo_pub,SIGNAL(editingFinished()),this,SLOT(aggiornaSconto()));
  connect(sconto,SIGNAL(editingFinished()),this,SLOT(aggiornaPrezzo()));
  connect(annulla,SIGNAL(clicked()),this,SLOT(reject()));
  connect(scarica,SIGNAL(clicked()),this,SLOT(accept()));

  setWindowFlags(Qt::Window | Qt::MSWindowsFixedSizeDialogHint | Qt::WindowTitleHint | Qt::WindowSystemMenuHint);
  setGeometry(100,200,540,280);
 }

void ARDialogScarica::settaPrezzo(QString prezzo_lis, QString sconto)
 {
 	this->prezzo_lis->setText(prezzo_lis);
 	this->sconto->setText(sconto);
 	aggiornaPrezzo();
 	prezzo_pub->setFocus(); prezzo_pub->selectAll();
 }

void ARDialogScarica::settaInfo(QString art,QString descr,QString misura,QString articoloID,QString fornitoreID,QString data)
 {
 	QString zeri,fornitore;
 	QDate d = QDate::fromString(data,"yyyy-MM-dd");
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT nome FROM fornitori WHERE fornitoreID='"+fornitoreID+"'"); 	
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) fornitore="SCONOSCIUTO";
    else { row=mysql_fetch_row(rs); fornitore=row[0]; }
    mysql_free_result(rs);
   }
 	for(int i=0;i<10-articoloID.length();i++) zeri+="0";
 	setWindowTitle(tr("Scarica articolo: ")+zeri+articoloID);
 	this->info->setText("- Articolo:<br>&nbsp;&nbsp;&nbsp;<b>("+art+") "+descr+" ["+misura+"]</b><br><br>- Fornitore:<br>&nbsp;&nbsp;&nbsp;<b>"+fornitore+"</b><br><br>L'articolo risulta caricato in magazzino <b>"+d.toString("dddd, dd MMM yyyy")+"</b>");
 }

QString ARDialogScarica::prendiPrezzo() { return prezzo_pub->text(); }

QString ARDialogScarica::prendiSconto() { return sconto->text(); }

void ARDialogScarica::aggiornaPrezzo()
 {
 	QString prezzo_pub;
 	double pr_l,pr_p,sco;
 	
 	pr_l=prezzo_lis->text().toDouble();
 	sco=sconto->text().toDouble();
 	pr_p=pr_l-(pr_l*sco/100);
 	prezzo_pub.sprintf("%.2lf",pr_p);
 	this->prezzo_pub->setText(prezzo_pub);
 }

void ARDialogScarica::aggiornaSconto()
 {
 	QString sconto;
 	double pr_l,pr_p,sco;
 	
 	pr_l=prezzo_lis->text().toDouble();
 	pr_p=prezzo_pub->text().toDouble();
 	sco=100-(pr_p/pr_l*100);
 	sconto.sprintf("%.2lf",sco);
 	this->sconto->setText(sconto);
 }

QString ARDialogScarica::getClienteID()
 {
 	return listaClienti->itemData(listaClienti->currentIndex()).toString();
 }

bool ARDialogScarica::populateCli()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0;
 	
 	listaClienti->clear();
 	listaClienti->addItem(tr("Nessuno in particolare"),QVariant(0));
 	rs=sql->doQueryRS("SELECT clienteID,nome FROM clienti ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaClienti->addItem(row[1],QVariant(row[0]));
   	  r++;
     }
    mysql_free_result(rs);
   }
  return r;
 }
