#include <QPushButton>
#include <QGroupBox>
#include <QComboBox>
#include <QCheckBox>
#include <QLabel>
#include <QLineEdit>
#include <QAction>
#include <QMenu>
#include <QContextMenuEvent>
#include <QHeaderView>
#include <QTableWidget>
#include <QTableWidgetItem>
#include <QMessageBox>
#include <QDateEdit>

#include "ARFinestra.h"
#include "ARDialogFattura.h"
#include "ARDialogServizi.h"
#include "ARDialogNumero.h"
#include "ARsql.h"

#include "ARFattura.h"

ARFattura::ARFattura(QWidget *parent) : QWidget(parent)
 {
  mainWin=(ARFinestra *)parent;
  num_col=7;
  rows_det=10;  // Prima colonna dettagli
  rows_cam=6;   // Prima colonna campi
  row_pr_pub=5; // Colonna con prezzo al pubblico
  dettagli=false;
  printFatturaID="0"; fatturaID="0";
  sql      = new ARsql(this);
  old_data = new QDate();
  fatturabox = new ARDialogFattura(this);
  fatturabox->settaPadre(this);
  servizibox = new ARDialogServizi(this);
  servizibox->settaPadre(this);

  numerobox = new ARDialogNumero(this);
  infobox  = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox  = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice  = new QGroupBox(tr("Crea nuova fattura "),this);
 	aggiorna = new QPushButton(QIcon("pic/upd.png"),tr("Aggiorna totali"),this);
 	stampa   = new QPushButton(QIcon("pic/printer.png"),tr("Stampa fattura"),this);
 	esegui   = new QPushButton(QIcon("pic/fatture_add.png"),tr("Inserisci fattura"),this);
 	estampa  = new QPushButton(QIcon("pic/fatture_add.png"),tr("Inserisci e stampa fattura"),this);
  escludi  = new QPushButton(QIcon("pic/cls.png"),tr(" Escludi articolo"),this);
  escludi->setIconSize(QSize(32,32));
  aggiungi = new QPushButton(QIcon("pic/fatture_add.png"),tr(" Aggiungi articoli"),this);
  aggiungi->setIconSize(QSize(32,32));
 	oggi = new QPushButton(QIcon("pic/calendar.png"),"",this);
  oggi->setGeometry(284,50,24,24);

  _cli       = new QLabel(tr("Cliente"),this);               _cli->setGeometry      ( 10, 20,120,24);
  listaCli   = new QComboBox(this);                          listaCli->setGeometry  (100, 20,430,24);
  _numero    = new QLabel(tr("Documento num."),this);        _numero->setGeometry   ( 10, 50,120, 24);
  numero     = new QLineEdit("",this);                       numero->setGeometry    (100, 50, 50, 24);
  numero->setReadOnly(true);
  _bdata     = new QLabel(tr("Data"),this);                  _bdata->setGeometry    (157, 50, 30, 24);
 	bdata      = new QDateEdit(QDate::currentDate(),cornice);  bdata->setGeometry     (187, 50, 90, 24);
 	bdata->setDisplayFormat("dd-MMM-yyyy");
  _tipologia = new QLabel(tr("Tipologia merce"),this);       _tipologia->setGeometry(315, 50,100, 24);
  tipologia  = new QLineEdit("",this);                       tipologia->setGeometry (400, 50,153, 24);
 	_scontrino = new QLabel(tr("Scontrino num."),this);        _scontrino->setGeometry(563, 50,120, 24);
  scontrino  = new QLineEdit("",this);                       scontrino->setGeometry (643, 50,150, 24);
  _note      = new QLabel(tr("Annotazioni"),this);           _note->setGeometry     ( 10, 80,100, 24);
  note       = new QLineEdit("",this);                       note->setGeometry      (100, 80,693, 24);
  _table     = new QLabel(tr("Articoli da fatturare"),this); _table->setGeometry    ( 10,100,120, 24);
  _totali    = new QLabel(tr("Totali fattura:"),this);        _totali->setGeometry   ( 10,350,120, 24);
  totali     = new QTableWidget(this);                       totali->setGeometry    ( 10,370,784, 90);
  totali->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
  //totali->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
  totali->setEditTriggers(QAbstractItemView::NoEditTriggers);
  totali->setSelectionMode(QAbstractItemView::NoSelection);
  totali->horizontalHeader()->hide();
  totali->verticalHeader()->hide();
  totali->setAlternatingRowColors(true);
  totali->insertColumn(0);
  totali->insertColumn(1);
  totali->setColumnWidth(0,181);
  tipologia->setMaxLength(255);
  scontrino->setMaxLength(255);
  note->setMaxLength(1024);

  table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  //table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,120);
 	table->setColumnWidth(1,150);
 	table->setColumnWidth(2,350);
 	table->setColumnWidth(3,60);
 	table->setColumnWidth(4,100);
 	table->setColumnWidth(5,55);
 	table->setColumnWidth(6,80);
 	table->setHorizontalHeaderLabels(QStringList() << "Codice a barre" << "Articolo" << "Descrizione" << "Quantit" << "Prezzo unitario" << "IVA(%)" << "Prezzo");
 	table->setGeometry(10,120,784,200);
 	//hidePrezzo(false);

  addCMnu=new QAction(QIcon("pic/fatture_add.png"),tr("Aggiungi riga personalizzata alla fattura"),this);
  serCMnu=new QAction(QIcon("pic/fatture_add.png"),tr("Aggiungi servizio alla fattura"),this);
 	
  //connect(ckcampi,SIGNAL(stateChanged(int)),this,SLOT(hideCampi(int)));
  connect(aggiungi,SIGNAL(clicked()),this,SLOT(addRighe()));
  connect(escludi,SIGNAL(clicked()),this,SLOT(clearRiga()));
  connect(esegui,SIGNAL(clicked()),this,SLOT(addFattura()));
  connect(oggi,SIGNAL(clicked()),this,SLOT(settaOggi()));
  connect(aggiorna,SIGNAL(clicked()),this,SLOT(aggiornaTotali()));
 	//connect(listaCli,SIGNAL(activated(int)),this,SLOT(updFornitore(int)));  
 	connect(listaCli,SIGNAL(currentIndexChanged(int)),this,SLOT(updFornitore(int)));  
  connect(bdata,SIGNAL(dateChanged(QDate)),this,SLOT(cambiaAnno(QDate))); // TODO
  connect(addCMnu,SIGNAL(triggered()),this,SLOT(addRigheExtra()));
  connect(serCMnu,SIGNAL(triggered()),this,SLOT(addRigheExtraServizi())); // Aggiungi servizio

  yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  infobox->setWindowModality(Qt::WindowModal);
  warnbox->setWindowModality(Qt::WindowModal);
  fatturabox->setDestTable(table);
  servizibox->setDestTable(table);
  azione=ARFATTURA_ADD;
  hide();
 }

void ARFattura::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-111);
  table->setGeometry     (10,120,lar-16,alt-354);
  _totali->setGeometry   ( 10,alt-232,65,24);
  totali->setGeometry    ( 10,alt-206,lar-273,92);
  totali->setColumnWidth (0,(totali->width()/2)-80);
  totali->setColumnWidth (1,(totali->width()/2)+60);
 	cornice->setGeometry   (2,0,lar-2,alt-111);
 	aggiungi->setGeometry  (lar-261,alt-206,128,39);
 	escludi->setGeometry   (lar-131,alt-206,128,39);
 	estampa->setGeometry   (lar-261,alt-164,258,24);
  esegui->setGeometry    (lar-261,alt-138,258,24);
  aggiorna->setGeometry  (80,alt-232,110,24);
  stampa->setGeometry    (lar-261,alt-232,258,24);
 }

bool ARFattura::setForm(QString fatturaID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM fatture WHERE fatturaID='"+fatturaID+"'");
  if(rs)
   {
   	QString clienteID,aux;
   	
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    clienteID=row[1]; populateCli(clienteID);
    tipologia->setFocus();
 	  tipologia->setText(row[2]);
 	  aux=row[4];
 	  scontrino->setText(row[3]);
 	  note->setText(row[4]);
 	  bdata->setDate(QDate::fromString(QString(row[5]),"yyyy-MM-dd"));
    numero->setText(row[8]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
  return false;
 }

void ARFattura::settaFormAdd()
 {
 	esegui->setText(tr("Inserisci fattura")); 	
 	esegui->setIcon(QIcon("pic/fatture_add.png"));
 	estampa->setText(tr("Inserisci e stampa fattura"));
 	estampa->setIcon(QIcon("pic/fatture_add.png"));
 	cornice->setTitle(tr("Crea nuova fattura "));
 	listaCli->setEnabled(true);
  numero->setText(nextNumero(bdata->date().toString("yyyy")));
  old_data->setYMD(bdata->date().year(),1,1);
  QDate st(1752,9,29),en(7999,12,31);
  bdata->setDateRange(st,en);
  if(numero->text()=="1")
   {
    numerobox->clearForm(bdata->date().toString("yyyy"));
    numerobox->exec();
    numero->setText(numerobox->prendiNumero());
   }
 }

void ARFattura::settaFormEdit()
 {
 	esegui->setText(tr("Salva modifiche"));
 	esegui->setIcon(QIcon("pic/floppy.png"));
 	estampa->setText(tr("Salva modifiche e stampa"));
 	estampa->setIcon(QIcon("pic/floppy.png"));
	cornice->setTitle(tr("Visualizza fattura "));
	listaCli->setEnabled(false);
  old_data->setYMD(bdata->date().year(),1,1);
  QDate st(bdata->date().year(),1,1),en(bdata->date().year(),12,31);
  bdata->setDateRange(st,en);
 	allineaFatture();
 }

void ARFattura::clearForm()
 {
  populateCli("");
 	tipologia->setFocus();
 	bdata->setDate(QDate::currentDate());
 	tipologia->clear();
 	scontrino->clear();
 	note->clear();
  allineaFatture();
 	table->setRowCount(0);
 	calcTotali();
  numero->clear();
 }

void ARFattura::populateTable(QString fatturaID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0;
 	
 	rs=sql->doQueryRS("SELECT articoloID,codice,descrizione,prezzo_pub,iva,'0' AS tipo FROM articoli WHERE fatturaID='"+fatturaID+"' UNION SELECT elementoID AS articoloID,articolo AS codice,descrizione,prezzo AS prezzo_pub,iva,'1' AS tipo FROM fatture_elementi_extra WHERE fatturaID='"+fatturaID+"' ORDER BY descrizione");
	if(rs)
 	 {
 	 	QString aux,tipo;
 	 	double prezzo;
 	 	
 	  while((row=mysql_fetch_row(rs)))
     {
  	  table->insertRow(r); table->setRowHeight(r,18);
  	  tipo=row[5];
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[1]));
   	  table->setItem(r,2,inserisciRiga(row[2]));
   	  table->setItem(r,3,inserisciRiga("1",Qt::AlignRight)); // Quantit
   	  table->setItem(r,4,inserisciRiga(row[3],Qt::AlignRight)); // Prezzo unitario
   	  table->setItem(r,5,inserisciRiga(row[4],Qt::AlignRight)); // IVA
   	  aux=row[3]; prezzo=aux.toDouble();
   	  prezzo=prezzo*table->item(r,3)->text().toDouble();
   	  aux.sprintf("%.2lf",prezzo);
  	  table->setItem(r,6,inserisciRiga(aux,Qt::AlignRight)); // Prezzo
   	  if(tipo=="1") // elemento preso da editor (custom)
   	   {
      	table->item(r,0)->setBackgroundColor(QColor(100,255,100));
      	table->item(r,0)->setTextColor(QColor(100,255,100));
      	table->item(r,0)->setFlags(0);
      	table->item(r,0)->setCheckState(Qt::Checked);
        table->item(r,3)->setFlags(Qt::ItemIsSelectable);
      	table->item(r,num_col-1)->setFlags(Qt::ItemIsSelectable);
   	   }
   	  else for(int i=0;i<num_col;i++) table->item(r,i)->setFlags(Qt::ItemIsSelectable);
   	  r++;
     }
    mysql_free_result(rs);
   }
  else
   {
   	infobox->setText(tr("Nessun articolo trovato"));
 	  infobox->exec();
   }
  calcTotali(); 
 }

bool ARFattura::populateCli(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString aux;
 	
 	listaCli->clear();
 	rs=sql->doQueryRS("SELECT * FROM clienti ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaCli->addItem(row[1],QVariant(row[0]));
     	aux=row[0]; if(aux==val) v=r;
     	r++;
     }
    mysql_free_result(rs);
   }
  listaCli->setCurrentIndex(v);
  return r;
 }

void ARFattura::hideCampi(int st)
 {
 	if(st==Qt::Unchecked)
 	 {
    table->hideColumn(rows_cam);
	  table->hideColumn(rows_cam+1);
    table->hideColumn(rows_cam+2);
    table->hideColumn(rows_cam+3);
   }
  else
   {
   	table->showColumn(rows_cam);
	  table->showColumn(rows_cam+1);
    table->showColumn(rows_cam+2);
    table->showColumn(rows_cam+3);
   }
 }

QString ARFattura::nextNumero(QString anno)
 {
  MYSQL_RES *rs;
  MYSQL_ROW row;
  QString aux;

  rs=sql->doQueryRS("SELECT MAX(numero)+1 FROM fatture WHERE anno='"+anno+"'");
  if(rs)
   {
    row=mysql_fetch_row(rs);
    aux=row[0]; if(aux=="") aux="1";
    mysql_free_result(rs);
    return aux;
   }
  return "0";
 }

QString ARFattura::nextNumeroPer(QString anno)
 {
  MYSQL_RES *rs;
  MYSQL_ROW row;
  QString aux;

  rs=mainWin->sql->doQueryRSPer("SELECT MAX(numero)+1 FROM fatture WHERE anno='"+anno+"'");
  if(rs)
   {
    row=mysql_fetch_row(rs);
    aux=row[0]; if(aux=="") aux="1";
    mysql_free_result(rs);
    return aux;
   }
  return "0";
 }

bool ARFattura::addFattura()
 {
  QString articoloID,fatturaID,stato;
  QString ts_sr,data_sr,ora_sr;
  QString ts_fat,data_fat,ora_fat;
  QString clienteID=listaCli->itemData(listaCli->currentIndex()).toString();
  QString tipologia=quote(this->tipologia->text());
  QString scontrino=quote(this->scontrino->text());
  QString note=quote(this->note->text());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);
  QString data_fattura=bdata->date().toString("yyyy-MM-dd");
  QString numero="0";
  QString anno=bdata->date().toString("yyyy");

  if(isAzione(ARFATTURA_ADD))
   {
    if(!checkForm())
     {
  	  yesnobox->setText(tr("Confermi salvataggio fattura?"));
      if(yesnobox->exec()==QMessageBox::Yes)
       {
        mainWin->sql->doQueryPer("LOCK TABLES fatture WRITE, fatture_elementi_extra WRITE, articoli WRITE");
        numero=nextNumeroPer(anno);
        if(numero!="1")
         {
          if(this->numero->text()!=numero)
           {
            warnbox->setText(tr("Attenzione, il numero del documento\n stato aggiornato a ")+numero);
 	          warnbox->exec();
           }
          this->numero->setText(numero);
         }
        else { numero=this->numero->text(); }
        ts_fat=ts; data_fat=data; ora_fat=ora;
        stato=ARSTATO_VENDUTO;
 	      if(mainWin->sql->doQueryPer("INSERT INTO fatture VALUES(NULL,'"+clienteID+"','"+tipologia+"','"+scontrino+"','"+note+"','"+data_fattura+"','00:00:00','0','"+numero+"','"+anno+"','"+data+"','"+ora+"','"+ts+"')",true))
 	       {
 	        fatturaID=mainWin->sql->prendiLastID();
 	        printFatturaID=fatturaID;
          for(int r=0;r<table->rowCount();r++)
           {
            articoloID=table->item(r,0)->text();
            if(articoloID!="") // Elemento fattura preso da magazzino
             {
 	            mainWin->sql->doQueryPer("UPDATE articoli SET fatturaID='"+fatturaID+"', fatturato='1', stato="+stato+", bolla='0', bollaID='0', data_fat='"+data_fat+"', ora_fat='"+ora_fat+"', ts_fat='"+ts_fat+"' WHERE articoloID='"+articoloID+"'");
 	           }
 	          else               // Elemento fattura preso da interfaccia (custom)
 	           {
 	           	mainWin->sql->doQueryPer("INSERT INTO fatture_elementi_extra VALUES(NULL,'"+fatturaID+"','"+clienteID+"','"+table->item(r,1)->text()+"','"+table->item(r,2)->text()+"','"+table->item(r,3)->text()+"','"+table->item(r,4)->text()+"','"+table->item(r,5)->text()+"','0','"+data_fat+"','"+ora_fat+"','"+ts_fat+"')");
 	           }
     	     }
     	    //allineaFatture(1);
     	    infobox->setText(tr("Nuova fattura inserita"));
   	      infobox->exec();
          mainWin->sql->doQueryPer("UNLOCK TABLES");
   	      clearForm();
          this->numero->setText(nextNumero(bdata->date().toString("yyyy")));
   	      return true;
   	     }
        mainWin->sql->doQueryPer("UNLOCK TABLES");
       }
     }
   }
  if(isAzione(ARFATTURA_EDIT))
   {
    if(!checkForm())
     {
  	  yesnobox->setText(tr("Confermi modifica fattura?"));
      if(yesnobox->exec()==QMessageBox::Yes)
       {
        ts_fat=ts; data_fat=data; ora_fat=ora;
        stato=ARSTATO_VENDUTO;
        fatturaID=this->fatturaID;
        printFatturaID=fatturaID;
 	      if(sql->doQuery("UPDATE fatture SET clienteID='"+clienteID+"', tipologia='"+tipologia+"', scontrino='"+scontrino+"', note='"+note+"', data_fattura='"+data_fattura+"' WHERE fatturaID='"+fatturaID+"'",true))
 	       {
 	       	for(int r=0;r<table->rowCount();r++)
           {
       	    articoloID=table->item(r,0)->text();

        	 	if(table->item(r,0)->checkState()==Qt::Checked)
        	 	 {
        	 	  if(articoloID=="") // Elemento inserito da interfaccia (mentre si modificava la fattura)
               sql->doQuery("INSERT INTO fatture_elementi_extra VALUES(NULL,'"+fatturaID+"','"+clienteID+"','"+table->item(r,1)->text()+"','"+table->item(r,2)->text()+"','"+table->item(r,3)->text()+"','"+table->item(r,4)->text()+"','"+table->item(r,5)->text()+"','0','"+data_fat+"','"+ora_fat+"','"+ts_fat+"')");
              else
               sql->doQuery("UPDATE fatture_elementi_extra SET articolo='"+table->item(r,1)->text()+"', descrizione='"+table->item(r,2)->text()+"', prezzo='"+table->item(r,4)->text()+"', iva='"+table->item(r,5)->text()+"' WHERE elementoID='"+articoloID+"'");
             }
 	 	        else
 	 	         {
 	 	          sql->doQuery("UPDATE articoli SET fatturaID='"+fatturaID+"', fatturato='1', bolla='0', bollaID='0', stato="+stato+", ts_fat='"+ts_fat+"', data_fat='"+data_fat+"', ora_fat='"+ora_fat+"' WHERE articoloID='"+articoloID+"'");
 	 	         }
     	     }
     	    stato=ARSTATO_GIACENZA;
     	    allineaFatture(1);
     	    infobox->setText(tr("Fattura modificata e salvata!"));
   	      infobox->exec();
   	      mainWin->visFatture();
   	      return true;
   	     }
   	   }
     }
 	 }
 	return false;
 }

void ARFattura::addRigheExtraServizi()
 {
 	servizibox->setFornitoreID(listaCli->itemData(listaCli->currentIndex()).toString());
 	servizibox->visServizi();
 	servizibox->setMsg(listaCli->itemText(listaCli->currentIndex()));
 	servizibox->exec();
 }

void ARFattura::addRigheExtra()
 {
 	int n;
 	
 	n=table->rowCount();
  table->insertRow(n);
  table->setRowHeight(n,18);
  for(int i=0;i<num_col;i++)
   {
    if(i<3) table->setItem(n,i,inserisciRiga("",Qt::AlignLeft));
    else
     {
      if(i==3) {
      	        table->setItem(n,i,inserisciRiga("1",Qt::AlignRight)); // Quantit
      	        table->item(n,i)->setFlags(Qt::ItemIsSelectable);
      	       }
      else     table->setItem(n,i,inserisciRiga("",Qt::AlignRight));
     }
    if(i==0)
     {
    	table->item(n,i)->setBackgroundColor(QColor(100,255,100));
    	table->item(n,i)->setTextColor(QColor(100,255,100));
      table->item(n,i)->setFlags(0);
      table->item(n,i)->setCheckState(Qt::Checked);  	
     }
    if(i==num_col-1) table->item(n,i)->setFlags(Qt::ItemIsSelectable);
   }
 }

void ARFattura::addRighe()
 {
 	fatturabox->setFornitoreID(listaCli->itemData(listaCli->currentIndex()).toString());
 	fatturabox->visMagazzino();
 	fatturabox->setMsg(listaCli->itemText(listaCli->currentIndex()));
 	fatturabox->exec();
 }

void ARFattura::clearRiga()
 {
 	if(table->currentRow()<0)
 	 {
 	  infobox->setText(tr("Nessun articolo selezionato"));
 	  infobox->exec();
 	 }
 	else
 	 {
 	 	QString aux;

 	 	aux=table->item(table->currentRow(),0)->text();
 	 	if(table->item(table->currentRow(),0)->checkState()==Qt::Checked)
 	 	 sql->doQuery("UPDATE fatture_elementi_extra SET da_cancellare='1' WHERE elementoID='"+aux+"'");
 	 	else
 	 	 sql->doQuery("UPDATE articoli SET fatturato='0' WHERE articoloID='"+aux+"'");
 	 	table->removeRow(table->currentRow());
 	 }
 	calcTotali();
 }

int ARFattura::checkElemento(int r, int c, int err, bool ckint, bool ckdouble)
 {
 	bool ok;
 	int n;
 	double d;
 	
 	if(!table->item(r,c)) return err;
 	//if(table->item(r,c)->text()=="" && (ckint || ckdouble)) table->item(r,c)->setText("0");
 	if(table->item(r,c)->text()=="") return err;
 	if(ckint)
 	 {
 	 	n=table->item(r,c)->text().toInt(&ok);
 	 	if(!ok) return err;
 	 	if(n<0) return err;
 	 	if(n>100) return err+100;
 	 }
 	if(ckdouble)
 	 {
 	 	d=table->item(r,c)->text().toDouble(&ok);
 	 	if(!ok) return err;
 	 	if(d<0) return err;
 	 	if(d>50000000) return err+100;
 	 }
 	if(table->item(r,c)->text().length()>255) return err+100;
 	return 0;
 }

int ARFattura::checkRiga(int r)
 {
 	int error=0;
 	
 	error=checkElemento(r,2,1);            if(error!=0) return error; // Descrizione
 	error=checkElemento(r,4,2,false,true); if(error!=0) return error; // Prezzo
  error=checkElemento(r,5,3,true);       if(error!=0) return error; // Iva
 	return 0;
 }

bool ARFattura::checkForm()
 {
 	int error=0, rigaerrata=0;

 	for(int r=0;r<table->rowCount();r++) if(table->item(r,0)->checkState()==Qt::Checked) { error=checkRiga(r); rigaerrata=r; if(error!=0) break; }
 	if(error==1) infobox->setText(tr("Descrizione vuota, inserire la descrizione!"));
 	if(error==2) infobox->setText(tr("Formato prezzo errato, correggere prezzo!"));
 	if(error==3) infobox->setText(tr("Formato iva errato, correggere iva!"));
 	if(error==101) infobox->setText(tr("Descrizione troppo lunga, massimo 255 caratteri!"));
  if(error==102) infobox->setText(tr("Prezzo troppo alto, massimo 50.000.000,00.\nCorreggere prezzo!"));
  if(error==103) infobox->setText(tr("L'IVA pu essere massimo 100.\nCorreggere IVA!"));
 	table->selectRow(rigaerrata);
 	if(!error) { table->clearSelection(); return false; } else { infobox->exec(); return true; }
 	
 	if(table->rowCount()==0)
 	 {
 	  infobox->setText(tr("Nessun articolo selezionato"));
 	  infobox->exec();
 	  return true;
 	 }
 	if(quote(this->tipologia->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la tipologia merceologica"));
 	  warnbox->exec();
 	  return true;
 	 }
 	return false;
 }

void ARFattura::contextMenuEvent(QContextMenuEvent *event)
 {
  QMenu menu(this);
  menu.addAction(addCMnu);
  menu.addAction(serCMnu);
  //menu.addAction(delCMnu);
  menu.exec(event->globalPos());
 }

QTableWidgetItem *ARFattura::inserisciRiga(const char *str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QTableWidgetItem *ARFattura::inserisciRiga(QString str, int alig)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	item->setTextAlignment(alig);
 	return item;
 }

QString ARFattura::getPrintFatturaID() { return printFatturaID; }

QString ARFattura::getFatturaID()
 {
 	return fatturaID;
 }

QString ARFattura::getClienteID()
 {
 	return listaCli->itemData(listaCli->currentIndex()).toString();
 }

QString ARFattura::getElemento(int r, int c, QString def)
 {
 	if(table->item(r,c)) return table->item(r,c)->text(); else return def;
 }

QString ARFattura::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void ARFattura::settaOggi()
 {
 	QDate cd = QDate::currentDate();

 	bdata->setDate(cd);
 }

void ARFattura::aggiornaTotali()
 {
  calcTotali();
 }

void ARFattura::calcTotali()
 {
  QString _pezzi,_imponibile,_iva,_totale;
  QString aux;
  double imponibile=0,iva=0,totale=0;
  int pezzi=0;

  totali->setRowCount(0);
  for(int r=0;r<4;r++) { totali->insertRow(r); totali->setRowHeight(r,18); }
  totali->setItem(0,0,inserisciRiga(tr("Totale quantit")));
  aux = "Totale imponibile ("+mainWin->CURRENCY_NAME+")";
  totali->setItem(1,0,inserisciRiga(tr(aux.toAscii())));
  aux = "Totale I.V.A. ("+mainWin->CURRENCY_NAME+")";
  totali->setItem(2,0,inserisciRiga(tr(aux.toAscii())));
  aux = "Totale fattura ("+mainWin->CURRENCY_NAME+")";
  totali->setItem(3,0,inserisciRiga(tr(aux.toAscii())));
  for(int r=0;r<table->rowCount();r++)
   {
  	table->item(r,6)->setText(table->item(r,4)->text());
  	imponibile=imponibile+table->item(r,6)->text().toDouble();
  	iva=iva+(table->item(r,5)->text().toDouble()/100.0*table->item(r,6)->text().toDouble());
  	pezzi++;
   }
  totale=imponibile+iva;
  _pezzi.sprintf("%d",pezzi);
  _imponibile.sprintf("%.2lf",imponibile);
  _iva.sprintf("%.2lf",iva);
  _totale.sprintf("%.2lf",totale);
  totali->setItem(0,1,inserisciRiga(_pezzi,Qt::AlignRight));
  totali->setItem(1,1,inserisciRiga(_imponibile,Qt::AlignRight));
  totali->setItem(2,1,inserisciRiga(_iva,Qt::AlignRight));
  totali->setItem(3,1,inserisciRiga(_totale,Qt::AlignRight));
 }

void ARFattura::setSrcTable(QTableWidget *stb) { srctable=stb; }

void ARFattura::setAzione(int azio) { azione=azio; }

bool ARFattura::isAzione(int azio) { if(azione==azio) return true; else return false; }

void ARFattura::setFatturaID(QString id) { fatturaID=id; }

void ARFattura::updFornitore(int p)
 {
  allineaFatture();
  table->setRowCount(0);
 }

void ARFattura::allineaFatture(int save)
 {
 	if(save==0)
 	 {
 	  sql->doQuery("UPDATE articoli SET fatturato='1' WHERE fatturaID!='0' AND fatturato='0'");
 	  sql->doQuery("UPDATE articoli SET fatturato='0' WHERE fatturaID='0' AND fatturato='1'");
 	 }
 	if(save==1)
 	 {
 	 	QString venduto;
 	 	
 	 	venduto=ARSTATO_VENDUTO;
 	  sql->doQuery("UPDATE articoli SET fatturaID='0', fatturato='0', data_fat='0000-00-00', ora_fat='00:00:00', ts_fat='0', bolla='0', bollaID='0' WHERE fatturaID!='0' AND stato='"+venduto+"' AND fatturato='0'");
 	  sql->doQuery("DELETE FROM fatture_elementi_extra WHERE da_cancellare='1'");
 	 }
 }

void ARFattura::cambiaAnno(QDate d)
 {
  QString old_anno,new_anno,numero;

  old_anno.sprintf("%d",old_data->year());
  new_anno=bdata->date().toString("yyyy");
  old_data->setYMD(d.year(),1,1);
  if(new_anno!=old_anno)
   {
    numero=nextNumero(new_anno);
    if(numero=="1")
     {
      numerobox->clearForm(new_anno);
      if(numerobox->exec()==QDialog::Accepted) this->numero->setText(numerobox->prendiNumero());
     }
    else { this->numero->setText(numero); }
   }
 }
