#ifndef ARFATTURA_H
#define ARFATTURA_H

#define ARFATTURA_ADD  0
#define ARFATTURA_EDIT 1

#include <QWidget>
#include <QDate>

class QPushButton;
class QGroupBox;
class QComboBox;
class QCheckBox;
class QLabel;
class QLineEdit;
class QAction;
class QMenu;
class QContextMenuEvent;
class QHeaderView;
class QTableWidget;
class QTableWidgetItem;
class QMessageBox;
class QDateEdit;

class ARFinestra;
class ARDialogFattura;
class ARDialogServizi;
class ARDialogNumero;
class ARsql;

class ARFattura : public QWidget
 {
  Q_OBJECT

  public:
   bool dettagli;
   QGroupBox *cornice;
   QAction *addCMnu,*serCMnu;
   QPushButton *stampa,*aggiorna,*estampa,*esegui,*escludi,*aggiungi,*oggi;
   QComboBox *listaCli;
   QLineEdit *numero,*scontrino,*tipologia,*note;
   QTableWidget *table,*totali;
   QDateEdit *bdata;
   
   ARFattura(QWidget *parent = 0);
   void settaGeometria(int,int);
   void populateTable(QString);
   bool populateCli(QString);
   QString getPrintFatturaID();
   QString getFatturaID();
   QString getClienteID();
   QString getElemento(int,int,QString def="");
   bool checkForm();
   bool setForm(QString);
   void settaFormAdd();
   void settaFormEdit();
   void clearForm();
   void setSrcTable(QTableWidget *);
   void setAzione(int);
   bool isAzione(int);
   void setFatturaID(QString);
   void calcTotali();
   int checkRiga(int);
   int checkElemento(int,int,int,bool ckint=false,bool ckdouble=false);

  public slots:
   bool addFattura();
   void updFornitore(int);
   void addRigheExtraServizi();
   void addRigheExtra();
   void addRighe();
   void aggiornaTotali();
   void clearRiga();
   void settaOggi();
   //void hidePrezzo(bool);
   void hideCampi(int);
   void cambiaAnno(QDate);

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   QString printFatturaID,fatturaID;
   ARFinestra *mainWin;
   ARDialogFattura *fatturabox;
   ARDialogServizi *servizibox;
   ARDialogNumero *numerobox;
   QMessageBox *infobox,*warnbox,*yesnobox;
   ARsql *sql;
   QLabel *_cli,*_numero,*_bdata,*_table,*_totali,*_scontrino,*_tipologia,*_note;
   QCheckBox *ckdata,*ckcampi;
   QTableWidget *srctable;
   QDate *old_data;
   int num_col,rows_det,rows_cam,row_pr_pub,azione;

   QString nextNumero(QString);
   QString nextNumeroPer(QString);
   QString quote(QString, bool like = false);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
   void allineaFatture(int save=0);
 };

#endif
