#include <QApplication>
#include <QMenuBar>
#include <QMenu>
#include <QAction>
//#include <QInputDialog>
#include <QTextStream>
#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QMessageBox>
#include <QTableWidget>
#include <QGroupBox>
#include <QTextDocument>
#include <QCloseEvent>
#include <QResizeEvent>
#include <QString>
#include <QProcess>
#include <QDir>
#include <QDesktopWidget>
#include <QToolBar>

#include "ARsql.h"
#include "ARMainMenu.h"
#include "ARBarra.h"
#include "ARFornitore.h"
#include "ARCliente.h"
#include "ARServizio.h"
#include "ARBolla.h"
#include "ARFattura.h"
#include "ARAzienda.h"
#include "ARScadenza.h"
#include "ARArticolo.h"
#include "AROption.h"
#include "ARGrigliaFor.h"
#include "ARGrigliaCli.h"
#include "ARGrigliaSer.h"
#include "ARGrigliaBol.h"
#include "ARGrigliaFat.h"
#include "ARGrigliaSca.h"
#include "ARGrigliaOpt.h"
#include "ARTipoArticolo.h"
#include "ARGrigliaTipoArt.h"
#include "ARCarico.h"
#include "ARScarico.h"
#include "ARStampante.h"
#include "ARDialogScadenza.h"
#include "ARDialogStampe.h"
#include "ARDialogPref.h"
#include "ARDialogSetup.h"
#include "ARDialogBackup.h"
#include "ARDialogInfo.h"
#include "ARDialogBCode.h"
#include "AROrologio.h"
#include "ARStat.h"

#include "costanti.h"

#include "ARFinestra.h"

ARFinestra::ARFinestra(QWidget *parent) : QMainWindow(parent)
 {
  QString aux;
  aux = "Edepol! ";
  aux += EDEPOL_VER;
  setWindowTitle(tr(aux.toStdString().c_str()));
  setupDatabase();
  readAdvanceConfig();
  orologio = new AROrologio();
  tool = new QToolBar(tr("Attrezzi"),this);
  tool->setGeometry(500,20,5000,40); //tool->resizeEvent ( QResizeEvent * ) 
  tool->setAllowedAreas(0);
  calcTl = new QAction(QIcon("pic/calc.png"),tr("Apri calcolatrice"),this);
  rubrTl = new QAction(QIcon("pic/rubrica.png"),tr("Apri rubrica"),this);
  backTl = new QAction(QIcon("pic/backup.png"),tr("Copia di sicurezza"),this);
  tool->addAction(calcTl);
  tool->addAction(rubrTl);
  tool->addSeparator();
  tool->addAction(backTl);
  tool->addSeparator();
  tool->addWidget(orologio);
  tool->addSeparator();
  
  scr = new QDesktopWidget();
  menubar  = new QMenuBar(this);
 	menu1    = new QMenu(tr("&Archivio"));
 	 newforMnu  = new QAction(QIcon("pic/fornitori.png"),tr("Nuovo fornitore"),this);
 	 newforMnu->setShortcut(tr("Ctrl+F"));
 	 newcliMnu  = new QAction(QIcon("pic/clienti.png"),tr("Nuovo cliente"),this);
 	 newcliMnu->setShortcut(tr("Ctrl+C"));
 	 newfatMnu  = new QAction(QIcon("pic/fatture.png"),tr("Nuova Fattura"),this);
 	 newfatMnu->setShortcut(tr("Ctrl+T"));
 	 newbolMnu  = new QAction(QIcon("pic/ddt.png"),tr("Nuovo D.D.T."),this);
 	 newbolMnu->setShortcut(tr("Ctrl+D"));
 	 newscaMnu  = new QAction(QIcon("pic/scadenze.png"),tr("Nuova scadenza"),this);
 	 newscaMnu->setShortcut(tr("Ctrl+S"));
 	 esciMnu    = new QAction(QIcon("pic/exit.png"),tr("&Esci"),this);
 	 esciMnu->setShortcut(tr("Ctrl+E"));
 	menu2    = new QMenu(tr("&Visualizza"));
 	 visforMnu  = new QAction(QIcon("pic/fornitori_vis.png"),tr("Fornitori"),this);
 	 viscliMnu  = new QAction(QIcon("pic/clienti_vis.png"),tr("Clienti"),this);
 	 visownMnu  = new QAction(QIcon("pic/aziende_vis.png"),tr("Dati tua azienda"),this);
 	 visfatMnu  = new QAction(QIcon("pic/fatture_vis.png"),tr("Fatture"),this);
 	 visddtMnu  = new QAction(QIcon("pic/ddt_vis.png"),tr("D.D.T."),this);
 	 visscaMnu  = new QAction(QIcon("pic/scadenze_vis.png"),tr("Scadenze"),this);
 	menu3    = new QMenu(tr("&Magazzino"));
 	 scaricoMnu = new QAction(QIcon("pic/magazzino.png"),tr("&Magazzino"),this);
 	 scaricoMnu->setShortcut(tr("Ctrl+S"));
 	 caricoMnu  = new QAction(QIcon("pic/magazzino_add.png"),tr("&Carico merce"),this);
 	 caricoMnu->setShortcut(tr("Ctrl+M"));
 	 resoMnu    = new QAction(QIcon("pic/reso.png"),tr("Articoli &resi"),this);
 	 vendutiMnu = new QAction(QIcon("pic/venduto.png"),tr("&Articoli venduti"),this);
	 giaceMnu   = new QAction(QIcon("pic/magazzino.png"),tr("Giacenze alla data"),this);
 	 eticMnu    = new QAction(QIcon("pic/etichetta.png"),tr("Stampa etichette articoli selezionati"),this);
 	 eticMnu->setEnabled(false); 	 
 	 stmagMnu   = new QAction(QIcon("pic/tabulati.png"),tr("Stampa magazzino"),this);
 	 stmagMnu->setEnabled(false); 	 
 	 ckprezMnu  = new QAction(tr("Prezzo d'acquisto"),this);
 	 ckprezMnu->setCheckable(true);
 	 ckprezMnu->setEnabled(false);
 	menu4    = new QMenu(tr("Articoli"));
 	  subm4_1  = new QMenu(tr("Tipologia"));
 	   newtartMnu = new QAction(QIcon("pic/tipi.png"),tr("Crea nuova tipologia articoli"),this);
 	   vistartMnu = new QAction(QIcon("pic/tipi_vis.png"),tr("Visualizza tipologie articoli"),this);
 	  subm4_2  = new QMenu(tr("Colore"));
 	   newColoreMnu = new QAction(QIcon("pic/colori.png"),tr("Crea nuovo colore articolo"),this);
 	   visColoreMnu = new QAction(QIcon("pic/colori_vis.png"),tr("Visualizza colori articoli"),this); 	   
 	  subm4_3  = new QMenu(tr("Fondo"));
 	   newFondoMnu = new QAction(QIcon("pic/fondi.png"),tr("Crea nuovo fondo articolo"),this);
 	   visFondoMnu = new QAction(QIcon("pic/fondi_vis.png"),tr("Visualizza fondi articoli"),this); 	    	   
 	  subm4_4  = new QMenu(tr("Tacco"));
 	   newTaccoMnu = new QAction(QIcon("pic/tacchi.png"),tr("Crea nuovo tacco articolo"),this);
 	   visTaccoMnu = new QAction(QIcon("pic/tacchi_vis.png"),tr("Visualizza tacchi articoli"),this); 	    	   
 	  subm4_5  = new QMenu(tr("Stagione"));
 	   newStagioneMnu = new QAction(QIcon("pic/stagioni.png"),tr("Crea nuova stagione articolo"),this);
 	   visStagioneMnu = new QAction(QIcon("pic/stagioni_vis.png"),tr("Visualizza stagioni articoli"),this);
  menu5    = new QMenu(tr("&Statistiche"));
   statrieMnu = new QAction(QIcon("pic/stat.png"),tr("Riepilogo"),this);
   stattreMnu = new QAction(QIcon("pic/stat.png"),tr("Andamenti"),this);
   statstaMnu = new QAction(QIcon("pic/stat.png"),tr("Statistiche"),this);
  menu6    = new QMenu(tr("&Impostazioni"));
   prefvarMnu = new QAction(QIcon("pic/pref.png"),tr("Imposta programma"),this);
   prefstaMnu = new QAction(QIcon("pic/pref_printer.png"),tr("Imposta stampe"),this);
  menu7    = new QMenu(tr("&Attrezzi"));
   toolcalMnu = new QAction(QIcon("pic/calc.png"),tr("Calcolatrice"),this);
   toolrubMnu = new QAction(QIcon("pic/rubrica.png"),tr("Rubrica"),this);
   toolbakMnu = new QAction(QIcon("pic/backup.png"),tr("Copia di sicurezza"),this);
  menu8    = new QMenu(tr("&?"));
   manMnu  = new QAction(QIcon("pic/help.png"),tr("Manuale di Edepol!"),this);
   infoMnu = new QAction(QIcon("pic/info.png"),tr("Informazioni su Edepol!"),this);
 	menu9    = new QMenu(tr("Servizi"));
 	 newServiziMnu  = new QAction(QIcon("pic/servizi.png"),tr("Nuovo servizio"),this);
 	 visServiziMnu  = new QAction(QIcon("pic/servizi_vis.png"),tr("Visualizza servizi"),this);

 	sql        = new ARsql(this);
 	sql2       = new ARsql(this);
 	mainMenu   = new ARMainMenu(this);
 	barra      = new ARBarra(this); barra->settaTool(tool); 	barra->sistemaBarra("");
 	carico     = new ARCarico(this);
 	scarico    = new ARScarico(this);
 	addFor     = new ARFornitore(this);
 	addCli     = new ARCliente(this);
 	addSer     = new ARServizio(this);
 	addSca     = new ARScadenza(this);
 	addBol     = new ARBolla(this);
 	addFat     = new ARFattura(this);
 	addAzi     = new ARAzienda(this);
 	addArt     = new ARArticolo(this);
 	addOpt     = new AROption(this);
 	griFor     = new ARGrigliaFor(this);
 	griCli     = new ARGrigliaCli(this);
 	griSer     = new ARGrigliaSer(this); 	
 	griBol     = new ARGrigliaBol(this);
 	griFat     = new ARGrigliaFat(this);
 	griSca     = new ARGrigliaSca(this);
 	addTiArt   = new ARTipoArticolo(this);   addTiArt->setEtichette(carico->getEtichette(),carico->getEtichCampi());
 	griTiArt   = new ARGrigliaTipoArt(this); griTiArt->setEtichette(carico->getEtichette(),carico->getEtichCampi(),carico->getRowIva(),carico->getRowStartCampi());
 	griOpt     = new ARGrigliaOpt(this);
 	stat       = new ARStat(this);

 	infobox    = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox    = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
 	errorbox   = new QMessageBox(tr("Errore"),"",QMessageBox::Critical,0,0,0,this);
 	yesnobox   = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	scadbox    = new ARDialogScadenza(this);
 	pstampebox = new ARDialogStampe(this);
 	prefbox    = new ARDialogPref(this);
 	stampe     = new ARStampante(this);
 	backupbox  = new ARDialogBackup(this);
 	bcodebox   = new ARDialogBCode(this);
 	about      = new ARDialogInfo(this);
 
 	menu1->addAction(newforMnu);
 	menu1->addAction(newcliMnu);
 	menu1->addSeparator();
 	menu1->addAction(newfatMnu);
 	menu1->addAction(newbolMnu);
 	menu1->addAction(newscaMnu);
 	menu1->addSeparator();
 	menu1->addAction(esciMnu);
 	menu2->addAction(visforMnu);
 	menu2->addAction(viscliMnu);
 	menu2->addAction(visownMnu);
 	menu2->addSeparator();
 	menu2->addAction(visfatMnu);
 	menu2->addAction(visddtMnu);
 	menu2->addAction(visscaMnu);
 	menu3->addAction(caricoMnu);
 	menu3->addAction(scaricoMnu);
 	menu3->addAction(resoMnu);
 	menu3->addAction(vendutiMnu);
	menu3->addAction(giaceMnu);
 	menu3->addAction(eticMnu);
 	menu3->addAction(stmagMnu);
 	menu3->addAction(ckprezMnu);
    menu4->addMenu(subm4_1);
 	 subm4_1->addAction(newtartMnu);
 	 subm4_1->addAction(vistartMnu);
 	menu4->addSeparator();
 	menu4->addMenu(subm4_2);
 	 subm4_2->addAction(newColoreMnu);
 	 subm4_2->addAction(visColoreMnu);
 	menu4->addMenu(subm4_3);
 	 subm4_3->addAction(newFondoMnu);
 	 subm4_3->addAction(visFondoMnu);
 	menu4->addMenu(subm4_4);
 	 subm4_4->addAction(newTaccoMnu);
 	 subm4_4->addAction(visTaccoMnu);
 	menu4->addMenu(subm4_5);
 	 subm4_5->addAction(newStagioneMnu);
 	 subm4_5->addAction(visStagioneMnu);
 	menu5->addAction(statrieMnu);
 	menu5->addAction(stattreMnu);
 	menu5->addAction(statstaMnu);
 	menu6->addAction(prefvarMnu);
 	menu6->addAction(prefstaMnu);
 	menu7->addAction(toolcalMnu);
 	menu7->addAction(toolrubMnu);
 	menu7->addSeparator();
 	menu7->addAction(toolbakMnu);
 	menu8->addAction(manMnu);
 	menu8->addAction(infoMnu);
 	menu9->addAction(newServiziMnu);
 	menu9->addAction(visServiziMnu);
 	menubar->addMenu(menu1); // Archivio
 	menubar->addMenu(menu2); // Visualizza
 	menubar->addMenu(menu3); // Magazzino
 	menubar->addMenu(menu4); // Articoli
 	menubar->addMenu(menu9); // Servizi
 	if(STATISTICS_ENABLED) menubar->addMenu(menu5); // Statistiche
 	menubar->addMenu(menu6); // Impostazioni
    menubar->addMenu(menu7); // Attrezzi
    menubar->addMenu(menu8); // ?
 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	errorbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
 	resize(800,550);
 	setWindowFlags(Qt::MSWindowsFixedSizeDialogHint);
  setWindowState(Qt::WindowMaximized);

  // ToolBar
  connect(calcTl,SIGNAL(triggered()),this,SLOT(mostraCalcolatrice()));
  connect(rubrTl,SIGNAL(triggered()),this,SLOT(mostraRubrica()));
  connect(backTl,SIGNAL(triggered()),this,SLOT(backupDb()));

  // Menu (a tendina)
  connect(newforMnu,SIGNAL(triggered()),this,SLOT(addFornitore()));
  connect(newcliMnu,SIGNAL(triggered()),this,SLOT(addCliente()));
  connect(newfatMnu,SIGNAL(triggered()),this,SLOT(addFattura()));
  connect(newbolMnu,SIGNAL(triggered()),this,SLOT(addBolla()));
  connect(newscaMnu,SIGNAL(triggered()),this,SLOT(addScadenza()));
  connect(esciMnu,SIGNAL(triggered()),this,SLOT(Esci()));
  connect(visforMnu,SIGNAL(triggered()),this,SLOT(visFornitori()));
  connect(viscliMnu,SIGNAL(triggered()),this,SLOT(visClienti()));
  connect(visfatMnu,SIGNAL(triggered()),this,SLOT(visFatture()));
  connect(visddtMnu,SIGNAL(triggered()),this,SLOT(visBolle()));
  connect(visscaMnu,SIGNAL(triggered()),this,SLOT(visScadenze()));
  connect(visownMnu,SIGNAL(triggered()),this,SLOT(visAzienda()));
  connect(caricoMnu,SIGNAL(triggered()),this,SLOT(addMerce()));
  connect(scaricoMnu,SIGNAL(triggered()),this,SLOT(scaricoMerce()));
  connect(resoMnu,SIGNAL(triggered()),this,SLOT(resoMerce()));
  connect(vendutiMnu,SIGNAL(triggered()),this,SLOT(vendutaMerce()));
  connect(giaceMnu,SIGNAL(triggered()),this,SLOT(giacenzeMerce()));
  connect(eticMnu,SIGNAL(triggered()),this,SLOT(stampaEtichette())); // Stampa etichette articoli
  connect(stmagMnu,SIGNAL(triggered()),this,SLOT(stampaMagazzino())); // Stampa magazzino
  connect(ckprezMnu,SIGNAL(toggled(bool)),this,SLOT(hidePrezzo(bool)));
  connect(newtartMnu,SIGNAL(triggered()),this,SLOT(addTipoArt()));
  connect(vistartMnu,SIGNAL(triggered()),this,SLOT(visTipoArt()));
  connect(newColoreMnu,SIGNAL(triggered()),this,SLOT(addColore()));
  connect(visColoreMnu,SIGNAL(triggered()),this,SLOT(visColori()));
  connect(newFondoMnu,SIGNAL(triggered()),this,SLOT(addFondo()));
  connect(visFondoMnu,SIGNAL(triggered()),this,SLOT(visFondi()));
  connect(newTaccoMnu,SIGNAL(triggered()),this,SLOT(addTacco()));
  connect(visTaccoMnu,SIGNAL(triggered()),this,SLOT(visTacchi()));
  connect(newStagioneMnu,SIGNAL(triggered()),this,SLOT(addStagione()));
  connect(visStagioneMnu,SIGNAL(triggered()),this,SLOT(visStagioni()));
  connect(newServiziMnu,SIGNAL(triggered()),this,SLOT(addServizio())); // Servizi
  connect(visServiziMnu,SIGNAL(triggered()),this,SLOT(visServizi()));
  connect(statrieMnu,SIGNAL(triggered()),this,SLOT(visStatistiche()));
  connect(stattreMnu,SIGNAL(triggered()),this,SLOT(visStatAndamenti()));
  connect(statstaMnu,SIGNAL(triggered()),this,SLOT(visStatStatistiche()));
  connect(prefstaMnu,SIGNAL(triggered()),this,SLOT(prefStampe()));
  connect(prefvarMnu,SIGNAL(triggered()),this,SLOT(prefMisc()));
  connect(manMnu,SIGNAL(triggered()),this,SLOT(mostraManuale()));
  connect(infoMnu,SIGNAL(triggered()),this,SLOT(mostraAbout()));
  connect(toolcalMnu,SIGNAL(triggered()),this,SLOT(mostraCalcolatrice()));
  connect(toolrubMnu,SIGNAL(triggered()),this,SLOT(mostraRubrica()));
  connect(toolbakMnu,SIGNAL(triggered()),this,SLOT(backupDb()));

  // Menu principale
  connect(mainMenu->fornitori,SIGNAL(clicked()),this,SLOT(visFornitori()));
  connect(mainMenu->clienti,SIGNAL(clicked()),this,SLOT(visClienti()));
  connect(mainMenu->azienda,SIGNAL(clicked()),this,SLOT(visAzienda()));
  connect(mainMenu->magazzino,SIGNAL(clicked()),this,SLOT(scaricoMerce()));
  connect(mainMenu->carico,SIGNAL(clicked()),this,SLOT(addMerce()));
  connect(mainMenu->cassa,SIGNAL(clicked()),this,SLOT(cassaRapida()));
  connect(mainMenu->ddt,SIGNAL(clicked()),this,SLOT(visBolle()));
  connect(mainMenu->fatture,SIGNAL(clicked()),this,SLOT(visFatture()));
  connect(mainMenu->scadenze,SIGNAL(clicked()),this,SLOT(visScadenze()));
  connect(mainMenu->stat,SIGNAL(clicked()),this,SLOT(visStatistiche()));

  // Barra pulsanti
  connect(barra->b1, SIGNAL(clicked()),this,SLOT(addFornitore()));
  connect(barra->b2, SIGNAL(clicked()),this,SLOT(visFornitori()));  
  connect(barra->b3, SIGNAL(clicked()),this,SLOT(addCliente()));
  connect(barra->b4, SIGNAL(clicked()),this,SLOT(visClienti()));
  connect(barra->b5, SIGNAL(clicked()),this,SLOT(addMerce()));
  connect(barra->b6, SIGNAL(clicked()),this,SLOT(scaricoMerce()));
  connect(barra->b7, SIGNAL(clicked()),this,SLOT(addBolla()));
  connect(barra->b8, SIGNAL(clicked()),this,SLOT(visBolle()));
  connect(barra->b9, SIGNAL(clicked()),this,SLOT(addTipoArt()));
  connect(barra->b10,SIGNAL(clicked()),this,SLOT(visTipoArt()));
  connect(barra->b11,SIGNAL(clicked()),this,SLOT(addColore()));
  connect(barra->b12,SIGNAL(clicked()),this,SLOT(visColori()));
  connect(barra->b13,SIGNAL(clicked()),this,SLOT(addFondo()));
  connect(barra->b14,SIGNAL(clicked()),this,SLOT(visFondi()));
  connect(barra->b15,SIGNAL(clicked()),this,SLOT(addTacco()));
  connect(barra->b16,SIGNAL(clicked()),this,SLOT(visTacchi()));
  connect(barra->b17,SIGNAL(clicked()),this,SLOT(addStagione()));
  connect(barra->b18,SIGNAL(clicked()),this,SLOT(visStagioni()));
  connect(barra->b19,SIGNAL(clicked()),this,SLOT(addFattura()));
  connect(barra->b20,SIGNAL(clicked()),this,SLOT(visFatture()));
  connect(barra->b21,SIGNAL(clicked()),this,SLOT(addScadenza()));
  connect(barra->b22,SIGNAL(clicked()),this,SLOT(visScadenze()));
  connect(barra->b23,SIGNAL(clicked()),this,SLOT(addServizio()));
  connect(barra->b24,SIGNAL(clicked()),this,SLOT(visServizi()));
  connect(barra->esci,SIGNAL(clicked()),this,SLOT(menuPrincipale()));
  connect(barra->quit,SIGNAL(clicked()),this,SLOT(Esci()));

  // Connect interclassi
  connect(addAzi->stampaint,SIGNAL(clicked()),this,SLOT(stampaIntestAzi())); // Stampa intestazioni tua azienda
  connect(griFor->edit,SIGNAL(clicked()),this,SLOT(editFornitore()));
  connect(griFor->mmagCMnu,SIGNAL(triggered()),this,SLOT(scaricoMerceFor())); // Mostra la merce in magazzino del fornitore selezionato in griFor
  connect(griFor->editCMnu,SIGNAL(triggered()),this,SLOT(editFornitore()));
  connect(griFor->stampaint,SIGNAL(clicked()),this,SLOT(stampaIntestFor())); // Stampa intestazioni fornitori
  connect(griFor->stampa,SIGNAL(clicked()),this,SLOT(stampaFornitori()));    // Stampa tabulato fornitori 
  connect(griCli->edit,SIGNAL(clicked()),this,SLOT(editCliente()));
  connect(griCli->editCMnu,SIGNAL(triggered()),this,SLOT(editCliente()));
  connect(griCli->stampaint,SIGNAL(clicked()),this,SLOT(stampaIntestCli())); // Stampa intestazioni clienti
  connect(griCli->stampa,SIGNAL(clicked()),this,SLOT(stampaClienti()));      // Stampa tabulato clienti
  connect(griSer->edit,SIGNAL(clicked()),this,SLOT(editServizio()));
  connect(griSer->editCMnu,SIGNAL(triggered()),this,SLOT(editServizio()));
  connect(griSer->stampa,SIGNAL(clicked()),this,SLOT(stampaServizi()));      // Stampa tabulato servizi
  connect(griTiArt->edit,SIGNAL(clicked()),this,SLOT(editTipoArt()));
  connect(scarico->edit,SIGNAL(clicked()),this,SLOT(editArticolo()));
  connect(scarico->editCMnu,SIGNAL(triggered()),this,SLOT(editArticolo()));
  connect(scarico->eticCMnu,SIGNAL(triggered()),this,SLOT(stampaEtichette())); // Stampa etichette articoli (da menu contestuale)
  connect(scarico->stmagCMnu,SIGNAL(triggered()),this,SLOT(stampaMagazzino()));  // Stampa tabulato magazzino
  //connect(scarico->ddtCMnu,SIGNAL(triggered()),this,SLOT(addBolla())); // Crea D.D.T. (da menu contestuale)
  connect(griOpt->edit,SIGNAL(clicked()),this,SLOT(editOpzione()));
  connect(addFat->estampa,SIGNAL(clicked()),this,SLOT(addPrintFattura()));    // Stampa fattura
  connect(griFat->stampa,SIGNAL(clicked()),this,SLOT(printFattura()));        // Stampa fattura
  connect(addFat->stampa,SIGNAL(clicked()),this,SLOT(printFatturaSalvata())); // Stampa fattura (già salvata in precedenza)
  connect(griFat->edit,SIGNAL(clicked()),this,SLOT(editFattura()));
  connect(griFat->editCMnu,SIGNAL(triggered()),this,SLOT(editFattura()));
  connect(addBol->estampa,SIGNAL(clicked()),this,SLOT(addPrintBolla())); // Stampa D.D.T.
  connect(griBol->stampa,SIGNAL(clicked()),this,SLOT(printBolla()));     // Stampa D.D.T.
  connect(griBol->edit,SIGNAL(clicked()),this,SLOT(editBolla()));
  connect(griBol->editCMnu,SIGNAL(triggered()),this,SLOT(editBolla()));
  connect(griSca->edit,SIGNAL(clicked()),this,SLOT(editScadenza()));
  connect(griSca->editCMnu,SIGNAL(triggered()),this,SLOT(editScadenza()));
  addArt->hide();

  // Allinea articoli (nel caso ci siano incongruenze per articoli non ancora
  // fatturati (fatturaID=0) con il flag fatturato=1 ed articoli non ancora in
  // bolla (bollaID=0) con il flag bolla=1) ... da verificare bene. 
  // Il problema quindi si risolve riavviando il programma.             
  sql->connetti();
  sql->doQuery("DELETE FROM fatture_elementi_extra WHERE da_cancellare='1'");
  sql->disconnetti();
  sql->connetti();  
  if(sql->bloccaPer(sql->getDbName()+".bolle","0")) 
   {
   	sql2->doQuery("UPDATE articoli SET bolla=0 WHERE bollaID=0 AND bolla=1 AND stato!=2");
   	sql2->doQuery("UPDATE articoli SET bolla=1 WHERE bollaID!=0 AND bolla=0 AND stato=2");
   }
  sql->disconnetti();
  sql->connetti();
  if(sql->bloccaPer(sql->getDbName()+".fatture","0")) 
   {
   	sql2->doQuery("UPDATE articoli SET fatturato=0 WHERE fatturaID=0 AND fatturato=1 AND stato!=1");
   	sql2->doQuery("UPDATE articoli SET fatturato=1 WHERE fatturaID!=0 AND fatturato=0 AND stato=1");
   }
  sql->disconnetti();

  if(!esisteAzienda()) addAzienda();
  controllaScadenze();
 }

void ARFinestra::readAdvanceConfig()
 {
  QString par,val;
  QFile *fd = new QFile(ADVCFG_FILE);

  if(!fd->exists(ADVCFG_FILE)) // default configuration
   {
    fd->open(QIODevice::WriteOnly | QIODevice::Text);
    QTextStream out(fd);
    out << "[STATISTICS_ENABLED]\n1\n";
    out << "[CURRENCY_NAME]\nEuro\n";
    out << "[CURRENCY_CODE]\nEUR\n";
 	fd->close();
   }

  // Valori di default in caso nel file "advance_config.cfg" non fossero presenti le stringhe giuste (nel caso di file "advance_config.cfg" scritto da vecchie versioni del programma)
  STATISTICS_ENABLED = true;
  CURRENCY_NAME = "Euro";
  CURRENCY_CODE = "EUR";

  fd->open(QIODevice::ReadOnly | QIODevice::Text);
  QTextStream in(fd);
  while(!in.atEnd())
   {
    par=in.readLine();
    val=in.readLine();
    if(par=="[STATISTICS_ENABLED]" || par=="STATISTICS_ENABLED")
	 {
	  if(val == "0") STATISTICS_ENABLED = false;
	  else           STATISTICS_ENABLED = true;
     }
    if(par=="[CURRENCY_NAME]"   || par=="CURRENCY_NAME") CURRENCY_NAME = val.toStdString().c_str();
    if(par=="[CURRENCY_CODE]"   || par=="CURRENCY_CODE") CURRENCY_CODE = val.toStdString().c_str();
   }
  fd->close();
 }

void ARFinestra::settaGeometria(bool m)
 {
 	menubar->setGeometry(0,0,3000,20);
 	if(m)
 	 {
 	 	griFor->settaGeometria(scr->width(),scr->height());
 	 	griCli->settaGeometria(scr->width(),scr->height());
 	 	griSer->settaGeometria(scr->width(),scr->height());
 	 	griSca->settaGeometria(scr->width(),scr->height());
 	 	scarico->settaGeometria(scr->width(),scr->height());
 	 	carico->settaGeometria(scr->width(),scr->height());
 	 	addFat->settaGeometria(scr->width(),scr->height());
 	 	addBol->settaGeometria(scr->width(),scr->height());
 	 	griTiArt->settaGeometria(scr->width(),scr->height());
 	 	griOpt->settaGeometria(scr->width(),scr->height());
 	 	griFat->settaGeometria(scr->width(),scr->height());
 	 	griBol->settaGeometria(scr->width(),scr->height());
 	 	stat->settaGeometria(scr->width(),scr->height());
 	 }
 	else
 	 {
 	 	griFor->settaGeometria(800,600);
 	 	griCli->settaGeometria(800,600);
 	 	griSer->settaGeometria(800,600);
 	 	griSca->settaGeometria(800,600);
    scarico->settaGeometria(800,600);
    carico->settaGeometria(800,600);
    addFat->settaGeometria(800,600);
    addBol->settaGeometria(800,600);
    griTiArt->settaGeometria(800,600);
    griOpt->settaGeometria(800,600);
    griFat->settaGeometria(800,600);
    griBol->settaGeometria(800,600);
    stat->settaGeometria(800,600);
 	 }
 }

void ARFinestra::setupDatabase()
 {
  ARsql *sql = new ARsql(this);

  setupbox = new ARDialogSetup(this);
  while(!sql->testConnection())
   {
    setupbox->setServerAddr(sql->getServerAddr());
    setupbox->setServerPort(sql->getServerPort());
    setupbox->setUserLog(sql->getUserLog());
    setupbox->setUserPwd(sql->getUserPwd());
    setupbox->setDbName(sql->getDbName());
    if(setupbox->exec()==QDialog::Accepted)
     {
   	  sql->writeConfig(setupbox->getServerAddr(),setupbox->getServerPort(),setupbox->getUserLog(),setupbox->getUserPwd(),setupbox->getDbName());
     }
    else exit(0);
   }
  if(!sql->testDbExist()) sql->createDb();
  if(sql->testDbEmpty()) sql->resetDb();
  if(sql->testDbNeedUpdate())
   {
	sql->updateDb();
	QMessageBox *infobox;
	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
	infobox->setText(tr("Edepol! correttamente aggiornato!"));
 	infobox->exec();
   }
  if(sql->testDbBadVersion())
   {
	double v;
	QMessageBox *errorbox;
	QString aux;
	v = sql->getDbVersion();
	aux =  "Versione del database errata! Necessaria ";
	aux += EDEPOL_DB_VER;
	aux += " attuale ";
	aux += QString::number(v,'f',1);
	aux += ".\nNon posso avviare il programma!";
	errorbox = new QMessageBox(tr("Errore"),"",QMessageBox::Critical,0,0,0,this);
	errorbox->setText(tr(aux.toStdString().c_str()));
 	errorbox->exec();
	exit(0);
   }
 }

void ARFinestra::controllaScadenze()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString query,nome,indr,citta,prov,tel,cell,piva;
 	
  // Prende tutte le scadenze non pagate che sono già scadute o scadono entro 15 giorni
  // Il 15 in futuro dovrà essere preso da database come opzione
 	query ="SELECT * FROM scadenze WHERE stato=0 AND data_scadenza<=DATE_SUB(CURDATE(),INTERVAL -15 DAY) ORDER BY data_scadenza";
 	rs=sql->doQueryRS(query);
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
      scadbox->setScadenzaID(row[0]);
      scadbox->setDescrizione(row[2]);
      scadbox->setSomma(row[5]);
      scadbox->setNote(row[3]);
      scadbox->setData(row[6]);
      scadbox->setWindowTitle(tr("In scadenza:"));
      scadbox->exec();
 	    if(scadbox->isIgnoraTutti()) break;
 	    if(scadbox->isPagato())
 	     {
    	 	if(sql->doQuery("UPDATE scadenze SET stato='1' WHERE scadenzaID='"+QString(row[0])+"'"))
 	       {
 	       	warnbox->setText(tr("La scadenza e' stata segnata come PAGATA!"));
 	        warnbox->exec();
         }
 	      else
 	       {
 	       	errorbox->setText(tr("Attenzione! La scadenza NON è stata segnata come pagata\na causa di un errore."));
 	        errorbox->exec();
 	       }
       }
     }
    mysql_free_result(rs);
   }
 }

void ARFinestra::addMerce()
 {
 	hideAll();
  // Entro nella sezione critica
  sql->connetti();
  if(!sql->bloccaPer(sql->getDbName()+".carico","0") || !sql->bloccaPer(sql->getDbName()+".articoli","0")) //.carico_n .articoli_n
   {
  	warnbox->setText(tr("Il magazzino è occupato da un'altro utente.\nRiprova più tardi."));
 	  warnbox->exec();
 	  sql->disconnetti();
 	  menuPrincipale();
 	  return;
   }
 	if(!carico->populateFor())
 	 {
   	infobox->setText(tr("Nessun fornitore trovato!\nPer caricare la merce è necessario inserire\nalmeno un fornitore!"));
 	  infobox->exec();
 	  menuPrincipale();
 	  return;
 	 }
  if(!carico->populateTipo())
   {
   	infobox->setText(tr("Nessuna tipologia di articoli trovata!\nPer caricare la merce è necessario creare prima\nun tipo di articolo!"));
 	  infobox->exec();
 	  menuPrincipale();
 	  return;
   }
  barra->sistemaBarra("magazzino");
 	carico->clearCarico();
 	carico->show();
 	carico->listaFor->setFocus();
 }

void ARFinestra::scaricoMerce()
 {
 	hideAll();
 	barra->sistemaBarra("magazzino");
 	scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
 	scarico->listaMostra->setCurrentIndex(0);
 	scarico->visMagazzino();
 }

void ARFinestra::scaricoMerceFor()
 {
 	QString fornitoreID;

  if(griFor->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun fornitore selezionato."));
 	  warnbox->exec();
   }
  else
   {
 	  hideAll();
 	  scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
    fornitoreID=griFor->table->item(griFor->table->currentRow(),0)->text();
	  scarico->populateFor(fornitoreID);
 	  scarico->listaMostra->setCurrentIndex(0);
 	  scarico->visMagazzino();
 	 }
 }

void ARFinestra::cassaRapida()
 {
 	//hideAll();
 	scarico->table->setCurrentCell (-1,0);
 	//ricavare codice a barre da finestra
 	//QInputDialog::getInteger(this,tr("Ciao"),tr("pippo"),25,0,100,1,&ok);
 	bcodebox->selezionaBCode(); // Evidenzia il testo della casella di input del codice a barre
 	if(bcodebox->exec()==QDialog::Accepted)
 	 {
 	  scarico->scaricaMerce(bcodebox->prendiBCode(),true);
 	 }
 	//barra->sistemaBarra("magazzino");
 	//scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
 	//scarico->listaMostra->setCurrentIndex(0);
 	//scarico->visMagazzino();
 }

void ARFinestra::resoMerce()
 {
  hideAll();
  barra->sistemaBarra("magazzino");
  scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
  scarico->listaMostra->setCurrentIndex(2);
  scarico->visMagazzino();
 }

void ARFinestra::vendutaMerce()
 {
  hideAll();
  barra->sistemaBarra("magazzino");
  scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
  scarico->listaMostra->setCurrentIndex(1);
  scarico->visMagazzino();
 }

void ARFinestra::giacenzeMerce()
 {
  hideAll();
  barra->sistemaBarra("magazzino");
  scarico->show(); eticMnu->setEnabled(true); stmagMnu->setEnabled(true); ckprezMnu->setEnabled(true);
  scarico->listaMostra->setCurrentIndex(3);
  scarico->visMagazzino();
 }

bool ARFinestra::esisteAzienda()
 {
 	MYSQL_RES *rs;

  rs=sql->doQueryRS("SELECT * FROM aziende WHERE aziendaID='1'");
  if(rs)
   {
    if(mysql_num_rows(rs)==1) { mysql_free_result(rs); return true; }
    else { mysql_free_result(rs); return false; }
   }
  return false;
 }

void ARFinestra::menuPrincipale()
 {
 	hideAll();
 	barra->sistemaBarra("");
 	mainMenu->show();
 }

void ARFinestra::addAzienda()
 {
  warnbox->setText(tr("Prima di potere usare il programma è necessario inserire\ni dati della tua azienda nel modulo sottostante."));
 	warnbox->exec();
 	hideAll(); disableAll(true);
 	addAzi->stampaint->setVisible(false);
 	addAzi->show();
 	addAzi->setAzione(ARAZIENDA_ADD);
 	addAzi->esegui->setText(tr("Inserisci"));
 	addAzi->esegui->setIcon(QIcon("pic/aziende_add.png"));
 	addAzi->cornice->setTitle(tr("Inserisci i dati della tua azienda "));
  addAzi->clearForm();
 }

void ARFinestra::visAzienda()
 {
 	QString aziendaID="1";
  if(addAzi->setForm(aziendaID))
 	 {
 	 	hideAll();
 	 	barra->sistemaBarra("azienda");
 	 	addAzi->stampaint->setVisible(true);
    addAzi->setAzione(ARAZIENDA_EDIT);
    addAzi->show();
 	  addAzi->esegui->setText(tr("Salva modifiche"));
 	  addAzi->esegui->setIcon(QIcon("pic/floppy.png"));
 	  addAzi->cornice->setTitle(tr("Visualizza dati tua azienda "));
 	  addAzi->setAziendaID(aziendaID);
   }
  else
   {
    infobox->setText(tr("Azienda inesistente!"));
 	  infobox->exec();
   }
 }

void ARFinestra::addFornitore()
 {
 	hideAll();
 	barra->sistemaBarra("fornitori");
 	addFor->show();
 	addFor->setAzione(ARFORNITORE_ADD);
  addFor->settaFormAdd();
  addFor->clearForm();
 }

void ARFinestra::visFornitori()
 {
 	hideAll();
 	barra->sistemaBarra("fornitori");
 	griFor->show();
 	griFor->visFornitori();
 }

void ARFinestra::addCliente()
 {
 	hideAll();
 	barra->sistemaBarra("clienti");
 	addCli->show();
 	addCli->setAzione(ARCLIENTE_ADD);
 	addCli->esegui->setText(tr("Inserisci"));
 	addCli->esegui->setIcon(QIcon("pic/clienti_add.png"));
 	addCli->cornice->setTitle(tr("Inserisci nuovo cliente "));
  addCli->clearForm();
 }

void ARFinestra::visClienti()
 {
 	hideAll();
 	barra->sistemaBarra("clienti");
 	griCli->show();
 	griCli->visClienti();
 }

void ARFinestra::addBolla()
 {
 	hideAll();
  // Entro nella sezione critica
  sql->connetti();
  if(!sql->bloccaPer(sql->getDbName()+".bolle","0")) 
   {
  	warnbox->setText(tr("La sezione documenti di trasporto è occupata da un'altro utente.\nRiprova più tardi."));
 	  warnbox->exec();
 	  sql->disconnetti();
 	  menuPrincipale();
 	  return;
   }
 	if(!addBol->populateFor(""))
 	 {
   	infobox->setText(tr("Nessun fornitore trovato!\nPer creare un documento di trasporto\nè necessario inserire almeno un fornitore!"));
 	  infobox->exec();
 	  menuPrincipale();
 	  return;
 	 }
 	barra->sistemaBarra("bolle");
 	addBol->show();
 	addBol->setAzione(ARBOLLA_ADD);
 	addBol->setSrcTable(scarico->table);//???
  addBol->clearForm();
  addBol->settaFormAdd();
 }

void ARFinestra::visBolle()
 {
 	hideAll();
 	barra->sistemaBarra("bolle");
 	griBol->show();
 	griBol->visBolle();
 }

void ARFinestra::addScadenza()
 {
 	hideAll();
  // Entro nella sezione critica
  sql->connetti();
  if(!sql->bloccaPer(sql->getDbName()+".scadenze","0")) //.scadenze_n
   {
  	warnbox->setText(tr("La sezione scadenze è occupata da un'altro utente.\nRiprova più tardi."));
 	  warnbox->exec();
 	  sql->disconnetti();
 	  menuPrincipale();
 	  return;
   }
 	barra->sistemaBarra("scadenze");
 	addSca->show();
 	addSca->setAzione(ARSCADENZA_ADD);
 	addSca->settaFormAdd();
 }

void ARFinestra::visScadenze()
 {
 	hideAll();
 	barra->sistemaBarra("scadenze");
 	griSca->show();
 	griSca->visScadenze();
 }

void ARFinestra::addFattura()
 {
 	hideAll();
  // Entro nella sezione critica
  sql->connetti();
  if(!sql->bloccaPer(sql->getDbName()+".fatture","0"))
   {
  	warnbox->setText(tr("La sezione fatture è occupata da un'altro utente.\nRiprova più tardi."));
 	  warnbox->exec();
 	  sql->disconnetti();
 	  menuPrincipale();
 	  return;
   }
 	if(!addFat->populateCli(""))
 	 {
   	infobox->setText(tr("Nessun cliente trovato!\nPer creare una fattura\nè necessario inserire almeno un cliente!"));
 	  infobox->exec();
 	  menuPrincipale();
 	  return;
 	 }
 	addFat->aggiorna->setEnabled(true);
  addFat->aggiungi->setEnabled(true);
  addFat->esegui->setEnabled(true);
  addFat->estampa->setEnabled(true);
  addFat->escludi->setEnabled(true);
  addFat->oggi->setEnabled(true);
  addFat->aggiungi->setEnabled(true);
  addFat->numero->setEnabled(true);
	addFat->cornice->setEnabled(true);
  addFat->tipologia->setEnabled(true);
  addFat->scontrino->setEnabled(true);
  addFat->note->setEnabled(true);
  addFat->addCMnu->setEnabled(true);
  addFat->serCMnu->setEnabled(true);
  addFat->table->setEnabled(true);
  addFat->stampa->setVisible(false);
 	barra->sistemaBarra("fatture");
 	addFat->show();
 	addFat->setAzione(ARFATTURA_ADD);
 	addFat->setSrcTable(scarico->table);//???
  addFat->clearForm();
  addFat->settaFormAdd();
 }

void ARFinestra::visFatture()
 {
 	hideAll();
 	barra->sistemaBarra("fatture");
 	griFat->show();
 	griFat->visFatture();
 }

void ARFinestra::addTipoArt()
 {
 	hideAll();
 	barra->sistemaBarra("tipologie");
 	addTiArt->show();
 	addTiArt->setAzione(ARTIPOARTICOLO_ADD);
 	addTiArt->esegui->setText(tr("Crea"));
 	addTiArt->esegui->setIcon(QIcon("pic/tipi_add.png"));
 	addTiArt->cornice->setTitle(tr("Crea nuova tipologia articoli "));
  addTiArt->clearForm();
 }

void ARFinestra::visTipoArt()
 {
 	hideAll();
 	barra->sistemaBarra("tipologie");
 	griTiArt->show();
 	griTiArt->visTipoArt();
 }

void ARFinestra::addColore()
 {
 	hideAll();
 	barra->sistemaBarra("colori");
 	addOpt->show();
 	addOpt->setAzione(AROPTION_ADD);
 	addOpt->setTabella("colori");
 	addOpt->esegui->setText(tr("Inserisci"));
 	addOpt->esegui->setIcon(QIcon("pic/colori_add.png"));
 	addOpt->cornice->setTitle(tr("Inserisci nuovo colore "));
  addOpt->clearForm();
 }

void ARFinestra::visColori()
 {
 	hideAll();
 	barra->sistemaBarra("colori");
 	griOpt->setTabella("colori");
 	griOpt->setNomeID("coloreID");
 	griOpt->show();
 	griOpt->visOption();
 	addOpt->setTabella("colori");
 	addOpt->setNomeID("coloreID");
 }

void ARFinestra::addFondo()
 {
 	hideAll();
 	barra->sistemaBarra("fondi");
 	addOpt->show();
 	addOpt->setAzione(AROPTION_ADD);
 	addOpt->setTabella("fondi");
 	addOpt->esegui->setText(tr("Inserisci"));
 	addOpt->esegui->setIcon(QIcon("pic/fondi_add.png"));
 	addOpt->cornice->setTitle(tr("Inserisci nuovo fondo "));
  addOpt->clearForm();
 }

void ARFinestra::visFondi()
 {
 	hideAll();
 	barra->sistemaBarra("fondi");
 	griOpt->setTabella("fondi");
 	griOpt->setNomeID("fondoID");
 	griOpt->show();
 	griOpt->visOption();
 	addOpt->setTabella("fondi");
 	addOpt->setNomeID("fondoID");
 }

void ARFinestra::addTacco()
 {
 	hideAll();
 	barra->sistemaBarra("tacchi");
 	addOpt->show();
 	addOpt->setAzione(AROPTION_ADD);
 	addOpt->setTabella("tacchi");
 	addOpt->esegui->setText(tr("Inserisci"));
 	addOpt->esegui->setIcon(QIcon("pic/tacchi_add.png"));
 	addOpt->cornice->setTitle(tr("Inserisci nuovo tacco "));
  addOpt->clearForm();
 }

void ARFinestra::visTacchi()
 {
 	hideAll();
 	barra->sistemaBarra("tacchi");
 	griOpt->setTabella("tacchi");
 	griOpt->setNomeID("taccoID");
 	griOpt->show();
 	griOpt->visOption();
 	addOpt->setTabella("tacchi");
 	addOpt->setNomeID("taccoID"); 	
 }

void ARFinestra::addStagione()
 {
 	hideAll();
 	barra->sistemaBarra("stagioni");
 	addOpt->show();
 	addOpt->setAzione(AROPTION_ADD);
 	addOpt->setTabella("stagioni");
 	addOpt->esegui->setText(tr("Inserisci"));
 	addOpt->esegui->setIcon(QIcon("pic/stagioni_add.png"));
 	addOpt->cornice->setTitle(tr("Inserisci nuova stagione "));
  addOpt->clearForm();
 }

void ARFinestra::visStagioni()
 {
 	hideAll();
 	barra->sistemaBarra("stagioni");
 	griOpt->setTabella("stagioni");
 	griOpt->setNomeID("stagioneID");
 	griOpt->show();
 	griOpt->visOption();
 	addOpt->setTabella("stagioni");
 	addOpt->setNomeID("stagioneID"); 	
 }

void ARFinestra::addServizio()
 {
 	hideAll();
 	barra->sistemaBarra("servizi");
 	addSer->show();
 	addSer->setAzione(ARSERVIZIO_ADD);
 	addSer->esegui->setText(tr("Inserisci"));
 	addSer->esegui->setIcon(QIcon("pic/servizi_add.png"));
 	addSer->cornice->setTitle(tr("Inserisci nuovo servizio "));
  addSer->clearForm();
 }

void ARFinestra::visServizi()
 {
 	hideAll();
 	barra->sistemaBarra("servizi");
 	griSer->show();
 	griSer->visServizi();
 }

void ARFinestra::visStatistiche(int t)
 {
  if(stat->setForm(t))
 	 {
 	 	hideAll();
 	 	barra->sistemaBarra("statistiche");
    stat->show();
   }
  else
   {
    infobox->setText(tr("Nessuna statistica disponibile!"));
 	  infobox->exec();
   }
 }

void ARFinestra::visStatAndamenti()   { visStatistiche(1); }

void ARFinestra::visStatStatistiche() { visStatistiche(2); }

void ARFinestra::prefStampe()
 {
 	pstampebox->loadPrefStampa();
 	pstampebox->exec();
 }

void ARFinestra::prefMisc()
 {
 	prefbox->loadPref();
 	prefbox->exec();
 }

void ARFinestra::stampaEtichette() { stampe->stampaEtichette(scarico->table); }

void ARFinestra::stampaMagazzino() { stampe->stampaMagazzino(scarico->table);  }

void ARFinestra::stampaIntestAzi() { stampe->stampaIntestAzi(NULL);/*Passare qui una futura griAzi->table*/ }

void ARFinestra::stampaIntestFor() { stampe->stampaIntestFor(griFor->table);  }

void ARFinestra::stampaFornitori() { stampe->stampaFornitori(griFor->table);  }
 
void ARFinestra::stampaIntestCli() { stampe->stampaIntestCli(griCli->table);  }

void ARFinestra::stampaClienti()   { stampe->stampaClienti(griCli->table);    }

void ARFinestra::stampaServizi()   { stampe->stampaServizi(griSer->table);    }

void ARFinestra::closeEvent(QCloseEvent *e)
 {
 	yesnobox->setText(tr("Vuoi veramente uscire dal programma?"));
  if(yesnobox->exec()==QMessageBox::Yes) e->accept(); else e->ignore();
 }

void ARFinestra::resizeEvent(QResizeEvent *e) { settaGeometria(isMaximized()); }

void ARFinestra::Esci()
 {
 	yesnobox->setText(tr("Vuoi veramente uscire dal programma?"));
  if(yesnobox->exec()==QMessageBox::Yes) qApp->quit();
 }

void ARFinestra::disableAll(bool b)
 {
  b=!b;
  newforMnu->setEnabled(b);
  newcliMnu->setEnabled(b);
  newfatMnu->setEnabled(b);
  newbolMnu->setEnabled(b);
  menu2->setEnabled(b); menu3->setEnabled(b);
  menu4->setEnabled(b); menu5->setEnabled(b);
 }

void ARFinestra::hideAll()
 {
 	mainMenu->hide();
 	stat->hide();
 	addAzi->hide();
 	addFor->hide();   griFor->hide();
 	addCli->hide();   griCli->hide();
 	addSer->hide();   griSer->hide();
 	addSca->hide();   griSca->hide();
 	addTiArt->hide(); griTiArt->hide();
 	carico->hide();   addArt->hide();
 	scarico->hide();
 	addOpt->hide();   griOpt->hide();
 	addFat->hide();   griFat->hide();
 	addBol->hide();   griBol->hide();
 	eticMnu->setEnabled(false); stmagMnu->setEnabled(false); ckprezMnu->setEnabled(false);

 	// Esco dalla sezione critica
 	if(sql->isConnesso())
 	 {
 	 	if(!sql->isBloccatoPer(sql->getDbName()+".bolle")) sql->doQueryPer("SELECT RELEASE_LOCK('"+sql->getDbName()+".bolle')");
 	 	if(!sql->isBloccatoPer(sql->getDbName()+".fatture")) sql->doQueryPer("SELECT RELEASE_LOCK('"+sql->getDbName()+".fatture')");	
 	 	// .scadenze_n
 	 	if(!sql->isBloccatoPer(sql->getDbName()+".scadenze")) sql->doQueryPer("SELECT RELEASE_LOCK('"+sql->getDbName()+".scadenze')");
 	 	// .carico_n
 	 	if(!sql->isBloccatoPer(sql->getDbName()+".carico")) sql->doQueryPer("SELECT RELEASE_LOCK('"+sql->getDbName()+".carico')");
 	 	sql->disconnetti();
   }
 }

void ARFinestra::hidePrezzo(bool b)
 {
  scarico->hidePrezzo(b);
  ckprezMnu->setChecked(scarico->dettagli);
 }

void ARFinestra::backupDb()
 {
  backupbox->exec();
 }


void ARFinestra::mostraCalcolatrice()
 {
  QProcess calc;
  QString sep = QDir::separator();

  #ifdef WIN32
  calc.startDetached("calc");
  #endif

  #ifdef linux
  calc.startDetached("gcalctool");
  #endif
 }

void ARFinestra::mostraRubrica()
 {
  QProcess rubr;
  QString sep = QDir::separator();

  rubr.startDetached("\"C:"+sep+"Programmi"+sep+"Outlook Express"+sep+"wab.exe\"");
 }

void ARFinestra::mostraManuale()
 {
  QProcess man;
  QString sep = QDir::separator();

  man.startDetached("\"C:"+sep+"Programmi"+sep+"Internet Explorer"+sep+"IEXPLORE.EXE\" \""+QDir::currentPath()+sep+"docs"+sep+"it"+sep+"index.html\"");
 }

void ARFinestra::mostraAbout() { about->exec(); }

ARFornitore *ARFinestra::prendiAddFor() { return addFor; }

// Funzioni interclassi
void ARFinestra::editFornitore()
 {
  if(griFor->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun fornitore selezionato."));
    warnbox->exec();
   }
  else
   {
   	QString fornitoreID;
    fornitoreID=griFor->table->item(griFor->table->currentRow(),0)->text();
  	if(addFor->setForm(fornitoreID))
 	   {
 	    hideAll();
      addFor->setAzione(ARFORNITORE_EDIT);
      addFor->setFornitoreID(fornitoreID);
      addFor->visIndirReso();
      addFor->settaFormEdit();
      addFor->show();
     }
    else
     {
      infobox->setText(tr("Fornitore inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editCliente()
 {
  if(griCli->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun cliente selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString clienteID;
    clienteID=griCli->table->item(griCli->table->currentRow(),0)->text();
  	if(addCli->setForm(clienteID))
 	   {
 	   	hideAll();
      addCli->setAzione(ARCLIENTE_EDIT);
   	  addCli->show();
 	    addCli->esegui->setText(tr("Salva modifiche"));
 	    addCli->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addCli->cornice->setTitle(tr("Visualizza cliente "));
 	    addCli->setClienteID(clienteID);
     }
    else
     {
      infobox->setText(tr("Cliente inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editTipoArt()
 {
  if(griTiArt->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna tipologia di articoli selezionata."));
 	  warnbox->exec();
   }
  else
   {
   	QString tipo_articoloID;
   	
 	  hideAll();
   	// Entro nella sezione critica
    sql->connetti();
    if(!sql->isBloccatoPer(sql->getDbName()+".carico")) //.carico_n
     {
      warnbox->setText(tr("Un'altro utente sta occupando la sezione tipologia articoli,\nnon posso modificare la tipologia adesso. Riprova più tardi."));
 	    warnbox->exec();
      sql->disconnetti();
      menuPrincipale();
      return;
     }
    sql->disconnetti();
    tipo_articoloID=griTiArt->table->item(griTiArt->table->currentRow(),0)->text();
  	if(addTiArt->setForm(tipo_articoloID))
 	   {
      addTiArt->setAzione(ARTIPOARTICOLO_EDIT);
   	  addTiArt->show();
 	    addTiArt->esegui->setText(tr("Salva modifiche"));
 	    addTiArt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addTiArt->cornice->setTitle(tr("Visualizza fornitore "));
 	    addTiArt->setTipoArticoloID(tipo_articoloID);
     }
    else
     {
      infobox->setText(tr("Tipologia di articolo inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editArticolo()
 {
  if(scarico->numRowSel()!=1) // Non posso visualizzare/editare più di un articolo alla volta
   {
    if(scarico->numRowSel()>1) warnbox->setText(tr("Devi selezionare solo un articolo."));
    else              warnbox->setText(tr("Nessun articolo selezionato."));
 	  warnbox->exec();
    return;
   }
  else
   {
   	QString articoloID;
    articoloID=scarico->table->item(scarico->currRowSel(),0)->text();
  	if(addArt->setForm(articoloID,scarico->listaMostra->itemData(scarico->listaMostra->currentIndex()).toString()))
 	   {
 	   	hideAll();
      addArt->setAzione(ARARTICOLO_EDIT);
   	  addArt->show();
 	    addArt->esegui->setText(tr("Salva modifiche"));
 	    addArt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addArt->cornice->setTitle(tr("Visualizza articolo "));
 	    addArt->setArticoloID(articoloID);
 	    addArt->populateListe();
     }
    else
     {
      infobox->setText(tr("Articolo inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editOpzione()
 {
 	if(griOpt->getTabella()=="colori")   editColore();
 	if(griOpt->getTabella()=="fondi")    editFondo();
 	if(griOpt->getTabella()=="tacchi")   editTacco();
 	if(griOpt->getTabella()=="stagioni") editStagione();
 }

void ARFinestra::editColore()
 {
  if(griOpt->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun colore selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString optionID;
    optionID=griOpt->table->item(griOpt->table->currentRow(),0)->text();
  	if(addOpt->setForm(optionID))
 	   {
      hideAll();
      addOpt->setAzione(AROPTION_EDIT);
   	  addOpt->show();
 	    addOpt->esegui->setText(tr("Salva modifiche"));
 	    addOpt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addOpt->cornice->setTitle(tr("Visualizza colore "));
 	    addOpt->setOptionID(optionID);
     }
    else
     {
      infobox->setText(tr("Colore inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editFondo()
 {
  if(griOpt->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun fondo selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString optionID;
    optionID=griOpt->table->item(griOpt->table->currentRow(),0)->text();
  	if(addOpt->setForm(optionID))
 	   {
      hideAll();
      addOpt->setAzione(AROPTION_EDIT);
   	  addOpt->show();
 	    addOpt->esegui->setText(tr("Salva modifiche"));
 	    addOpt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addOpt->cornice->setTitle(tr("Visualizza fondo "));
 	    addOpt->setOptionID(optionID);
     }
    else
     {
      infobox->setText(tr("Fondo inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editTacco()
 {
  if(griOpt->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun tacco selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString optionID;
    optionID=griOpt->table->item(griOpt->table->currentRow(),0)->text();
  	if(addOpt->setForm(optionID))
 	   {
 	   	hideAll();
      addOpt->setAzione(AROPTION_EDIT);
   	  addOpt->show();
 	    addOpt->esegui->setText(tr("Salva modifiche"));
 	    addOpt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addOpt->cornice->setTitle(tr("Visualizza tacco "));
 	    addOpt->setOptionID(optionID);
     }
    else
     {
      infobox->setText(tr("Tacco inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editStagione()
 {
  if(griOpt->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna stagione selezionata."));
 	  warnbox->exec();
   }
  else
   {
   	QString optionID;
   	optionID=griOpt->table->item(griOpt->table->currentRow(),0)->text();
  	if(addOpt->setForm(optionID))
 	   {
      hideAll();
      addOpt->setAzione(AROPTION_EDIT);
   	  addOpt->show();
 	    addOpt->esegui->setText(tr("Salva modifiche"));
 	    addOpt->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addOpt->cornice->setTitle(tr("Visualizza stagione "));
 	    addOpt->setOptionID(optionID);
     }
    else
     {
      infobox->setText(tr("Stagione inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editServizio()
 {
  if(griSer->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun servizio selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString servizioID;
    servizioID=griSer->table->item(griSer->table->currentRow(),0)->text();
  	if(addSer->setForm(servizioID))
 	   {
 	   	hideAll();
      addSer->setAzione(ARSERVIZIO_EDIT);
   	  addSer->show();
 	    addSer->esegui->setText(tr("Salva modifiche"));
 	    addSer->esegui->setIcon(QIcon("pic/floppy.png"));
 	    addSer->cornice->setTitle(tr("Visualizza servizio "));
 	    addSer->setServizioID(servizioID);
     }
    else
     {
      infobox->setText(tr("Servizio inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::editFattura()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString aux;

  if(griFat->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna fattura selezionata."));
 	  warnbox->exec();
   }
  else
   {
   	QString fatturaID;

   	hideAll();
    // Entro nella sezione critica
    sql->connetti();
    if(!sql->bloccaPer(sql->getDbName()+".fatture","0"))
     {
	    warnbox->setText(tr("La sezione fatture è occupata da un'altro utente.\nRiprova più tardi."));
      warnbox->exec();
      sql->disconnetti();
      menuPrincipale();
      return;
     }
    fatturaID=griFat->table->item(griFat->table->currentRow(),0)->text();
  	if(addFat->setForm(fatturaID))
 	   {
      // Si puo' modificare solo l'ultima fattura inserita
      rs=sql->doQueryRSPer("SELECT max(fatturaID) AS max FROM fatture");
      if(rs)
       {
        row=mysql_fetch_row(rs);  
        aux=row[0];
        if(aux!=fatturaID) // La fattura non è modificabile
         {
          addFat->aggiorna->setEnabled(false);
 	   	    addFat->aggiungi->setEnabled(false);
 	   	    addFat->esegui->setEnabled(false);
 	   	    addFat->estampa->setEnabled(false);
 	   	    addFat->escludi->setEnabled(false);
 	   	    addFat->oggi->setEnabled(false);
 	   	    addFat->aggiungi->setEnabled(false);
 	   	    addFat->numero->setEnabled(false);
 	   	    addFat->cornice->setEnabled(false);
 	   	    addFat->tipologia->setEnabled(false);
 	   	    addFat->scontrino->setEnabled(false);
 	   	    addFat->note->setEnabled(false);
 	   	    addFat->addCMnu->setEnabled(false);
 	   	    addFat->serCMnu->setEnabled(false);
 	   	    addFat->table->setEnabled(false);
 	   	    addFat->stampa->setVisible(true);
         }
        else
         {
         	addFat->aggiorna->setEnabled(true);
 	   	    addFat->aggiungi->setEnabled(true);
 	   	    addFat->esegui->setEnabled(true);
 	   	    addFat->estampa->setEnabled(true);
 	   	    addFat->escludi->setEnabled(true);
 	   	    addFat->oggi->setEnabled(true);
 	   	    addFat->aggiungi->setEnabled(true);
 	   	    addFat->numero->setEnabled(true);
 	   	    addFat->cornice->setEnabled(true);
 	   	    addFat->tipologia->setEnabled(true);
 	   	    addFat->scontrino->setEnabled(true);
 	   	    addFat->note->setEnabled(true);
 	   	    addFat->addCMnu->setEnabled(true);
 	   	    addFat->serCMnu->setEnabled(true);
 	   	    addFat->table->setEnabled(true);
 	   	    addFat->stampa->setVisible(false);
         }

        mysql_free_result(rs);
       }

      addFat->setAzione(ARFATTURA_EDIT);
   	  addFat->show();
 	    addFat->setFatturaID(fatturaID);
 	    addFat->populateTable(fatturaID);
 	    addFat->settaFormEdit();
     }
    else
     {
      infobox->setText(tr("Fattura inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::addPrintFattura()
 {
 	if(addFat->addFattura()) stampe->stampaFattura(addFat->getPrintFatturaID());
 }

void ARFinestra::printFattura()
 {
 	if(griFat->table->currentRow()>=0)
 	 {
 	  stampe->stampaFattura(griFat->table->item(griFat->table->currentRow(),0)->text());
 	 }
 	else
 	 {
 	 	infobox->setText(tr("Nessuna fattura selezionata!\nSelezionare una fattura!"));
 	  infobox->exec();
 	 }
 }

void ARFinestra::printFatturaSalvata()
 {
 	QString fatturaID;
 	
 	fatturaID=addFat->getFatturaID();
  stampe->stampaFattura(fatturaID);
 }

void ARFinestra::editBolla()
 {
  if(griBol->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun documento di trasporto selezionato."));
 	  warnbox->exec();
   }
  else
   {
   	QString bollaID;

 	  hideAll();
 	  // Entro nella sezione critica
    sql->connetti();
    if(!sql->bloccaPer(sql->getDbName()+".bolle","0")) 
     {
  	  warnbox->setText(tr("La sezione documenti di trasporto è occupata da un'altro utente.\nRiprova più tardi."));
 	    warnbox->exec();
 	    sql->disconnetti();
 	    menuPrincipale();
 	    return;
     }
    bollaID=griBol->table->item(griBol->table->currentRow(),0)->text();
  	if(addBol->setForm(bollaID))
 	   {
      addBol->setAzione(ARBOLLA_EDIT);
   	  addBol->show();
 	    addBol->setBollaID(bollaID);
 	    addBol->populateTable(bollaID);
 	    addBol->settaFormEdit();
     }
    else
     {
      infobox->setText(tr("Documento di trasporto inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

void ARFinestra::addPrintBolla()
 {
 	if(addBol->addBolla()) stampe->stampaBolla(addBol->getPrintBollaID());
 }

void ARFinestra::printBolla()
 {
 	if(griBol->table->currentRow()>=0)
 	 {
 	  stampe->stampaBolla(griBol->table->item(griBol->table->currentRow(),0)->text());
 	 }
 	else
 	 {
 	 	infobox->setText(tr("Nessuna documento di trasporto selezionato!\nSelezionare un documento di trasporto!"));
 	  infobox->exec();
 	 }
 }

void ARFinestra::editScadenza()
 {
  if(griSca->table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna scadenza selezionata."));
 	  warnbox->exec();
   }
  else
   {
   	QString scadenzaID;

 	  hideAll();
    scadenzaID=griSca->table->item(griSca->table->currentRow(),0)->text();
  	if(addSca->setForm(scadenzaID))
 	   {
      addSca->setAzione(ARSCADENZA_EDIT);
   	  addSca->show();
 	    addSca->setScadenzaID(scadenzaID);
 	    addSca->settaFormEdit();
     }
    else
     {
      infobox->setText(tr("Scadenza inesistente!"));
 	    infobox->exec();
     }
 	 }
 }

bool ARFinestra::passwordChecked() { return ckprezMnu->isChecked(); }

ARScarico *ARFinestra::getARScaricoP() { return scarico; }
