#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QLabel>
#include <QMessageBox>
#include <QMenu>
#include <QAction>
#include <QContextMenuEvent>
#include <QDate>

#include "ARsql.h"

#include "ARGrigliaBol.h"

ARGrigliaBol::ARGrigliaBol(QWidget *parent) : QWidget(parent)
 {
 	num_col=14;
 	sql = new ARsql(this);
  infobox    = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox    = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox   = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice    = new QGroupBox(tr("Ricerca documento di trasporto "),this);

  _dest      = new QLabel(tr("Destinatario"),cornice); _dest->setGeometry     (  6, 15, 80, 24);
  listaFor   = new QComboBox(cornice);                 listaFor->setGeometry  ( 70, 15,220, 24);
  _causale   = new QLabel(tr("Causale"),cornice);      _causale->setGeometry  (295, 15, 80, 24);
  causale    = new QLineEdit("",cornice);              causale->setGeometry   (340, 15,160, 24);
  causale->setMaxLength(255);
  _mezzo     = new QLabel(tr("A mezzo"),cornice);      _mezzo->setGeometry    (508, 15, 80, 24);
  listaMezzo = new QComboBox(cornice);                 listaMezzo->setGeometry(555, 15,134, 24);
  listaMezzo->addItem(tr("TUTTI I MEZZI"),QVariant("0"));
  listaMezzo->addItem(tr("Mittente"),QVariant("1"));
  listaMezzo->addItem(tr("Vettore"),QVariant("2"));
  listaMezzo->addItem(tr("Destinatario"),QVariant("3"));  
  _aspetto   = new QLabel(tr("Aspetto beni"),cornice); _aspetto->setGeometry  (  6, 45, 80, 24);
  aspetto    = new QLineEdit("",cornice);              aspetto->setGeometry   ( 70, 45,168, 24);
  aspetto->setMaxLength(255);
  _colli     = new QLabel(tr("N. colli"),cornice);     _colli->setGeometry    (248, 45, 80, 24);
  colli      = new QLineEdit("",cornice);              colli->setGeometry     (288, 45, 70, 24);
  colli->setMaxLength(255);
  _peso_kg   = new QLabel(tr("Peso kg."),cornice);     _peso_kg->setGeometry  (368, 45, 80, 24);
  peso_kg    = new QLineEdit("",cornice);              peso_kg->setGeometry   (415, 45, 85, 24);
  peso_kg->setMaxLength(255);
  _porto     = new QLabel(tr("Porto"),cornice);        _porto->setGeometry    (508, 45, 80, 24);
  listaPorto = new QComboBox(cornice);                 listaPorto->setGeometry(555, 45,134, 24);
  listaPorto->addItem(tr("TUTTI"),QVariant("0"));
  listaPorto->addItem(tr("Franco"),QVariant("1"));
  listaPorto->addItem(tr("Assegnato"),QVariant("2"));
  _vettore   = new QLabel(tr("Vettore"),cornice);      _vettore->setGeometry  (  6, 75, 80, 24);
  vettore    = new QLineEdit("",cornice);              vettore->setGeometry   ( 70, 75,180, 24);
  vettore->setMaxLength(255);

 	edit      = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
 	del       = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
  stampa    = new QPushButton(QIcon("pic/tabulati.png"),tr("Stampa"),this);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(503,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20); table->hideColumn(0);
 	table->setColumnWidth(1,55);
 	table->setColumnWidth(2,70);
 	table->setColumnWidth(3,220);
 	table->setColumnWidth(4,70);
 	table->setColumnWidth(5,130);
 	table->setColumnWidth(6,130);
 	table->setColumnWidth(7,50);
 	table->setColumnWidth(8,50);
 	table->setColumnWidth(9,70);
 	table->setColumnWidth(10,120);
 	table->setColumnWidth(11,200);
 	table->setColumnWidth(12,10); table->hideColumn(12);
 	table->setColumnWidth(13,10); table->hideColumn(13);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Numero" << "Del" << "Destinatario" << "A mezzo" << "Causale" << "Aspetto beni" << "N. colli" << "Peso" << "Porto" << "Vettore" << "Note");

 	editCMnu=new QAction(QIcon("pic/edit.png"),tr("Visualizza il D.D.T. selezionato"),this);
 	delCMnu=new QAction(QIcon("pic/delete.png"),tr("Cancella il D.D.T. selezionato"),this);
 	
 	//connect(del,SIGNAL(clicked()),this,SLOT(delBolle()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visBolle()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
 	connect(listaFor,SIGNAL(activated(int)),this,SLOT(visBolle(int)));
  connect(causale,SIGNAL(returnPressed()),this,SLOT(visBolle()));
  connect(listaMezzo,SIGNAL(activated(int)),this,SLOT(visBolle(int)));
  connect(aspetto,SIGNAL(returnPressed()),this,SLOT(visBolle()));
  connect(colli,SIGNAL(returnPressed()),this,SLOT(visBolle()));
  connect(peso_kg,SIGNAL(returnPressed()),this,SLOT(visBolle()));
  connect(listaPorto,SIGNAL(activated(int)),this,SLOT(visBolle(int)));
  connect(vettore,SIGNAL(returnPressed()),this,SLOT(visBolle()));
  // Menu contestuale
  //connect(delCMnu,SIGNAL(triggered()),this,SLOT(delBolle()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaBol::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry(0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry   (704,alt-213,96,24);
  del->setGeometry    (704,alt-188,96,24);
  stampa->setGeometry (704,alt-163,96,48);
 }

void ARGrigliaBol::visBolle(int) { visBolle(); }

void ARGrigliaBol::visBolle()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString bollaID,fornitoreID,indir_resoID;
 	QString query,mezzo,causale,aspetto,colli,peso_kg,porto,vettore,note,data_bolla;
 	bool primo;
 	int r;
 	
 	populateFor(listaFor->itemData(listaFor->currentIndex()).toString());
 	table->setRowCount(0);
 	r=0; primo=true;
 	query ="SELECT bolle.bollaID,bolle.fornitoreID,bolle.indir_resoID,bolle.data_bolla,bolle.mezzo,bolle.causale,bolle.aspetto,bolle.colli,bolle.peso_kg,bolle.porto,bolle.vettore1,bolle.vettore2,bolle.vettore3,bolle.note,bolle.numero,";
  query+="       fornitori.nome,fornitori.indirizzo,fornitori.cap,fornitori.citta,fornitori.provincia,fornitori.nazione ";
  query+="FROM   bolle,fornitori";

 	fornitoreID = listaFor->itemData(listaFor->currentIndex()).toString();
 	causale     = quote(this->causale->text(),true);
 	mezzo       = listaMezzo->itemData(listaMezzo->currentIndex()).toString();
 	aspetto     = quote(this->aspetto->text(),true);
 	colli       = quote(this->colli->text(),true);
 	peso_kg     = quote(this->peso_kg->text(),true);
 	porto       = listaPorto->itemData(listaPorto->currentIndex()).toString();
 	vettore     = quote(this->vettore->text(),true);
 	if(fornitoreID!="0") { if(primo) { query+=" WHERE bolle.fornitoreID='"+fornitoreID+"'"; primo=false; } else { query+=" AND fornitoreID='"+fornitoreID+"'"; } }
 	if(causale!="")      { if(primo) { query+=" WHERE causale LIKE '%"+causale+"%'"; primo=false; } else { query+=" AND causale LIKE '%"+causale+"%'"; } }
 	if(mezzo!="0")       { if(primo) { query+=" WHERE mezzo='"+mezzo+"'"; primo=false; } else { query+=" AND mezzo='%"+mezzo+"%'"; } }
 	if(aspetto!="")      { if(primo) { query+=" WHERE aspetto LIKE '%"+aspetto+"%'"; primo=false; } else { query+=" AND aspetto LIKE '%"+aspetto+"%'"; } }
 	if(colli!="")        { if(primo) { query+=" WHERE colli LIKE '%"+colli+"%'"; primo=false; } else { query+=" AND colli LIKE '%"+colli+"%'"; } }
 	if(peso_kg!="")      { if(primo) { query+=" WHERE peso_kg LIKE '%"+peso_kg+"%'"; primo=false; } else { query+=" AND peso_kg LIKE '%"+peso_kg+"%'"; } }
 	if(porto!="0")       { if(primo) { query+=" WHERE porto='"+porto+"'"; primo=false; } else { query+=" AND porto='"+porto+"'"; } }
 	if(vettore!="")      { if(primo) { query+=" WHERE (vettore1 LIKE '%"+vettore+"%' OR vettore2 LIKE '%"+vettore+"%' OR vettore3 LIKE '%"+vettore+"%')"; primo=false; } else { query+=" AND (vettore1 LIKE '%"+vettore+"%' OR vettore2 LIKE '%"+vettore+"%' OR vettore3 LIKE '%"+vettore+"%')"; } }
 	if(primo) { query+=" WHERE bolle.fornitoreID=fornitori.fornitoreID"; primo=false; } else { query+=" AND bolle.fornitoreID=fornitori.fornitoreID"; }
 	query+=" ORDER BY bolle.bollaID DESC";
 	rs=sql->doQueryRS(query);
 	
 	QString a_indr,a_cap,a_citta,a_prov,a_piva,a_cf;
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);

      //a_indr=row[2]; a_cap=row[3]; a_citta=row[4]; a_prov=row[5];
   	  //a_indr=a_indr+"   "+a_cap+" "+a_citta;
   	  //if(a_prov!="") a_indr+=" ("+a_prov+")";
   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[14]));
   	  data_bolla=row[3];
   	  QDate aux_date=QDate::fromString(data_bolla,"yyyy-MM-dd");
   	  data_bolla=aux_date.toString("dd-MMM-yyyy");
   	  table->setItem(r,2,inserisciRiga(data_bolla));
   	  table->setItem(r,3,inserisciRiga(row[15]));
   	  mezzo=row[4];
   	  if(mezzo=="1") mezzo=tr("Mittente");
   	  if(mezzo=="2") mezzo=tr("Vettore");
   	  if(mezzo=="3") mezzo=tr("Destinatario");
   	  table->setItem(r,4,inserisciRiga(mezzo));
   	  table->setItem(r,5,inserisciRiga(row[5]));
   	  table->setItem(r,6,inserisciRiga(row[6]));
   	  table->setItem(r,7,inserisciRiga(row[7]));
   	  table->setItem(r,8,inserisciRiga(row[8]));
   	  porto=row[9];
   	  if(porto=="1") porto=tr("Franco");
   	  if(porto=="2") porto=tr("Assegnato");
   	  table->setItem(r,9,inserisciRiga(porto));
   	  table->setItem(r,10,inserisciRiga(QString(row[10])+" "+row[11]+" "+row[12]));
   	  table->setItem(r,11,inserisciRiga(row[13])); // note	  
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessun documento di trasporto trovato!"));
 	      infobox->exec();
 	     }
     }
   }
 }

void ARGrigliaBol::delBolle()
 {
 	MYSQL_RES *rs;
 	QString bollaID;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessun documento di trasporto selezionato."));
 	  warnbox->exec();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare il bolla?"));
  if(yesnobox->exec()==QMessageBox::No) return;
  bollaID=table->item(table->currentRow(),0)->text();
  rs=sql->doQueryRS("SELECT * FROM articoli WHERE bollaID='"+bollaID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)==0)
     {
   	  sql->doQuery("DELETE FROM clienti WHERE bollaID='"+bollaID+"'");
      infobox->setText(tr("Cliente cancellato!"));
      infobox->exec();
      visBolle();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare il bolla poich\nsono presenti, in magazzino, articoli da lui acquistati."));
      warnbox->exec();
     }
    mysql_free_result(rs);
   }
 }

void ARGrigliaBol::resRicerca()
 {
 	populateFor("0");
 	causale->clear();
 	listaMezzo->setCurrentIndex(0);
 	aspetto->clear();
 	colli->clear();
 	peso_kg->clear();
 	listaPorto->setCurrentIndex(0);
 	vettore->clear();
 	visBolle();
 }

bool ARGrigliaBol::populateFor(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString aux;
 	
 	listaFor->clear();
 	listaFor->addItem(tr("TUTTI I FORNITORI"),QVariant(0));
 	rs=sql->doQueryRS("SELECT fornitoreID,nome FROM fornitori ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaFor->addItem(row[1],QVariant(row[0]));
   	  r++;
     	aux=row[0]; if(aux==val) v=r;
     }
    mysql_free_result(rs);
   }
  listaFor->setCurrentIndex(v);
  return r;
 }

void ARGrigliaBol::contextMenuEvent(QContextMenuEvent *event)
 {
  QMenu menu(this);
  menu.addAction(editCMnu);
  menu.addAction(delCMnu);
  menu.exec(event->globalPos());
 }

QTableWidgetItem *ARGrigliaBol::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARGrigliaBol::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QString ARGrigliaBol::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
