#ifndef ARGRIGLIABOL_H
#define ARGRIGLIABOL_H

#include <QWidget>

class QTableWidget;
class QGroupBox;
class QTableWidgetItem;
class QPushButton;
class QLineEdit;
class QComboBox;
class QLabel;
class QMessageBox;
class QMenu;
class QAction;
class QContextMenuEvent;
class QDate;

class ARsql;

class ARGrigliaBol : public QWidget
 {
  Q_OBJECT

  public:
   QTableWidget *table;
   QPushButton *edit,*del,*search,*reset,*stampa;
   QLineEdit *causale,*aspetto,*colli,*peso_kg,*vettore;
   QAction *editCMnu,*delCMnu;
   QComboBox *listaFor,*listaMezzo,*listaPorto;
   
   ARGrigliaBol(QWidget *parent = 0);
   void settaGeometria(int,int);
   QTableWidgetItem *inserisciRiga(QString);
   QTableWidgetItem *inserisciRiga(const char *);
   bool populateFor(QString);

  public slots:
   void visBolle(int);
   void visBolle();
   void delBolle();
   void resRicerca();

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   int num_col;
   ARsql *sql;
   QMessageBox *infobox,*warnbox,*yesnobox;
   QGroupBox *cornice;
   QLabel *_dest,*_causale,*_mezzo,*_aspetto,*_colli,*_peso_kg,*_porto,*_vettore;

   QString quote(QString, bool like = false);
 };

#endif
