#ifndef ARGRIGLIACLI_H
#define ARGRIGLIACLI_H

#include <QWidget>

class QTableWidget;
class QGroupBox;
class QTableWidgetItem;
class QPushButton;
class QLineEdit;
class QLabel;
class QMessageBox;
class QMenu;
class QAction;
class QContextMenuEvent;

class ARFinestra;
class ARsql;

class ARGrigliaCli : public QWidget
 {
  Q_OBJECT

  public:
   QTableWidget *table;
   QPushButton *edit,*del,*search,*reset,*stampa,*stampaint;
   QLineEdit *nome,*indr,*citta,*prov,*tel,*cell,*piva;
   QAction *editCMnu,*delCMnu;
   
   ARGrigliaCli(QWidget *parent = 0);
   void settaGeometria(int,int);
   QTableWidgetItem *inserisciRiga(QString);
   QTableWidgetItem *inserisciRiga(const char *);

  public slots:
   void visClienti();
   void delClienti();
   void resRicerca();

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   int num_col;
   ARFinestra *mainWin;
   ARsql *sql;
   QMessageBox *infobox,*warnbox,*yesnobox;
   QGroupBox *cornice;
   QLabel *_nome,*_indr,*_citta,*_prov,*_tel,*_cell,*_piva;

   QString quote(QString, bool like = false);
 };

#endif
