#include <QTableWidget>
#include <QTableWidgetItem>
#include <QGroupBox>
#include <QPushButton>
#include <QLineEdit>
#include <QComboBox>
#include <QLabel>
#include <QMessageBox>
#include <QMenu>
#include <QAction>
#include <QContextMenuEvent>
#include <QDate>

#include "ARsql.h"

#include "ARGrigliaFat.h"

ARGrigliaFat::ARGrigliaFat(QWidget *parent) : QWidget(parent)
 {
 	num_col=9;
 	sql  = new ARsql(this);
 	sql2 = new ARsql(this);
  infobox    = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
  warnbox    = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
  yesnobox   = new QMessageBox(tr("Scegli"),"",QMessageBox::Question,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,this);
 	cornice    = new QGroupBox(tr("Ricerca Fattura "),this);

  _dest      = new QLabel(tr("Intestatario"),cornice);    _dest->setGeometry     (  6, 15, 80, 24);
  listaCli   = new QComboBox(cornice);                    listaCli->setGeometry  ( 85, 15,240, 24);
  _numero    = new QLabel(tr("Numero"),cornice);          _numero->setGeometry   (332, 15, 80, 24);
  numero     = new QLineEdit("",cornice);                 numero->setGeometry    (377, 15, 70, 24);
  numero->setValidator(new QIntValidator(1,1999999999,numero));
  _tipologia = new QLabel(tr("Tipologia merce"),cornice); _tipologia->setGeometry(452, 15, 80, 24);
  tipologia  = new QLineEdit("",cornice);                 tipologia->setGeometry (535, 15,160, 24);
  tipologia->setMaxLength(255);
  _scontrino = new QLabel(tr("Scontrino num."),cornice);  _scontrino->setGeometry(  6, 45, 80, 24);
  scontrino  = new QLineEdit("",cornice);                 scontrino->setGeometry ( 85, 45,240, 24);
  scontrino->setMaxLength(255);

 	edit      = new QPushButton(QIcon("pic/edit.png"),tr("Visualizza"),this);
 	del       = new QPushButton(QIcon("pic/delete.png"),tr("Cancella"),this);
  stampa    = new QPushButton(QIcon("pic/tabulati.png"),tr("Stampa"),this);
 	reset = new QPushButton(QIcon("pic/no_search.png"),tr("Azzera"),cornice);
  reset->setGeometry(503,83,96,24);
 	search = new QPushButton(QIcon("pic/search.png"),tr("Cerca"),cornice);
  search->setGeometry(601,83,96,24);
 	table = new QTableWidget(this);
  table->setSortingEnabled(true);
  table->setAlternatingRowColors(true);
  table->setEditTriggers(QAbstractItemView::NoEditTriggers);
  table->setSelectionMode(QAbstractItemView::SingleSelection);
  table->setSelectionBehavior(QAbstractItemView::SelectRows);
 	for(int i=0;i<num_col;i++) table->insertColumn(i);
 	table->setColumnWidth(0,20); table->hideColumn(0);
 	table->setColumnWidth(1,70);
 	table->setColumnWidth(2,90);
 	table->setColumnWidth(3,240);
 	table->setColumnWidth(4,180);
 	table->setColumnWidth(5,160);
 	table->setColumnWidth(6,250);
 	table->setColumnWidth(7,10); table->hideColumn(7);
 	table->setColumnWidth(8,10); table->hideColumn(8);
 	table->setHorizontalHeaderLabels(QStringList() << "ID" << "Numero" << "Del" << "Intestatario" << "Tipologia merce" << "Scontrino numero" << "Note");

 	editCMnu=new QAction(QIcon("pic/edit.png"),tr("Visualizza la fattura selezionata"),this);
 	delCMnu=new QAction(QIcon("pic/delete.png"),tr("Cancella la fattura selezionata"),this);

 	connect(del,SIGNAL(clicked()),this,SLOT(delFatture()));
 	connect(search,SIGNAL(clicked()),this,SLOT(visFatture()));
 	connect(reset,SIGNAL(clicked()),this,SLOT(resRicerca()));
 	connect(listaCli,SIGNAL(activated(int)),this,SLOT(visFatture(int)));
 	connect(numero,SIGNAL(returnPressed()),this,SLOT(visFatture()));
  connect(tipologia,SIGNAL(returnPressed()),this,SLOT(visFatture()));
  connect(scontrino,SIGNAL(returnPressed()),this,SLOT(visFatture()));
  //connect(listaPorto,SIGNAL(activated(int)),this,SLOT(visFatture(int)));
  // Menu contestuale
  connect(delCMnu,SIGNAL(triggered()),this,SLOT(delFatture()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
 	yesnobox->setWindowModality(Qt::WindowModal);
 	yesnobox->setButtonText(QMessageBox::Yes,tr("Si"));
 	yesnobox->setButtonText(QMessageBox::No,tr("No"));
  hide();
 }

void ARGrigliaFat::settaGeometria(int lar, int alt)
 {
  setGeometry(0,61,lar,alt-70);
 	table->setGeometry(0,0,lar,alt-220);
 	cornice->setGeometry(2,alt-222,700,110);
  edit->setGeometry   (704,alt-213,96,24);
  del->setGeometry    (704,alt-188,96,24);
  stampa->setGeometry (704,alt-163,96,48);
 }

void ARGrigliaFat::visFatture(int) { visFatture(); }

void ARGrigliaFat::visFatture()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString fatturaID,clienteID;
 	QString query,tipologia,scontrino,numero,data_bolla;
 	bool primo;
 	int r;

 	populateCli(listaCli->itemData(listaCli->currentIndex()).toString());
 	table->setRowCount(0);
 	r=0; primo=true;
 	query ="SELECT fatture.fatturaID,fatture.clienteID,fatture.tipologia,fatture.data_fattura,fatture.scontrino,fatture.note,fatture.numero,";
  query+="       clienti.nome,clienti.indirizzo,clienti.cap,clienti.citta,clienti.provincia,clienti.nazione ";
  query+="FROM   fatture,clienti";

 	clienteID = listaCli->itemData(listaCli->currentIndex()).toString();
 	numero = quote(this->numero->text(),true);
 	tipologia = quote(this->tipologia->text(),true);
 	scontrino = quote(this->scontrino->text(),true);
 	if(clienteID!="0") { if(primo) { query+=" WHERE fatture.clienteID='"+clienteID+"'"; primo=false; } else { query+=" AND fatture.clienteID='"+clienteID+"'"; } }
 	if(numero!="")     { if(primo) { query+=" WHERE numero='"+numero+"'"; primo=false; } else { query+=" AND numero='"+numero+"'"; } }
 	if(tipologia!="")  { if(primo) { query+=" WHERE tipologia LIKE '%"+tipologia+"%'"; primo=false; } else { query+=" AND tipologia LIKE '%"+tipologia+"%'"; } }
 	if(scontrino!="")  { if(primo) { query+=" WHERE scontrino LIKE '%"+scontrino+"%'"; primo=false; } else { query+=" AND scontrino LIKE '%"+scontrino+"%'"; } }
 	if(primo) { query+=" WHERE fatture.clienteID=clienti.clienteID"; primo=false; } else { query+=" AND fatture.clienteID=clienti.clienteID"; }
 	query+=" ORDER BY fatture.fatturaID DESC";
 	rs=sql->doQueryRS(query);

 	QString a_indr,a_cap,a_citta,a_prov,a_piva,a_cf;
 	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
   	  table->insertRow(r); table->setRowHeight(r,18);

      //a_indr=row[2]; a_cap=row[3]; a_citta=row[4]; a_prov=row[5];
   	  //a_indr=a_indr+"   "+a_cap+" "+a_citta;
   	  //if(a_prov!="") a_indr+=" ("+a_prov+")";

   	  table->setItem(r,0,inserisciRiga(row[0]));
   	  table->setItem(r,1,inserisciRiga(row[6]));
   	  data_bolla=row[3];
   	  QDate aux_date=QDate::fromString(data_bolla,"yyyy-MM-dd");
   	  data_bolla=aux_date.toString("dd-MMM-yyyy");
   	  table->setItem(r,2,inserisciRiga(data_bolla));
   	  table->setItem(r,3,inserisciRiga(row[7])); // Intestatario
   	  table->setItem(r,4,inserisciRiga(row[2])); // Tipologia merce
   	  table->setItem(r,5,inserisciRiga(row[4])); // Scontrino
   	  table->setItem(r,6,inserisciRiga(row[5])); // Note

   	  /*porto=row[5];
   	  if(porto=="1") porto=tr("Franco");
   	  table->setItem(r,6,inserisciRiga(porto));
   	  table->setItem(r,7,inserisciRiga(QString(row[2])+" "+row[3]+" "+row[4]));*/
   	  r++;
     }
    mysql_free_result(rs);
    if(r==0) 
     {
     	if(infobox->isHidden())
     	 {
     	  infobox->setText(tr("Nessuna fattura trovata!"));
 	      infobox->exec();
 	     }
     }
   }
 }

void ARGrigliaFat::delFatture()
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	QString fatturaID;
 	QString aux;

  if(table->currentRow()<0)
   {
    warnbox->setText(tr("Nessuna fattura selezionata."));
 	  warnbox->exec();
 	  return;
   }
  yesnobox->setText(tr("Vuoi veramente cancellare la fattura?"));
  if(yesnobox->exec()==QMessageBox::No) return;

  // Entro nella sezione critica
  sql2->connetti();
  if(!sql2->bloccaPer(sql->getDbName()+".fatture","0")) 
   {
  	warnbox->setText(tr("La sezione fatture  occupata da un'altro utente.\nRiprova pi tardi."));
 	  warnbox->exec();
 	  sql2->disconnetti();
 	  return;
   }
  sql->doQuery("LOCK TABLES fatture WRITE, articoli WRITE");

  fatturaID=table->item(table->currentRow(),0)->text();
  // Si puo' cancellare solo l'ultima fattura inserita
  rs=sql->doQueryRS("SELECT max(fatturaID) AS max FROM fatture");
  if(rs)
   {
    row=mysql_fetch_row(rs);  
    aux=row[0];
    if(aux==fatturaID) // La fattura da cancellare  l'ultima inserita
     {
     	sql->doQuery("UPDATE articoli SET fatturaID = '0', fatturato = '0', data_fat = '0', ora_fat = '0', ts_fat = '0' WHERE fatturaID='"+fatturaID+"'");
     	sql->doQuery("DELETE FROM fatture_elementi_extra WHERE fatturaID='"+fatturaID+"'");
   	  sql->doQuery("DELETE FROM fatture WHERE fatturaID='"+fatturaID+"'");
      infobox->setText(tr("Fattura eliminata ed articoli\nad essa associati ripristinati!"));
      infobox->exec();
      visFatture();
     }
    else
     {
   	  warnbox->setText(tr("Non posso cancellare la fattura\npoich posso cancellare solo l'ultima inserita."));
      warnbox->exec();
     }
    mysql_free_result(rs);
   }
  sql->doQuery("UNLOCK TABLES");
  
 	// Esco dalla sezione critica
 	if(sql2->isConnesso())
 	 {
 	 	if(!sql2->isBloccatoPer(sql2->getDbName()+".fatture")) sql2->doQueryPer("SELECT RELEASE_LOCK('"+sql2->getDbName()+".fatture')");
 	 	sql2->disconnetti();
   }
 }

void ARGrigliaFat::resRicerca()
 {
 	populateCli("0");
 	numero->clear();
 	tipologia->clear();
 	scontrino->clear();
 	visFatture();
 }

bool ARGrigliaFat::populateCli(QString val)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;
 	int r=0,v=0;
 	QString aux;
 	
 	listaCli->clear();
 	listaCli->addItem(tr("TUTTI I CLIENTI"),QVariant(0));
 	rs=sql->doQueryRS("SELECT clienteID,nome FROM clienti ORDER BY nome");
	if(rs)
 	 {
 	  while((row=mysql_fetch_row(rs)))
     {
     	listaCli->addItem(row[1],QVariant(row[0]));
   	  r++;
     	aux=row[0]; if(aux==val) v=r;
     }
    mysql_free_result(rs);
   }
  listaCli->setCurrentIndex(v);
  return r;
 }

void ARGrigliaFat::contextMenuEvent(QContextMenuEvent *event)
 {
  QMenu menu(this);
  menu.addAction(editCMnu);
  menu.addAction(delCMnu);
  menu.exec(event->globalPos());
 }

QTableWidgetItem *ARGrigliaFat::inserisciRiga(QString str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QTableWidgetItem *ARGrigliaFat::inserisciRiga(const char *str)
 {
 	QTableWidgetItem *item;
 	
 	item = new QTableWidgetItem();
 	item->setText(str);
 	return item;
 }

QString ARGrigliaFat::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }
