#ifndef ARGRIGLIASER_H
#define ARGRIGLIASER_H

#include <QWidget>

class QTableWidget;
class QGroupBox;
class QTableWidgetItem;
class QPushButton;
class QLineEdit;
class QLabel;
class QMessageBox;
class QMenu;
class QAction;
class QContextMenuEvent;

class ARFinestra;
class ARsql;

class ARGrigliaSer : public QWidget
 {
  Q_OBJECT

  public:
   QTableWidget *table;
   QPushButton *edit,*del,*search,*reset,*stampa;
   QLineEdit *articolo,*descrizione,*prezzo,*iva,*note;
   QAction *editCMnu,*delCMnu;
   
   ARGrigliaSer(QWidget *parent = 0);
   void settaGeometria(int,int);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);

  public slots:
   void visServizi();
   void delServizi();
   void resRicerca();

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   int num_col;
   ARFinestra *mainWin;
   ARsql *sql;
   QMessageBox *infobox,*warnbox,*yesnobox;
   QGroupBox *cornice;
   QLabel *_articolo,*_descrizione,*_prezzo,*_iva,*_note;

   QString quote(QString, bool like = false);
 };

#endif
