#include <QPushButton>
#include <QGroupBox>
#include <QLabel>
#include <QLineEdit>
#include <QMessageBox>

#include "ARsql.h"
#include "ARFinestra.h"

#include "AROption.h"

AROption::AROption(QWidget *parent) : QWidget(parent)
 {
 	mainWin=(ARFinestra *)parent;
 	sql = new ARsql(this);
 	infobox = new QMessageBox(tr("Informazioni"),"",QMessageBox::Question,0,0,0,this);
 	warnbox = new QMessageBox(tr("Avviso"),"",QMessageBox::Warning,0,0,0,this);
 	cornice = new QGroupBox(tr("Inserisci nuovo cliente "),this);
 	cornice->setGeometry(2,0,650,420);

  _codice = new QLabel(tr("Codice"),this);      _codice->setGeometry(10, 20, 80, 24);
  codice  = new QLineEdit("",this);             codice->setGeometry (80, 20,200, 24);
  _descr  = new QLabel(tr("Descrizione"),this); _descr->setGeometry (10, 50, 80, 24);
  descr   = new QLineEdit("",this);             descr->setGeometry  (80, 50,550, 24);
  _etich  = new QLabel(tr("Etichetta"),this);   _etich->setGeometry (10, 80, 80, 24);
  etich   = new QLineEdit("",this);             etich->setGeometry  (80, 80,200, 24);
  // default...

  codice->setMaxLength(255);
  descr->setMaxLength(255);
  etich->setMaxLength(255);

 	esegui = new QPushButton(QIcon("pic/new.png"),tr("Inserisci"),this);
 	esegui->setGeometry(543,393,106,24);
 	
  connect(esegui,SIGNAL(clicked()),this,SLOT(addOption()));

 	infobox->setWindowModality(Qt::WindowModal);
 	warnbox->setWindowModality(Qt::WindowModal);
  setGeometry(0,61,680,440);
  azione=AROPTION_ADD;  
  hide();
 }

void AROption::addOption()
 {
  QString codice=quote(this->codice->text());
  QString descr=quote(this->descr->text());
  QString etich=quote(this->etich->text());
  QString def="0";//quote(this->etich->text());
  QString ts=sql->timeStamp();
  QString data=sql->data(ts);
  QString ora=sql->ora(ts);

 	if(isAzione(AROPTION_ADD))
 	 {
 	  if(!checkForm())
 	   {
 	   	if(sql->doQuery("INSERT INTO "+tabella+" VALUES('0','"+codice+"','"+descr+"','"+etich+"','"+def+"','"+data+"','"+ora+"','"+ts+"')"))
       {
        infobox->setText(tr("Nuova opzione inserita"));
        infobox->exec();
        clearForm();
 	     }
 	   }
 	 }
 	if(isAzione(AROPTION_EDIT))
 	 {
 	  if(!checkForm())
 	   {
	   	mainWin->sql->connetti();
 	   	mainWin->sql->doQueryPer("LOCK TABLES articoli WRITE, colori WRITE, fondi WRITE, tacchi WRITE, stagioni WRITE");
 	 	  if(mainWin->sql->doQueryPer("UPDATE "+tabella+" SET codice='"+codice+"', descrizione='"+descr+"', etichetta='"+etich+"', deflt='"+def+"' WHERE "+nomeID+"='"+optionID+"'"))
 	 	   {
 	 	   	if(tabella=="colori")   mainWin->sql->doQueryPer("UPDATE articoli SET colore='"+descr+"' WHERE "+nomeID+"='"+optionID+"'");
 	 	   	if(tabella=="fondi")    mainWin->sql->doQueryPer("UPDATE articoli SET fondo='"+descr+"' WHERE "+nomeID+"='"+optionID+"'");
 	 	   	if(tabella=="tacchi")   mainWin->sql->doQueryPer("UPDATE articoli SET tacco='"+descr+"' WHERE "+nomeID+"='"+optionID+"'");
 	 	   	if(tabella=="stagioni") mainWin->sql->doQueryPer("UPDATE articoli SET stagione='"+descr+"' WHERE "+nomeID+"='"+optionID+"'");
 	 	   	mainWin->sql->doQueryPer("UNLOCK TABLES");
        mainWin->sql->disconnetti();
        warnbox->setText(tr("Opzione modificata, salvata ed articoli aggiornati!"));
        warnbox->exec(); 
        if(tabella=="colori") mainWin->visColori();
        if(tabella=="fondi") mainWin->visFondi();
        if(tabella=="tacchi") mainWin->visTacchi();
        if(tabella=="stagioni") mainWin->visStagioni();
       }
      else
       {
       	mainWin->sql->doQueryPer("UNLOCK TABLES");
        mainWin->sql->disconnetti();
       }
     }
 	 }
 }

bool AROption::setForm(QString optionID)
 {
 	MYSQL_RES *rs;
 	MYSQL_ROW row;

  rs=sql->doQueryRS("SELECT * FROM "+tabella+" WHERE "+nomeID+"='"+optionID+"'");
  if(rs)
   {
    if(mysql_num_rows(rs)!=1) { mysql_free_result(rs); return false; }
    row=mysql_fetch_row(rs);
    codice->setFocus();
 	  codice->setText(row[1]);
 	  descr->setText(row[2]);
 	  etich->setText(row[3]);
 	  mysql_free_result(rs);
 	  return true;
 	 }
 	return false;
 }

void AROption::clearForm()
 {
 	codice->setFocus();
 	codice->clear();
 	descr->clear();
 	etich->clear();
 }

bool AROption::checkForm()
 {
 	if(quote(this->descr->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la descrizione"));
 	  warnbox->exec();
 	  return true;
 	 }
/* 	if(quote(this->piva->text())=="" && quote(this->cf->text())=="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del cliente"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->cf->text())!="")
 	 {
 	  warnbox->setText(tr("Devi inserire la partita iva oppure il codice fiscale del cliente\nnon entrambi"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->piva->text())!="" && quote(this->piva->text()).length()!=11)
 	 {
 	  warnbox->setText(tr("Lunghezza partita iva errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->cf->text())!="" && quote(this->cf->text()).length()!=16)
 	 {
 	  warnbox->setText(tr("Lunghezza codice fiscale errata"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->email->text())!="" && !reg_email->exactMatch(quote(this->email->text())))
 	 {
 	  warnbox->setText(tr("Formato email errato"));
 	  warnbox->exec();
 	  return true;
 	 }
 	if(quote(this->note->toPlainText()).length()>1024)
 	 {
 	  warnbox->setText(tr("Campo note troppo lungo,\nmassimo 1000 caratteri."));
 	  warnbox->exec();
 	  return true;
 	 }*/
 	return false;
 }

QString AROption::quote(QString str, bool like)
 {
 	if(like)
 	 {
 	  str.replace('\\',"\\\\\\\\");
 	  str.replace('\'',"\\'");
 	 }
 	else
   {
 	  str.replace('\\',"\\\\");
 	  str.replace('\'',"\\'");
   }
 	return str;
 }

void AROption::setOptionID(QString optID) { optionID=optID; }

void AROption::setTabella(QString tbl) { tabella=tbl; }

void AROption::setNomeID(QString nID) { nomeID=nID; }

void AROption::setAzione(int azio) { azione=azio; }

bool AROption::isAzione(int azio) { if(azione==azio) return true; else return false; }
