#ifndef ARSCARICO_H
#define ARSCARICO_H

#include <QWidget>

class QTableWidget;
class QTableWidgetItem;
class QGroupBox;
class QCheckBox;
class QPushButton;
class QLineEdit;
class QComboBox;
class QLabel;
class QMessageBox;
class QDateEdit;
class QDate;
class QDialog;
class QInputDialog;
class QMenu;
class QAction;
class QContextMenuEvent;

class ARsql;
class ARFinestra;
class ARDialogScarica;
class ARDialogEditAll;
class ARBarraInfo;

class ARScarico : public QWidget
 {
  Q_OBJECT

  public:
   bool dettagli;
   QTableWidget *table;
   QPushButton *scarica,*rendi,*edit,*del,*oggi,*search,*reset;
   QComboBox *listaFor,*listaMostra;
   QAction *edallCMnu,*eticCMnu,*stmagCMnu,*editCMnu,*delCMnu,*selallCMnu;
   ARBarraInfo *infobar;
   QDateEdit *from,*to;
   
   ARScarico(QWidget *parent = 0);
   void settaGeometria(int,int);
   QTableWidgetItem *inserisciRiga(const char *, int alig=Qt::AlignLeft);
   QTableWidgetItem *inserisciRiga(QString, int alig=Qt::AlignLeft);
   bool populateFor(QString);
   int numRowSel(int col=0);
   int currRowSel(int col=0);

  public slots:
   void scaricaMerce(QString artID="",bool fast=false);
   void resoMerce();
   void visMagazzino();
   void visMagazzino(int);
   void resRicerca();
   void delMagazzino();
   void selAllMagazzino();
   void settaOggi();
   void hidePrezzo(bool);
   void hideCampi(int);
   void editAllMagazzino();
   void editAllAggArt();
   void editAllAggDescr();
   void editAllAggPrezzoPub();
   void editAllAggPrezzo();
   void editAllAggIva();
   void editAllAggSconto();
   void editAllAggFornitore();
   void editAllAggTutti();

  protected:
   void contextMenuEvent(QContextMenuEvent *event);

  private:
   int num_col,rows_det,row_pr_pub,rows_cam;
   ARsql *sql,*sql2,*sql3;
   ARFinestra *mainWin;
   QCheckBox *ckdata,*ckcampi;
   QMessageBox *infobox,*warnbox,*yesnobox;
   QGroupBox *cornice;
   QLabel *_bcode,*_for,*_art,*_descr,*_misura,*_prezzo,*_from,*_to,*_mostra,*_totali;
   QLineEdit *bcode,*art,*descr,*misura,*prezzo;
   ARDialogScarica *scaricobox;
   ARDialogEditAll *editallbox;

   QString calcGuadagno();
   QString calcTotArticoli();
   QString calcTotPrezzo();
   QString calcTotPrezzoAcq();
   QString calcTotIVA();
   QString calcTotPrezzoIVA();
   QString quote(QString, bool like = false);
 };

#endif
