#ifndef ARSERVIZIO_H
#define ARSERVIZIO_H

#define ARSERVIZIO_ADD  0
#define ARSERVIZIO_EDIT 1

#include <QWidget>

class QPushButton;
class QGroupBox;
class QLineEdit;
class QTextEdit;
class QLabel;
class QMessageBox;
class QIntValidator;
class QDoubleValidator;

class ARFinestra;
class ARsql;

class ARServizio : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice;
   QPushButton *esegui;
   QLineEdit *articolo,*descrizione,*prezzo,*iva;
   QTextEdit *note;

   ARServizio(QWidget *parent = 0);
   bool setForm(QString);
   void clearForm();
   void setServizioID(QString);
   void setAzione(int);
   bool isAzione(int);

  public slots:
   void addServizio();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   QMessageBox *infobox,*warnbox;
   QString servizioID;
   QLabel *_articolo,*_descrizione,*_prezzo,*_iva;
   QLabel *_note;
   int azione;

   bool checkForm();
   QString quote(QString, bool like = false);   
 };

#endif
