#ifndef ARSTAMPANTE_H
#define ARSTAMPANTE_H

#define ARSTAMPANTE_ETICHETTE        0
#define ARSTAMPANTE_INTESTAZIONI_FOR 1
#define ARSTAMPANTE_TABULATI_FOR     2
#define ARSTAMPANTE_INTESTAZIONI_CLI 3
#define ARSTAMPANTE_TABULATI_CLI     4
#define ARSTAMPANTE_INTESTAZIONI_AZI 5
#define ARSTAMPANTE_TABULATI_AZI     6
// eccetera....

#include <QWidget>

class QTextDocument;
class QMessageBox;
class QPrinter;
class QPushButton;
class QComboBox;
class QDateEdit;
class QLineEdit;
class QPrintDialog;
class QPainter;
class QTableWidget;
class QDate;
class QSpinBox;

class ARFinestra;
class ARScarico;
class ARBarraInfo;
class ARsql;
class ARDialogAnteprima;
class ARDialogStampe;
class ARAzienda;

class ARStampante : public QWidget
 {
  Q_OBJECT

  public:
   QPrinter *stampante;
   QPrintDialog *stampabox;
   ARDialogAnteprima *prebox;
   
   ARStampante(QWidget *parent = 0);
   void stampaFattura(QString);
   void stampaBolla(QString);
   void stampaEtichette(QTableWidget *);
   void stampaMagazzino(QTableWidget *);
   void stampaIntestAzi(QTableWidget *);
   void stampaIntestFor(QTableWidget *);
   void stampaFornitori(QTableWidget *);
   void stampaIntestCli(QTableWidget *);
   void stampaClienti  (QTableWidget *);
   void stampaServizi  (QTableWidget *);   
   
  public slots:
   void settaStampante();
   void settaStampe();
   void vaiPagina();
   void primaPagina();
   void precPagina();
   void succPagina();
   void cambiaRC(int);
  
  private:
   ARsql *sql;
   ARFinestra *mainWin;
   QTableWidget *aux_table;
   QMessageBox *infobox,*warnbox;
   ARDialogStampe *prestampabox;
   QString mdestro,malto,msinistro,mbasso,roriz,rvert,num_r,num_c,barcodeon,bcodesmall;
   uint campi_vis,bcodealt;
   QString titcli,titfor;
   QString BCLUT[108];
   int tipo;

   void stampaRealEtichette(QTableWidget *,bool,int pg=0);
   void stampaRealIntestFor(QTableWidget *,bool,int pg=0);
   void stampaRealIntestCli(QTableWidget *,bool,int pg=0);
   void stampaRealIntestAzi(QTableWidget *,bool,int pg=0);
   void drawBcode(QString,int,int,int,QPainter *);
   void drawBcodeChar(QString,int,int,int,int *,QPainter *);   
   int checkBcode(QString);
   void initBcodeLUT();
   void prendiPref(int);
 };

#endif
