#ifndef ARSTAT_H
#define ARSTAT_H

#include <QWidget>

class QTextDocument;
class QDateTime;
class QDate;
class QTextEdit;
class QPushButton;
class QGroupBox;
class QLineEdit;
class QTextEdit;
class QLabel;
class QTabWidget;
class QMessageBox;
class QImage;
class QScrollArea;
class QPainter;
class QComboBox;

class ARFinestra;
class ARsql;

class ARStat : public QWidget
 {
  Q_OBJECT

  public:
   QGroupBox *cornice,*cornice2;
   QPushButton *stampa1,*stampa2,*stampa3;
   QTextDocument *riep_html;
   QTextEdit *riep;
   QComboBox *listaMostra,*listaMostra2,*listaStep;
   
   ARStat(QWidget *parent = 0);
   void creaRiepilogo();
   void creaTrend();
   QDate prendiDataInizioTrend();
   QDate prendiDataFineTrend();
   int prendiNumDatiTrend(QDate,QDate);
   void prendiDatiTrend(QString *,QString *,QDate,QDate);
   int drawAssiTrend(int,int,int,double,QPainter *,QString labx="",QString laby="");
   void drawIstoTrend(int,int,QString,QString,double,QPainter *,int);

   void creaStatistica();
   int prendiNumDatiStatistica();
   void prendiDatiStatistica(QString *,QString *);
   int drawAssiStatistica(int,int,int,double,QPainter *,QString labx="",QString laby="");
   void drawIstoStatistica(int,int,QString,QString,double,QPainter *,int);

   void settaGeometria(int,int);
   bool setForm(int);

  public slots:
   void cambiaTab(int);
   //void stampaRiep???();
   
  private:
   ARFinestra *mainWin;
   ARsql *sql;
   QLabel *_pic,*_pic2;
   QLabel *_mostra,*_mostra2,*_step;
   QImage *pic,*pic2;
   QScrollArea *area,*area2; 
   QTabWidget *tab;
   QWidget *tpage1,*tpage2,*tpage3;
   QMessageBox *infobox,*warnbox;

   bool checkForm();
   QString quote(QString, bool like = false);
 };

#endif
